pro fa_load_k0_orbit,types,trange=trange

tb = scope_traceback(/structure)
lvl = n_elements(tb)-1
dir = file_dirname(tb[lvl].filename)

printdat,dir

odat = read_asc(dir+'/fa_orbit_time.txt',format={time:0d,orbit:0l},/conv_time)
odat = odat[sort(odat.time)]

printdat,odat

 tr=timerange(trange)
 orbits = interp(odat.orbit,odat.time,tr)
print,time_string(tr)
orbit_range = long(orbits+[-.5,.5])
n_orbits = orbit_range[1]-orbit_range[0]+1
orbits = string(lindgen(n_orbits) + orbit_range[0],format='(i05)')
printdat,orbits


local_dir = '/data/fast/orbit/
remote_dir = 'http://sprg.ssl.berkeley.edu/wind3dp/data/fa/

if not keyword_set(types) then types = ['ees','ies']

for i=0,n_elements(types)-1 do begin
     type = types[i]
     relpath = type+'/'
     prefix = 'fa_k0_'+type+'_'
     ending = '_v03.cdf'
     relpathnames = relpath+prefix+orbits+ending

     files = file_retrieve(relpathnames,local_root=local_dir,remote_root=remote_dir)
     if keyword_set(downloadonly) then continue
     cdf2tplot,file=files,/all,verbose=verbose ,prefix = 'fa_'    ; load data into tplot variables
endfor


end
