

function define_grid,circle=circle

nan= !values.f_nan
np = 100
nt = 50

fp = [findgen(np)/(np-1)  * 360.,nan]
ft = [findgen(nt)/(nt-1)  * 180.,nan]

;lng = [-2,2,45,90,135,180,225,270.,315]
lng = [-2,2,30,60,90,120,150,180,210,240,270,300,330,360]
lat = 90-[-60,-30,0,30,45,60]

lng_p = ((ft*0+1) # lng)(*)
lng_t = (ft  # (lng*0+1))(*)

lat_t = ((fp*0+1) # lat)(*)
lat_p = (fp  # (lat*0+1))(*)

p = [lat_p,lng_p]
t = [lat_t,lng_t]
r = p*0+1

return,[[r],[t],[p]]
end

function convert_mag_to_geo,pos
   geopack_conv_coord,pos[*,0],pos[*,1],pos[*,2],x,y,z,/from_mag,/to_geo
   return,[[x],[y],[z]]
end


function convert_geo_to_gse,pos
;   geopack_conv_coord,pos[*,0],pos[*,1],pos[*,2],x,y,z,/from_geo,/to_gse
   geopack_conv_coord,pos[*,0],pos[*,1],pos[*,2],x2,y2,z2,/from_geo,/to_gei
   geopack_conv_coord,x2,y2,z2,x ,y ,z ,/from_gei,/to_gse
   return,[[x],[y],[z]]
end


function convert_geo_to_gsm,pos
;   geopack_conv_coord,pos[*,0],pos[*,1],pos[*,2],x,y,z,/from_geo,/to_gse
   geopack_conv_coord,pos[*,0],pos[*,1],pos[*,2],x2,y2,z2,/from_geo,/to_gei
   geopack_conv_coord,x2,y2,z2,x ,y ,z ,/from_gei,/to_gsm
   return,[[x],[y],[z]]
end


function convert_gei_to_gse,pos
;   geopack_conv_coord,pos[*,0],pos[*,1],pos[*,2],x,y,z,/from_geo,/to_gse
   geopack_conv_coord,pos[*,0],pos[*,1],pos[*,2],x ,y ,z ,/from_gei,/to_gse
   return,[[x],[y],[z]]
end

function convert_gsm_to_gse,pos
   geopack_conv_coord,pos[*,0],pos[*,1],pos[*,2],x,y,z,/from_gsm,/to_gse
;   geopack_conv_coord,x2,y2,z2,x ,y ,z ,/from_gei,/to_gse
   return,[[x],[y],[z]]
end

function convert_geo_to_mag,pos
   geopack_conv_coord,pos[*,0],pos[*,1],pos[*,2],x,y,z,/from_geo,/to_mag
;   geopack_conv_coord,x2,y2,z2,x ,y ,z ,/from_gei,/to_gse
   return,[[x],[y],[z]]
end

function convert_gse_to_gsm,pos
   geopack_conv_coord,pos[*,0],pos[*,1],pos[*,2],x,y,z,/from_gse,/to_gsm
;   geopack_conv_coord,x2,y2,z2,x ,y ,z ,/from_gei,/to_gsm
   return,[[x],[y],[z]]
end

function convert_polar_to_cart,polar
   geopack_sphcar,polar[*,0],polar[*,1],polar[*,2],x,y,z,/to_rect,/degree
   return,[[x],[y],[z]]
end


function hide,pos
   p = pos
   rho = sqrt(p[*,0]^2+p[*,2]^2)
   w = where(pos[*,1] lt 0  and rho lt 1,nw)
   if nw gt 0 then p[w,*] = !values.f_nan
   return,p
end

;pro hplot,pos,_extra=ex,nohide=nohide,rotmat=rotmat ;,plts=plts,title=title
;   if ~keyword_set(plts) then begin
;     zoom=1
;     xrange=[15,-3] /zoom
;     yrange=[-3,15]
;     zrange=[-5,5]
;     !p.multi = [0,1,2]
;     plot,xrange,yrange,/nodata,xrange=xrange,yrange=yrange,/isotropic,title=title,ytitle='Y'
;     plt1 = get_plot_state()
;     plot,xrange,zrange,/nodata,xrange=xrange,zrange=zrange,/isotropic,title=title,ytitle='Z'
;     plt2 = get_plot_state()
;     plts = [plt1,plt2]
;
;   endif
;   hpos = pos
;   if keyword_set(rotmat) then hpos = rotmat ## hpos
;   if ~keyword_set(nohide) then hpos = hide(hpos)
;
;   restore_plot_state,plts[0]
;   oplot,hpos[*,0],hpos[*,1],_extra=ex
;   restore_plot_state,plts[1]
;   oplot,hpos[*,0],hpos[*,2],_extra=ex
;end


pro hplot,pos,_extra=ex,nohide=nohide,rotmat=rotmat ;,plts=plts,title=title
   hpos = pos

   if keyword_set(rotmat) then hpos = rotmat ## hpos
   if ~keyword_set(nohide) then hpos = hide(hpos)

   oplot,hpos[*,0],hpos[*,2],_extra=ex
end




pro geopack_demo2,parmod=parmod

parmod = 3
scnames = tnames('th?_state_pos_Re_gse',nsc)
if nsc eq 0 then begin
   thm_load_state2
   scnames = tnames('th?_state_pos_Re_gse',nsc)
endif
gmags = thm_gmag_location()

wi,1,/show
wt= .025
nan= !values.f_nan
nan3 = [[nan],[nan],[nan]]
wt1 = 0;.001
;if 1 then begin
xrot = -90.
   rotmat = euler_rot_matrix([1,0,0],set_angle=-90.)
   xrange = [15,-3]
   yrange = [-8,8]
;endif else begin
;   rotmat = euler_rot_matrix([1,0,0],set_angle=-90.)
;   xrange = [15,-3]
;   yrange = [3,-10]
;endelse

zoom = 1   ; .5
;  iopt=4
t0 = systime(1)
t0 = time_double('2007-12-21')
tr = timerange(trange)
t0= tr[0]
grid = define_grid()
grid = convert_polar_to_cart(grid)  ; geopack_sphcar,  c[*,0], c[*,1], c[*,2], xm,ym,zm,/degree,/to_rec
nphis = 4
;phis= dindgen(nphis)/nphis*360.
;thetas =  [ 22,25,30,45,60.]
;wsize=[!d.x_size,!d.y_size]   ;[1200,800]
;d0 = !d
;window,1,xsize=wsize[0],ysize=wsize[1] ;,/pixmap
;dd = !d
plts=0

for tt=tr[0],tr[1],450d do begin
;  wset,dd.window
  plot,[20,-20],[-20,20],/nodata,/isotropic,xrange=xrange/zoom <40,yrange=yrange/zoom,title=time_string(tt)
  ts = time_struct(tt)
  geopack_recalc,ts.year,ts.doy,ts.hour,ts.min,ts.sec   ;,tilt=tilt
  gridr = grid
;  gridr = convert_mag_to_geo(gridr)
  gridr = convert_geo_to_gse(gridr)

  hplot,gridr ,rotmat=rotmat

  for k=0,n_elements(phis)-1 do begin
   for j=0,n_elements(thetas)-1  do begin
   col = j mod 6 +1
    pos = convert_polar_to_cart([[1.],[thetas[j]],[phis[k]]])

    pos = convert_mag_to_geo(pos)
    pos = convert_geo_to_gse(pos)
    pos = convert_gse_to_gsm(pos)

    dir = thetas[j] lt 90 ? 1 : -1
    geopack_trace,pos[*,0],pos[*,1],pos[*,2], dir,parmod,xf,yf,zf,fline=fline,/noboundary,/t89
    fpos = [[xf],[yf],[zf]]
    pos = fpos
    fpos = convert_gsm_to_gse(fpos)
    fline = convert_gsm_to_gse(fline)
;    hplot,fpos,psym=1 , nohide=nohide
    hplot,fline, nohide=nohide, color=col, thick=2, rotmat=rotmat ,plts=plts ;,psym=3

    if 0 then begin
      dir = -dir
      geopack_trace,pos[*,0],pos[*,1],pos[*,2], dir,parmod,xf,yf,zf,fline=fline,/noboundary,/t89
      fpos = [[xf],[yf],[zf]]
      fpos = convert_gsm_to_gse(fpos)
      fline = convert_gsm_to_gse(fline)
;      hplot,fpos,psym=1 , nohide=nohide
      hplot,fline, nohide=nohide, color=col ,rotmat=rotmat,plts=plts
    endif

    wait, wt1
   endfor
  endfor
  for sc =0,nsc-1 do begin
      name = scnames[sc]
      scn = (byte(strmid(name,2,1))-byte('a'))[0]
      pos = transpose(data_cut(name,tt)) ;/6400.
;      pos = convert_gei_to_gse(pos)
      hplot,pos,psym=1  ,rotmat=rotmat,plts=plts
      orbit = tsample(name,tr)
      hplot,orbit  ,rotmat=rotmat,plts=plts
      pos = convert_gse_to_gsm(pos)
      geopack_trace,pos[*,0],pos[*,1],pos[*,2],-1,parmod,xf1,yf1,zf1,fline=fline1,/t89;,/noboundary
      geopack_trace,pos[*,0],pos[*,1],pos[*,2],1,parmod,xf2,yf2,zf2,fline=fline2,/t89 ;,/noboundary
      fpos = [[xf1,xf2],[yf1,yf2],[zf1,zf2]]
      fpos = convert_gsm_to_gse(fpos)
      fline = convert_gsm_to_gse([fline1,nan3,fline2])
      hplot,fpos,psym=1 , nohide=nohide ,rotmat=rotmat,plts=plts
      hplot,fline, nohide=nohide ,rotmat=rotmat,plts=plts ,color = ([1,2,3,4,6])[scn]

  endfor
  if keyword_set(gmags) then begin
      for i=0,n_elements(gmags) -1 do begin
         pos = transpose( gmags[i].vec * 1.01 )
         pos = convert_geo_to_gsm(pos)
         if finite(total(pos)) eq 0 then continue
         geopack_trace,pos[*,0],pos[*,1],pos[*,2],1,parmod,xf1,yf1,zf1,fline=fline1,/t89;,/noboundary
         fpos =[[xf1],[yf1],[zf1]]   ; [[xf1,xf2],[yf1,yf2],[zf1,zf2]]
         fpos = convert_gsm_to_gse(fpos)
         fline = convert_gsm_to_gse(fline1)
         hplot,fpos,psym=1 , nohide=nohide ,rotmat=rotmat,plts=plts
         hplot,fline, nohide=nohide ,rotmat=rotmat,plts=plts ;,color = ([1,2,3,4,6])[scn]
      endfor
  endif
;  image=tvrd(/true);,image
;  wset,d0.window
;  tv,image,/true
  wait, wt
endfor
;wdelete,dd.window
return
end




geopack_demo2,parmod=3
end
