
function ace_swepam_pad_filenames,tr

if n_elements(tr) ne 2 then get_timespan,tr

pathname='/home/davin/dat/ac/swepam/pads/swepam_e_*.txt'

;fnames = cdf_file_names(pathname=pathname,/use_master,trange=trange)
fnames = findfile(pathname)
;print,transpose(fnames)
;if not keyword_set(filename) then begin
;  filename=fnames[0]
;  read,filename,prompt='filename? '
;endif

pos = strpos(/reverse_search,fnames,'/')
fn2 = strmid(fnames,transpose(pos+1))
t1 = replicate(time_struct(0.),n_elements(fnames))
t1.year = fix(strmid(fn2,9,4))
t1.date = fix(strmid(fn2,14,3))
t1.month = 1
t2=t1
t2.year = fix(strmid(fn2,23,4))
t2.date = fix(strmid(fn2,28,3))+1
t1=time_double(t1)
t2=time_double(t2)
s = sort(t1)
fnames = fnames[s]
t1 = t1[s]
t2 = t2[s]
i = where(t2 ge tr[0] and t1 lt tr[1],c)
if c eq 0 then return,''
fn = fnames[i]

print,transpose(fn)

return,fn
end







pro load_ace_pad,data=d  ,time_range=trange ,filename=filename

filenames = ace_swepam_pad_filenames(trange)
format = {time:0.d,df:replicate(0.,20,20)}

for i=0,n_elements(filenames)-1 do $
  dat= keyword_set(dat) ? [dat,read_asc(format=format,filenames[i])] : read_asc(format=format,filenames[i])

energy = [2.5571429,3.6514286,5.1600000,7.3057143, $
10.328571,14.342857,19.957143,27.428571, $
38.371429,52.828571,73.328571,102.00000, $
142.14286,196.57143,272.00000,372.71429, $
519.00000,712.57143,987.14286,1370.0000]

pa = findgen(20) * 9.0 + 4.5

ename = 'acpd_'+strtrim(round(energy),2)+'eV'
dlim = {spec:1,yrange:[0,180],ystyle:1,panel_size:.75}
for e = 0,20-1 do $
  store_data,ename[e],data={x:dat.time,y:transpose(dat.df[*,e]),v:pa},dlim=dlim

ylims = [$
  1.13019e-24,  7.46335e-25,  4.09781e-25,  2.23093e-25 , 1.29536e-25 , 8.68436e-26 , 5.65829e-26,$
  2.77922e-26,  1.03488e-26,  3.27296e-27,  9.25620e-28,  2.67096e-28,  8.18296e-29,  2.43987e-29,$
  6.82405e-30,  1.73582e-30,  3.52716e-31 , 6.53483e-32 , 1.11163e-32 , 2.41798e-33]


for e=0,20-1 do zlim,ename[e],ylims[e]/5,ylims[e]*5,1

npa = 20
pa1 = findgen(npa)*180/npa
pa2 = pa1+180./npa
wght = (cosd(pa1)-cosd(pa2))/2
  mass = 5.6856593e-06
  a = 2./mass^2*1e5

conv = wght # (energy*a*1e15)

flux = transpose(dat.df,[2,0,1])
for i=0,n_elements(dat)-1 do flux[i,*,*] = flux[i,*,*] * conv
flux = total(flux,2)
store_data,'ace_flux',data={x:dat.time,y:flux,v:energy},dlim={zlog:1,ylog:1,spec:1}

;store_data,'ace_mom',data=dat


end

