pro alfven_cor, bstr,nstr, vstr,n1,n2

get_data,vstr,data=v
time = v.x
b = data_cut(bstr,time)
n = data_cut(nstr,time)
if not keyword_set(n1) then n1 = 31
if not keyword_set(n2) then n2 = 21

help,v,b,n1,n2,/str

bmag = sqrt(total(b^2,2))
valfven = 21.8 * bmag / sqrt(n)

vx = double(v.y[*,0])
vy = double(v.y[*,1])
vz = double(v.y[*,2])

bx = b[*,0]
by = b[*,1]
bz = b[*,2]

vas = smooth(valfven,n1,/nan)
vxs = smooth(vx,n1,/nan)
vys = smooth(vy,n1,/nan)
vzs = smooth(vz,n1,/nan)

bxs = smooth(bx,n1,/nan)
bys = smooth(by,n1,/nan)
bzs = smooth(bz,n1,/nan)
bms = smooth(bmag,n1,/nan)

dbx = [[(bx-bxs)/bms],[(vx-vxs)/vas]]
dby = [[(by-bys)/bms],[(vy-vys)/vas]]
dbz = [[(bz-bzs)/bms],[(vz-vzs)/vas]]

;correlate_vect,vx-vxs,bx-bxs,n2,a=ax,b=bx,r=rx,c=cx
;correlate_vect,vy-vys,by-bys,n2,a=ay,b=by,r=ry,c=cy
;correlate_vect,vz-vzs,bz-bzs,n2,a=az,b=bz,r=rz,c=cz

correlate_vect,dbx[*,0],dbx[*,1],n2,a=ax,b=bx,r=rx,c=cx
correlate_vect,dby[*,0],dby[*,1],n2,a=ay,b=by,r=ry,c=cy
correlate_vect,dbz[*,0],dbz[*,1],n2,a=az,b=bz,r=rz,c=cz

store_data,'slope',data={x:time,y:[[bx],[by],[bz]]}
store_data,'yintr',data={x:time,y:[[ax],[ay],[az]]}
store_data,'corrc',data={x:time,y:[[rx],[ry],[rz]]}
store_data,'ccorrc',data={x:time,y:[[cx],[cy],[cz]]}

wx = where(abs(rx) lt .7,nwx)
wy = where(abs(ry) lt .7,nwy)
wz = where(abs(rz) lt .7,nwz)
nan = !values.f_nan
if nwx ne 0 then bx[wx] = nan
if nwy ne 0 then by[wy] = nan
if nwz ne 0 then bz[wz] = nan
store_data,'slope2',data={x:time,y:[[bx],[by],[bz]]}

options,/def,'corrc yintr slope slope2','psym',3
ylim,'slope',-1.5,1.5
ylim,'slope2',-1.5,1.5
ylim,'yintr',-.01,.01
ylim,'corrc',-1.2,1.2


return
end


