pro alfven_corr, bstr,nstr, vstr,n1,n2,rotate=rotate ,tempstr=tstr

get_data,nstr,ptr=n
time = n.x
n = *n.y
b = data_cut(bstr,*time)
v = data_cut(vstr,*time)
if not keyword_set(n1) then n1 = 31
if not keyword_set(n2) then n2 = n1

help,n,v,b,n1,n2,/str

bmag = sqrt(total(b^2,2))
valfven = 21.8 * bmag / sqrt(n)


vas = smooth(valfven,n1,/nan)

vsm = [[smooth(v[*,0],n1,/nan)],[smooth(v[*,1],n1,/nan)],[smooth(v[*,2],n1,/nan)]]
bsm = [[smooth(b[*,0],n1,/nan)],[smooth(b[*,1],n1,/nan)],[smooth(b[*,2],n1,/nan)]]
nsm = smooth(n,n1,/nan)

store_data,'B_sm',data={x:time,y:bsm}
store_data,'V_sm',data={x:time,y:vsm}
store_data,'N_sm',data={x:time,y:nsm}

bms = smooth(bmag,n1,/nan)

threevec = [1.,1.,1.]

db = (b-bsm)/(bms # threevec)
dv = (v-vsm)/(vas # threevec)
dn = (n-nsm)/nsm

if keyword_set(rotate) then begin
  for i = 0l,n_elements(*time)-1 do begin
     rmat = rot_mat(reform(bsm[i,*]))
     db[i,*] = db[i,*] # rmat
     dv[i,*] = dv[i,*] # rmat
  endfor
endif

store_data,'dB',data={x:time,y:db},dlim={yrange:[-.8,.8],ystyle:1}
store_data,'dV',data={x:time,y:dv},dlim={yrange:[-.8,.8],ystyle:1}
store_data,'dN',data={x:time,y:dn},dlim={yrange:[-.8,.8],ystyle:1}

store_data,'Valfven',data={x:time,y:valfven}

store_data,'dBx_B',data={x:time,y:[[db[*,0]],[dv[*,0]]]}
store_data,'dBy_B',data={x:time,y:[[db[*,1]],[dv[*,1]]]}
store_data,'dBz_B',data={x:time,y:[[db[*,2]],[dv[*,2]]]}
options,'dBx_B',ytitle='!19d!xB!dX!n/B  !19d!xV!dX!n/V!dA!n'
options,'dBy_B',ytitle='!19d!xB!dY!n/B  !19d!xV!dY!n/V!dA!n'
options,'dBz_B',ytitle='!19d!xB!dZ!n/B  !19d!xV!dZ!n/V!dA!n'
ylim,'dBx_B dBy_B dBz_B',-1,1,0

correlate_vect,db[*,0],dv[*,0],n2,a=ax,b=bx,r=rx,c=cx
correlate_vect,db[*,1],dv[*,1],n2,a=ay,b=by,r=ry,c=cy
correlate_vect,db[*,2],dv[*,2],n2,a=az,b=bz,r=rz,c=cz


store_data,'slope',data={x:time,y:[[bx],[by],[bz]]}
store_data,'yintr',data={x:time,y:[[ax],[ay],[az]]}
store_data,'corrc',data={x:time,y:[[rx],[ry],[rz]]}
;store_data,'ccorrc',data={x:time,y:[[cx],[cy],[cz]]}

wx = where(abs(rx) lt .7,nwx)
wy = where(abs(ry) lt .7,nwy)
wz = where(abs(rz) lt .7,nwz)
nan = !values.f_nan
if nwx ne 0 then bx[wx] = nan
if nwy ne 0 then by[wy] = nan
if nwz ne 0 then bz[wz] = nan
store_data,'slope2',data={x:time,y:[[bx],[by],[bz]]}

options,/def,'corrc yintr slope slope2','psym',3
ylim,'slope',-1.5,1.5
ylim,'slope2',-1.5,1.5
ylim,'yintr',-.01,.01
ylim,'corrc',-1.1,1.1


correlate_vect,n,dv[*,2],n2,a=a,b=b,r=r
w = where(abs(r) lt .7,nw)
if nw ne 0 then b[w] = !values.f_nan
store_data,'IA_slope',data={x:time,y:b}
store_data,'IA_corrc',data={x:time,y:r}

return
end


