pro alfven_fluc, bstr, nstr ,vstr, n1,n2

get_data,vstr,data=v
time = v.x
b = data_cut(bstr,time)
n = data_cut(nstr,time)
if not keyword_set(n1) then n1 = 31

help,v,b,n,n1,n2,/str

vx = double(v.y[*,0])
vy = double(v.y[*,1])
vz = double(v.y[*,2])

bmag = sqrt(total(b^2,2))

valfven = 21.8 * bmag / sqrt(n)

bx = b(*,0)
by = b(*,1)
bz = b(*,2)

vxs = smooth(vx,n1,/nan)
vys = smooth(vy,n1,/nan)
vzs = smooth(vz,n1,/nan)
vas = smooth(valfven,n1,/nan)

bxs = smooth(bx,n1,/nan)
bys = smooth(by,n1,/nan)
bzs = smooth(bz,n1,/nan)
bms = smooth(bmag,n1,/nan)

dbx = [[(bx-bxs)/bms],[(vx-vxs)/vas]]
dby = [[(by-bys)/bms],[(vy-vys)/vas]]
dbz = [[(bz-bzs)/bms],[(vz-vzs)/vas]]

if keyword_set(n2) then begin
   dbx[*,0] = smooth(dbx[*,0],n2,/nan)
   dbx[*,1] = smooth(dbx[*,1],n2,/nan)
   dby[*,0] = smooth(dby[*,0],n2,/nan)
   dby[*,1] = smooth(dby[*,1],n2,/nan)
   dbz[*,0] = smooth(dbz[*,0],n2,/nan)
   dbz[*,1] = smooth(dbz[*,1],n2,/nan)
endif


store_data,'dBx_B',data={x:time,y:dbx}
store_data,'dBy_B',data={x:time,y:dby}
store_data,'dBz_B',data={x:time,y:dbz}

options,'dBx_B',ytitle='!19d!xB!dX!n/B  !19d!xV!dX!n/V!dA!n'
options,'dBy_B',ytitle='!19d!xB!dY!n/B  !19d!xV!dY!n/V!dA!n'
options,'dBz_B',ytitle='!19d!xB!dZ!n/B  !19d!xV!dZ!n/V!dA!n'

;stop



;correlate_vect,vx-vxs,bx-bxs,n2,a=ax,b=bx,r=rx
;correlate_vect,vy-vys,by-bys,n2,a=ay,b=by,r=ry
;correlate_vect,vz-vzs,bz-bzs,n2,a=az,b=bz,r=rz

;store_data,'slope',data={x:time,y:[[bx],[by],[bz]]}
;store_data,'yintr',data={x:time,y:[[ax],[ay],[az]]}
;store_data,'corrc',data={x:time,y:[[rx],[ry],[rz]]}
;options,/def,'corrc','psym',3

return
end


