pro aplot,dat3d,limits=lim,overplot=over,a_color=a_color

if not keyword_set(a_color) then a_color='pitchangle'
limits =  {a_color:a_color,xtitle:'' $
  ,units:'df',xrange:[0.,180.],xstyle:1,xlog:0,ylog:1}
  
if not keyword_set(lim) then lim =limits
extract_tags,limits,lim

str_element,limits,'bins',bins
str_element,limits,'a_color',a_color
str_element,limits,'units',value=units
dat = conv_units(dat3d,units)
str_element,dat,'vsw',value=vsw
str_element,dat,'magf',value=magf

data  =  dat.data
ddata = dat.ddata

if ndimen(bins) eq 1 then begin
   bad = where(bins eq 0,c)
   if c ne 0 then data[*,bad] = !values.f_nan
endif

if ndimen(bins) eq 2 then begin
   bad = where(bins eq 0,c)
   if c ne 0 then data[bad] = !values.f_nan
endif

data   = transpose(data)
ddata  = transpose(ddata)
str_element,dat,'ddata',value=ddata
if n_elements(ddata) ne 0 then ddata=transpose(ddata)
theta  = transpose(dat.theta)
phi    = transpose(dat.phi)

phi = phi-360.d*floor(phi/360.d)


case  strlowcase(strmid(a_color,0,2)) of
'pi' : begin
         limits.xtitle = 'Pitch Angle'
         ang=pangle(theta,phi,vec=magf)
       end
'su' : begin
         limits.xtitle = 'Sun Angle'
         ang=pangle(theta,phi,vec=vsw)     
       end
'ph' : begin
         limits.xtitle = 'Phi Angle'
         ang=phi
         limits.xrange = [0,360.]     
       end
endcase

if keyword_set(cosine) then begin
   ang = cos(ang*!dtor)
   limits.xtitle = 'cos('+limits.xtitle+')'
   limits.xrange = [-1,1]
endif
extract_tags,blimits,limits,except=['bins']
;blimits=limits
if keyword_set(over) then str_element,/add,blimits,'overplot',1

;help,blimits,ang,data,/st
s = sort(ang(*,0))

mplot,ang(s,*),data(s,*),ddata[s,*],limit=blimits;,ddata

end
