pro asympad, names,norm=norm

if keyword_set(norm) then postfix='_asymn' else postfix='_asym'

if not keyword_set(names) then begin
   s = strtrim(indgen(15),2)
   names = 'elpd-1-'+s+':'+s
endif

if ndimen(names) eq 0 then tnames = str_sep(names,' ') else tnames=names
for i=0,n_elements(tnames)-1 do begin

name = tnames[i]

get_data,name,ptr=p,alim=alim

str_element,alim,'ytitle',ytitle
flux = *p.y
energy = *p.v

flux90 = average(flux[*,3:4],2)
flux0  = flux[*,0]
flux180 = flux[*,7]

if keyword_set(norm) then begin
  asym0 = flux0/flux90
  asym180 = flux180/flux90
  flux90[*]=1
  data = {x:p.x,  y:[[flux90],[asym0],[asym180]] }
  dlim={yrange:[.5,20.],ylog:1,ystyle:1,colors:[4,6,2],ytitle:ytitle}
endif else begin
  data = {x:p.x,  y:[[flux90],[flux0],[flux180]] }
  dlim ={colors:[4,6,2],ytitle:ytitle}
endelse

nrg = roundsig(average(energy,2,/nan))

store_data,name+postfix,data=data ,dlim=dlim

  

endfor

end
