;load_wi_mfi,/polar

pro cloudfit,p,fit=fitnames,res=res,ctime=ctime

magname = (tnames('wi_B wi_B3',/all))[0]
vnames = tnames('pm.VELOCITY PL.MOM.P.VELOCITY wi_3dp_Vp wi_swe_Vp',/all)
velname = vnames[0]
res = 1800.

help,velname,magname

if data_type(p) ne 8 then begin
   dummy = fluxrope(0,param=p)
   fitnames=1
endif

trange = p.pp.trange

if (trange[0] eq trange[1]) or keyword_set(ctime) then begin
  ctime,trange,seconds=res,np=2
  trange=minmax_range(trange)
endif

p.pp.trange=trange
p.pp.midtime = average(trange)
store_data,'cloud_lim',data={x:trange}


; Fit to cloud parameters:
data0 = {time:0.d,mag:fltarr(3),fit:fltarr(3)}
mag = tsample(magname,trange,time=time)
dat_all = replicate(data0,n_elements(time))
dat_all.time = time
dat_all.mag  = transpose(mag)
dat_sm = average_str(dat_all,res,/nan)


dat = transpose(dat_sm.mag)
time = dat_sm.time
p.pp.vsw = tsample(velname,trange,/average)
p.pp.np = n_elements(time)

if keyword_set(fitnames) then begin
  if data_type(fitnames) ne 7 then fitnames='theta phi b0 r0 cad'
  w= where(finite(dat) and finite(time))
  bmax = sqrt(max(total(dat^2,2)))
  p.b0 = abs(p.b0) < 2*bmax
  p.r0 = -.4  > p.r0 < .4
  p.cad = -.9*abs(p.r0) > p.cad < .9*abs(p.r0) 
  p.t0 =  -3600.*8 > p.t0 < 3600.*8
  fit,time[w],dat[w,*],func='fluxrope',par=p,names=fitnames
;  printdat,p
  if p.b0 lt 0 then begin
     p.theta = p.theta+180
     p.b0 = -p.b0
  endif    
  p.theta = (p.theta/360 - floor(p.theta/360)) *360
  if p.theta ge 270 then p.theta=p.theta-360
  if p.theta gt 90 then begin 
    p.theta = 180-p.theta
    p.phi = p.phi-180
  endif
  p.phi = (p.phi/360 - floor(p.phi/360)) *360
  
;print,time_string(p.t0 + p.pp.midtime)
;timebar,p.pp.midtime + p.t0
endif

;col = get_colors()

fit = fluxrope(time,par=p,length=length)
dat_sm.fit = transpose( fit )
xyz_to_polar,dat_sm,tag='fit',/ph_0_360
xyz_to_polar,dat_sm,tag='mag',/ph_0_360
add_str_element,dat_sm,'length',length  * 1.2
store_data,'cloud',data=dat_sm
options,'cloud.FIT*',colors='r',/def


if n_elements(tnames('Bmag Bth Bph')) ne 3 then begin
 store_data,'Bth',data=['cloud.FIT_TH',magname+'_th']
 store_data,'Bph',data=['cloud.FIT_PHI',magname+'_phi']
 store_data,'Bmag',data=['cloud.FIT_MAG',magname+'_mag']
 options,'Bph',ytitle='!19F!X!DB!U'
 options,'Bth',ytitle='!19Q!X!DB!U'
 options,'Bmag',ytitle='|B|'
endif
;options,iton('cloud.FIT'),'psym_lim',2

printdat,p

;tplot,'Bmag Bth Bph length'
end

