
function getnode,l,r
nd = ptr_new(*l)
(*nd).c = 0
(*nd).left = l
(*nd).right = r
(*nd).freq = (*l).freq + (*r).freq
(*nd).s = (*l).s + (*r).s
(*l).up = nd
(*r).up = nd
return,nd
end


pro printtree,np,array,level=level,string=string,prt=prt
if not keyword_set(level) then level = 0
if level eq 0 then array=0
if not keyword_set(string) then string = ''
n = *np
;print,string,format='(a,$)'
if ptr_valid(n.left)  then printtree, n.left  ,array, level=level+1,string= string+'0'  
if ptr_valid(n.right) then printtree, n.right ,array, level=level+1, string= string+'1' 
if ptr_valid(n.left) eq 0 and ptr_valid(n.right) eq 0 then begin 
   n.level = level
   n.s = string
   if keyword_set(prt) then   print,n.c,n.freq,n.level,'  ',n.s
   if keyword_set(array) then array = [array,n] else array=[n]
endif
end




function huffmantree,h,val,table=table
nullp = ptr_new()
node = {c:0, freq:0d, level:0, s:'',  left:nullp, right:nullp, up:nullp}
nh = n_elements(h)

if n_elements(val) ne nh then val=indgen(nh)
table=replicate(nullp,nh)
n= node
for i=0,nh-1 do begin
   n.c =val[i]
   n.freq = h[i]
   n.s = string(i)
   table[i] = ptr_new(n)
endfor

ind = indgen(nh)
for i=0,nh-2 do begin
;print,i
  nt = n_elements(ind)
  f = dblarr(nt)
;  help,nt
  for j=0,nt-1 do f[j] = (*table[ind[j]]).freq
  s = sort(f)
  n = getnode( table[ind[s[0]]], table[ind[s[1]]] )
  table = [table,n]
  if nt gt 2 then ind = [nh+i,ind[s[2:*]]]
 
endfor
return,n
end




function huffman_comp,dc,tree,cmpdat=cmpdat,bitflip=bitflip,seed=seed

if not keyword_set(tree) then tree = huffmantree(histogram(dc))
printtree,tree,array
array = array(sort(array.c))
h = histogram(dc)
;help,h,array
size = round(total(h * array.level,/double))
size = ((size+7)/8)*8
cmpdat = bytarr(size)
bitcodes = ''
for i = 0,n_elements(array)-1 do bitcodes=bitcodes+array[i].s
bitcodes = byte(bitcodes) eq (byte('1'))[0]
len = array.level
pos0 = shift(round(total(/cum,len)),1)
pos0[0] = 0
pos1 = pos0 + len -1

j = 0l
for i=0l,n_elements(dc)-1 do begin
   cmpdat[j : j+len[ dc[i] ] -1 ] = bitcodes[ pos0[ dc[i] ] : pos1[ dc[i] ] ]
   j = j + len[ dc[i] ] 
endfor

if keyword_set(bitflip) then begin
    r = long(randomu(seed) *size)
    cmpdat[r]= cmpdat[r] eq 0
    print,'Bit ',r,' of ',size,' changed to ',cmpdat[r]
endif



cmpdat = reform(cmpdat,8,size/8)
cmp = bytarr(size/8)
for i=0,7 do cmp=  ishft(cmp,1)  + cmpdat[i,*]
return,cmp
end



function huffman_decom,cmp,tree

nd =tree
data = bytarr(n_elements(cmp)*3)
n = 0l
for i=0l,n_elements(cmp)-1 do begin
  byt = cmp[i]
   for j=0,8-1 do begin
      bit = (byt and 128) ne 0
 ;     print, bit, format='(i1,$)'
      nd  = bit ? (*nd).right : (*nd).left
      if  ptr_valid((*nd).left) eq 0 then begin
 ;        print, '  -->  ', (*nd).c 
         data[n] = (*nd).c
         n = n+1
        nd = tree
      endif
      byt = ishft(byt,1)
   endfor
endfor
data = data[0:n-1]
return,data
end



