pro cont_ph,ph,pl,lim=clim,moment=mom




lim = {xrange:[2500.,-2500],xlog:0,xstyle:1, $
          yrange:[2500.,-2500],ylog:0,ystyle:1, $
          levels:reverse(-8-findgen(11)/2), $
          title:'', $
          units:'df', $
          psym:3, $
          th_range:[-30.,30.], aspect:1 }
          
if not keyword_set(clim) then clim=lim else  extract_tags,lim,clim

title = ph.project_name+'  '+ph.data_name
title = title+'!C'+trange_str(ph.time,ph.end_time)
if not keyword_set(lim.title) then lim.title=title

phf = conv_units(ph,lim.units)

phdata=phf.data[*]
phenergy = phf.energy[*]
phtheta = phf.theta[*]
phphi = phf.phi[*]
phbins = ph.bins[*]
mass = ph.mass

if keyword_set(pl) then begin
  plf = conv_units(pl,lim.units)
  pldata=plf.data[*]
  plenergy = plf.energy[*]
  pltheta = plf.theta[*]
  plphi = plf.phi[*]
  plbins = plf.bins[*]
  
  pr = minmax_range(plphi)
  er = minmax_range(plenergy)
  wphoverlap = (phphi lt pr[1]) and (phphi ge pr[0]) and (phenergy lt er[1])
  phbins = phbins and (wphoverlap eq 0)
  
  data=[phdata,pldata]
  energy=[phenergy,plenergy]
  theta=[phtheta,pltheta]
  phi = [phphi,plphi]
  bins = [phbins,plbins]
endif else begin
  energy = phenergy
  theta=phtheta
  phi=phphi
  bins=phbins
  data=phdata
endelse





;data = alog10(data)
vel = velocity(energy,mass)

deltav = [0.,0.,0.]

c = cos(!dpi/180.*theta)
sx = c * cos(!dpi/180.*phi)
sy = c * sin(!dpi/180.*phi)
sz = sin(!dpi/180.*theta)


sx = cos(!dpi/180.*phi)
sy = sin(!dpi/180.*phi)

vx = (vel*sx) - deltav(0)
vy = (vel*sy) - deltav(1)
vz = (vel*sz) - deltav(2)



bins = bins and (theta lt lim.th_range[1]) and (theta gt lim.th_range[0]) and finite(data)
wb = where(bins)

data=data[wb]
energy=energy[wb]
phi=phi[wb]
vx = vx[wb]
vy = vy[wb]

if keyword_set(1) then begin
;total over theta range
h=hist2d(alog(energy),phi,xbins=128,ybins=128,reverse=ri)
fhist_average,vx,h,ri,mean=mean_vx
fhist_average,vy,h,ri,mean=mean_vy
fhist_average,data,h,ri,mean=mean_data,weight=weight
mean_data=mean_data*h  ; total, not average
;w = where(finite(mean_vx) and finite(mean_vy) and finite(mean_data))
w = where(h ne 0)
data = mean_data[w]
vx = mean_vx[w]
vy = mean_vy[w]
vmin = min(sqrt(vx^2 + vy^2))*.8
p = findgen(32)/32*2*!pi
vx_inner = vmin * sin(p)
vy_inner = vmin * cos(p)
df_inner = 1e-13+P*0

;vx=[vx_inner,vx]
;vy=[vy_inner,vy]
;data=[df_inner,data]
;w = where((vx^2 + vy^2) lt 1000)
;data[w] = 1e-20
;stop
endif


options,lim,'aspect',1
box,lim


if keyword_set(0) then begin
   dfp = distfunc(vx,vy,df=data)
   vxn = dgen(100,/x) # replicate(1.,100)
   vyn = replicate(1.,100) # dgen(100,/y)
   dfn = distfunc(vxn,vyn,param=dfp)
   
   stop

endif 

 data = alog10(data)
 df_inner = alog(df_inner)



;spec3d,phf,bins=bins,units='df'


contour,[df_inner,data],[vx_inner,vx],[vy_inner,vy],/irre,levels=lim.levels,/over,/fill
contour,[df_inner,data],[vx_inner,vx],[vy_inner,vy],/irre,levels=lim.levels,/over
oplot,vx,vy,ps=lim.psym

if keyword_set(mom) then begin
bf = mom.magf
density = mom.density
vsw = mom.velocity
bmag = sqrt(total(bf^2))
if keyword_set(density) then begin
   valf = 21.8 * bmag / sqrt(density)
   bfnorm=bf/bmag * valf
   printdat,bf/bmag,'bdir'
   printdat,valf,'Valf'
   oplot,[vsw[0],bfnorm[0]+vsw[0]],[vsw[1],bfnorm[1]+vsw[1]],thick=3,color=6
endif else begin
   bf=bf/bmag
   bfnorm = bf*max(lim.xrange)
   print,bfnorm
   oplot,[0,bfnorm[0]],[0,bfnorm[1]]
endelse
oplot,[0,vsw[0]],[0,vsw[1]],thick=3,color=2
;vxy = vsw[[0,1]]
;bxy = bf[[0,1]]/bmag
p0 = vsw+2000*bf/bmag
p1 = vsw-2000*bf/bmag
oplot,[p0[0],p1[0]],[p0[1],p1[1]]
endif

;plots,vx[wb],vy[wb],colo=bytescale(data[wb],range=[-13,-8]),ps=3

end
