pro contpad,data,lim=lim,_extra=ex,units=units

if not keyword_set(units) then units='df'

cpd = 2

dat=conv_units(data,units)

vel = velocity(dat.energy,dat.mass)
sphere_to_cart,vel,  dat.theta,  dat.phi,sx,sy,sz

rot = rot_mat(dat.magf)
dim =dimen(sx)
vecs = [[sx[*]],[sy[*]],[sz[*]]]

vecsp = rot ## vecs

;cart_to_sphere,vecsp[*,0],vecsp[*,1],vecsp[*,2],r,theta,phi,/co_lat
;theta = reform(theta,dim,/overwrite)
;phi   = reform(phi  ,dim,/overwrite)


f= alog(dat.data)/alog(10)
frange = round(minmax_range(f))
levels = dgen(range=frange,res=1./cpd)
c_labels = abs(levels - round(levels)) lt .01

x = vecsp[*,2]
y = sqrt(vecsp[*,0]^2 +vecsp[*,1]^2)

w=where(vecsp[*,0] lt 0,count)
if count ne 0 then y[w]=-y[w]


w = where(dat.bins)
f= f[w]
x= x[w]
y =y[w]

contour,f,x,y,_extra=ex,levels=levels,/irreg,/fill 
  
contour,f,x,y,_extra=ex,levels=levels,/irreg,c_labels=c_labels,/over

oplot,/ps,x,y
end

