pro crosscor_data,tname1,tname2,dimen1=dimenn1,dimen2=dimenn2 $
   ,wave1=wave1,wave2=wave2,time=t1,period=period,j=j $
   ,trange=trange,pdens=pdens
get_data,tname1,ptr=d
t1=*d.x
y1=*d.y
name1=tname1
if dimen2(y1) gt 1 then begin
   if n_elements(dimenn1) eq 0 then message,"Need dimen!"
   y1 = y1[*,dimenn1]
   name1 = name1+'('+strtrim(dimenn1,2)+')'
endif
n1 = n_elements(y1)
dt = (t1[n1-1]-t1[0])/(n1-1)
w = where(finite(y1) eq 0,nw)
if nw ne 0 then y1[w] = average(y1,/nan)
wave1 = wavelet(y1,dt,j=j,/pad,period=period,scale=scale,coi=coi,signif=signif,/verb)
powname = 'pow('+name1+')'

if keyword_set(tname2) then begin
  get_data,tname2,ptr=d
  t2=*d.x
  y2=*d.y
  name2=tname2
  if dimen2(y2) gt 1 then begin
     if n_elements(dimenn2) eq 0 then message,"Need dimen!"
     y2 = y2[*,dimenn2]
     name2 = name2+'('+strtrim(dimenn2,2)+')'
  endif
  if n_elements(trange) eq 2 then begin
     w = where((t1 le trange[1]) and (t1 ge trange[0]),nw)
     if nw eq 0 then begin
        message,/info,'No data in time range'
        return
     endif
     t1=t1[w]
     y1=y1[w]
     w = where((t2 le trange[1]) and (t2 ge trange[0]),nw)
     if nw eq 0 then begin
        message,/info,'No data in time range'
        return
     endif
     t2=t2[w]
     y2=y2[w]
  endif
n2 = n_elements(y2)
;stop
  if (total(t1 ne t2) ne 0) or (n1 ne n2) then message,'Variables must have the same time series!'
  w = where(finite(y2) eq 0,nw)
  if nw ne 0 then y2[w] = average(y2,/nan)
  wave2 = wavelet(y2,dt,j=j,/pad,period=period,scale=scale,coi=coi,signif=signif,/verb)
  powname = 'pow('+name1+','+name2+')'
  polname = 'pol('+name1+','+name2+')'
endif else wave2=0

printdat,period,'period'
printdat,scale,'scale'
yrange = minmax(period)

omega = 2*!pi/period

power = abs(wave1)^2 + abs(wave2)^2
if keyword_set(pdens) then power = power*(replicate(1.,n1) # omega)
opts = {spec:1,yrange:yrange,ylog:1,zlog:1,ystyle:1,panel_size:1.5}
store_data,powname,data={x:t1,y:power,v:period},dlim=opts
if keyword_set(polname) then begin
  polar = imaginary(wave1*conj(wave2))
  if keyword_set(pdens) then polar = polar*(replicate(1.,n1) # omega)
  store_data,polname,data={x:t1,y:polar,v:period},dlim=opts
endif
end




;phase = imaginary(alog(wave1/wave2))
;store_data,name1+'@'+name2,data={x:t1,y:phase/!pi,v:period},dlim={zrange:[-1,1],ylog:0,psym:3}
;ratio = abs(wave1/wave2)
;store_data,name1+'/'+name2,data={x:t1,y:ratio,v:period},dlim={zrange:[.5,2],ylog:1,psym:3}


