function  dig_func,p,parameters=par, p_names=p_names, pder_values=pder_values
x = p.i * par.a0 + p.j * par.a1 + par.d

if keyword_set(p_names) then begin
   np = n_elements(p_names)
   nd = n_elements(p.i)
   pder_values = dblarr(nd,np)
   for i=0,np-1 do begin
      case strupcase(p_names(i)) of
          'A0': pder_values(*,i) = p.i
          'A1': pder_values(*,i) = p.j
          'D': pder_values(*,i) = 1
      endcase
   endfor
endif

return,x
end

;+
;PROCEDURE: digitize
;USAGE:
;   digitize,x,y,metric=metric,filename=filename 
;
;-



pro digitize,x,y,filename=filename,metric=metric,image=image, $
   xlog=xlog,ylog=ylog,nearest=nearest


if data_type(metric) eq 8 then begin
   filename = metric.filename
endif

if not keyword_set(filename) then begin
  filename = ''
  read,filename,prompt='Enter Filename: '
endif

read_gif,filename,image,r,g,b

dim = dimen(image)
window,xsize=dim[0],ysize=dim[1]
tv,image

if data_type(metric) ne 8 then begin
read,x1,y1,prompt='Enter point 1 (x y): 
read,x2,y2,prompt='Enter point 2 (x y): 
read,x3,y3,prompt='Enter point 3 (x y): 
read,x4,y4,prompt='Enter point 4 (x y): 

print,'click on the 4 points in the same order'
crosshairs,px,py,/device,/nolegend

pf = {i:0, j:0}

pfs = replicate(pf,n_elements(px))
pfs.i = px
pfs.j = py


par = {a0:0.d  ,a1:0.d , d:0.d , log:0}

x=[x1,x2,x3,x4]
xpar = par
xpar.log = keyword_set(xlog)

y =[y1,y2,y3,y4]
ypar = par
ypar.log  = keyword_set(ylog)

if keyword_set(xpar.log) then x = alog10(x)
if keyword_set(ypar.log) then y = alog10(y)

fit,pfs,x,par=xpar,funct='dig_func' ; ,/silent
fit,pfs,y,par=ypar,funct='dig_func' ; ,/silent

metric = {xpar:xpar, ypar:ypar, filename:filename}

endif

if keyword_set(nearest) then begin
w = where(image eq nearest,wc)
pxv = (lindgen(dim[0]) # replicate(1.,dim[1]))[w]
pyv = (replicate(1.,dim[0]) # lindgen(dim[1]))[w]
endif



psym =1
!ERR = 0
x = 0
y = 0
n = 0
while !ERR ne 4 do begin
   cursor,px,py,/down,device=1
   if keyword_set(nearest) then begin
      d = min((pxv-px)^2 + (pyv-py)^2,bin)
      px = round(pxv[bin])
      py = round(pyv[bin])
   endif
   if !err eq 1 then begin
       x0 = dig_func({i:px,j:py},par=metric.xpar)
       y0 = dig_func({i:px,j:py},par=metric.ypar)
       if xpar.log ne 0 then x0 = 10.d^x0
       if ypar.log ne 0 then y0 = 10.d^y0
       append_array,x,x0
       append_array,y,y0
       plots,px,py,psym = psym,continue=n,device=1
       if keyword_set(cont) then n = n+1
       print,px,py, (reverse(x))[0], (reverse(y))[0]
   endif

endwhile


end
