pro elpd_str_to_tplot,d,do_fit=do_fit,no_reduce=no_reduce,position=position, $
  no_pad=no_pad,pad_energy=pad_energy



if not keyword_set(no_pad) or keyword_set(pad_energy) then $
  store_data,'elpd',data={x:d.time,y:transpose(d.flux,[2,0,1]),v1:transpose(d.energy),v2:transpose(d.pangle)}
if keyword_set(pad_energy) then $
   reduce_pads,'elpd',pad_energy
store_data,'MAGF',data={x:d.time,y:transpose(d.magf)}

wbad = where(d.flags ne 0,nbad)

str_element,d,'fit',fit
do_fit = keyword_set(fit)

if keyword_set(fit) then begin
  if nbad gt 0 then fit[wbad] = fill_nan(fit[0])
  str_element,/add,fit,'time',d.time
  str_element,/add,fit,'core.trat',1/(fit.core.tdif+1)
  store_data,'elf',data=fit
  ylim,'elf.CORE.TDIF',-.4,.4,/defa
  ylim,'elf.CORE.T',.1,50,1,/def  
  ylim,'elf.CORE.TRAT',.5,4,1,/def  
endif
str_element,d,'fitres',fitres   ;  fitres = d.fitres
if keyword_set(fitres) then begin
  store_data,'fitres_nits',data={x:d.time,y:d.fitres.nits},dlim={yrange:[0,25]}
  store_data,'fitres_x2',data={x:d.time,y:transpose(d.fitres.x2),v:transpose(d.omni_nrg)},$
     dlim={spec:1,ylog:1,ystyle:1,yrange:[4.,1500.],no_interp:1,zrange:[1,20.],zlog:1,zstyle:1}
  store_data,'fitres_chi2',data={x:d.time,y:d.fitres.chi2}
  ylim,/def,'fitres_chi2',.5,200,1
  store_data,'fitres_vflags',data={x:d.time,y:d.fitres.vflags},dlim={tplot_routine:'bitplot',yrange:[0,15]}
  store_data,'fitres_erange',data={x:d.time,y:transpose(d.fitres.erange)},dlim={colors:'ww'}
  store_data,'fitres_x2_erange',data='fitres_x2 fitres_erange',dlim={ylog:1,ystyle:1,yrange:[2.,1500.],no_interp:1}
;  str_element,/add,fitres,'time',d.time
;  store_data,'elfr',data=fitres
;  options,'elfr.VFLAGS',tplot_routine='bitplot'
endif

mom = d.mom
if nbad gt 0 then mom[wbad] = fill_nan(mom[0])
store_data,'elm',data=mom

store_data,'sc_pot_el',data={x:d.time,y:d.sc_pot_el}
store_data,'sc_pot_nsw',data={x:d.time,y:d.sc_pot_nsw}

store_data,'NSW',data={x:d.time,y:d.NSW}
store_data,'VSW',data={x:d.time,y:transpose(d.VSW)}
store_data,'TSW',data={x:d.time,y:d.TSW}

ylim,'elm.VELOCITY',-800,200,/default
ylim,'elm.MAGT3',3,40,1,/default
ylim,'elm.EXCESS',.5,10,1,/default
ylim,'elm.SC_POT',0,25,/default
ylim,'elm.QVEC',-1.0e5,1.0e5,/default
ylim,'elm.SKEWNESS',-1.5,1.5,/default
ylim,'elm.AVGTEMP',.1,200,1,/default
ylim,'elm.DENSITY',.1,200,1,/default
ylim,'elm.TRAT',.7,4,1
ylim,'TSW',.1,200,1
ylim,'NSW',.1,200,1

options,'elm.DENSITY',ytitle='Ne',colors='r',/default,binsize=.05
options,'elm.VELOCITY',ytitle='Ve',/default,binsize=10
options,'elm.MAGT3',ytitle='T3',/default
options,'elm.TRAT',ytitle='Trat',colors='r',/default
options,'elm.SKEWNESS',ytitle='Qnorm',colors='r',/default
options,'elm.QVEC',ytitle='Qe',/default
options,'elm.AVGTEMP',colors='r',/default,ytitle='Te (eV)'
options,'elm.EXCESS',ytitle='Re',colors='r',/default
options,'elm.ERANGE',linestyle=1,colors='bg',/default
options,'NSW',ytitle='Proton Density (1/cc)' 

options,'elm.QVEC elm.SKEWNESS',constant=0.

if keyword_set(position) then begin
  store_data,'wi_pos',data={x:d.time,y:transpose(d.pos)}
endif

if not keyword_set(no_reduce) and not keyword_set(no_pad) then begin
 pdname ='elpd'
 nenergy = n_elements(d[0].energy)
 num_pa = n_elements(d[0].pangle) 
 for i = 0, nenergy-1 do  reduce_pads,pdname,1,i,i
 reduce_pads,pdname,2,num_pa-2,num_pa-1
 reduce_pads,pdname,2, round((num_pa-1)/2.-.9),round((num_pa-1)/2.+.9)
 reduce_pads,pdname,2,0,1
 ylim,tnames(pdname+'-2-*'),10,1e8,1,/def
 normpad
 elpd_lim
endif



end
