pro fft_avg,t,y,window=wind $
   ,color=col,lim=lim,overplot=overplot $
   ,npoints=np,average=na,power=fy,freq=fx

if not keyword_set(na) then na=1

c= n_elements(t)

np = c/na

c = np*na

if not keyword_set(wind) then w=hanning(np) else w = interp(wind,np)

y2 = reform(y(0:c-1),np,na)
t2 = reform(t(0:c-1),np,na)
fy = fltarr(np,na)
fx = fltarr(np,na)
;stop

for i=0,na-1 do begin
   yi = y2(*,i)
   ti = t2(*,i)
   fy(*,i) = abs(fft(yi*w))^2
   delt = ti -shift(ti,1)
   deltr = minmax_range(delt[1:*])
   delta = average(delt[1:*])
   if (deltr[1] gt delta*1.1) then begin
     print,"Time gap too large (",deltr[1],") in segment ",i
     fy(*,i)=!values.f_nan
   endif
   if (deltr[1] lt delta/1.1) then begin
     print,"Time gap too small (",deltr[1],") in segment ",i
     fy(*,i)=!values.f_nan
   endif
   dt = ti(np-1)-ti(0)
   fx(*,i) = findgen(np)/dt
endfor

fy = average(fy,2,/nan) * np
fx = average(fx,2,/nan)
fy = fy(0:np/2)
fx = fx(0:np/2)

if keyword_set(lim) then begin
   if not keyword_set(overplot) then box,lim,fx,fy
   extract_tags,oplotstuff,lim,/oplot
   str_element,/add,oplotstuff,'color',col
;help,oplotstuff,/st
   oplot,fx,fy,_extra = oplotstuff
endif

overplot=1

end
