pro fft_spec,vname,nsamp=nsamp,window=wind

if not keyword_set(nsamp) then nsamp=256
nsamp = fix(nsamp)

if not keyword_set(wind) then wind = [1.,1.]

w = interp(wind,nsamp)

if n_elements(vname) ne 1 then begin
  ctime,vname=vname,prom='Click on panel',np=1
  vname=vname(0)
endif

get_data,vname,time,value

if ndimen(value) ne 1 then message,'Sorry, one dimensional arrays only!'

n = n_elements(time)

nfft = n/nsamp
spec = fltarr(nfft,nsamp/2+1)
freq = fltarr(nfft,nsamp/2+1)
t    = dblarr(nfft)

help,spec,freq

for i=0l,nfft-1 do begin
  i0= i*nsamp
  i1= (i+1)*nsamp-1
  spec(i,*) = (abs(fft(value(i0:i1)*w)))(0:nsamp/2)
  freq(i,*) = findgen(nsamp/2+1)/(time(i1)-time(i0))
  t(i) = (time(i0)+time(i1))/2
endfor

spec(*,0) = spec(*,1)

store_data,vname+'_fft',data={x:t,y:spec,v:freq}, $
   dlim={ystyle:1,spec:1}

end
