pro get_plasma_param,b_name=b_name,n_name=n_name,v_name=v_name $
   ,tp_name=tp_name,te_name=te_name


get_data,n_name,data=n
b=data_cut(b_name,n.x)
bmag = sqrt(total(b^2,2))

f_ion_gyro = 28./1836 * bmag
f_ele_gyro = 28.0 * bmag

valfven = 21.8 * bmag / sqrt(n.y)
store_data,'C_alf',data={x:n.x,y:valfven},dlim={maxvalue:1000.}

if keyword_set(te_name) then begin
   Te = data_cut(te_name,n.x)
   if ndimen(Te) eq 2 then Te = total(te,2)/3
endif else te=!values.f_nan*n.y

if keyword_set(tp_name) then begin
   tp = data_cut(tp_name,n.x)
   if ndimen(Tp) eq 2 then Tp = total(tp,2)/3
endif else tp=!values.f_nan*n.y

cs = 9.79 * sqrt(Te+1.67*Tp)
cms = sqrt(cs^2+valfven^2)

store_data,'C_s',data={x:n.x,y:cs},dlim={maxvalue:1000.}
store_data,'C_fms',data={x:n.x,y:cms},dlim={maxvalue:1000.}

if keyword_set(v_name) then begin
   vp = data_cut(v_name,n.x)
   if ndimen(Tp) eq 2 then vp = sqrt(total(vp^2,2)) else vp=abs(vp)
   store_data,'M_fms',data={x:n.x,y:vp/cms},dlim={maxvalue:100.}
   ylim,'M_fms',.5,20,1
endif

epress = (Te)*n.y
ipress = (Tp)*n.y
press = (Te+Tp)*n.y
bpress = bmag^2/4.03e-1

beta = press/bpress
betai = ipress/bpress
betae = epress/bpress

store_data,'Beta',data={x:n.x,y:beta}
store_data,'Beta_i',data={x:n.x,y:betai}
store_data,'Beta_e',data={x:n.x,y:betae}
ylim,'Beta',.005,5,1


return
end
