function  ion_eflux,energy_q,theta,phi,params=par,true_nrg=true_nrg,ionsteps=ionsteps,flux_units=flux_units

if not keyword_set(par) then begin
s = {name:'',an:0,q:0,m:0.,n:0.,v:0.,t:0.,tr:1.,c:0,tp:0};,E_q:0.,E0:0.,E1:0.,Er:0.}
nam=['H','3He','He','C','N','O','Ne','Mg','Si', 'Fe']
typ=[ 1 ,  2  ,  3 , 4 , 5 , 6 ,  7 ,  8 ,  9,   10]
an =[ 1 ,  2  ,  2 , 6 , 7 , 8 , 10 , 12 , 14 ,  26]
col=[ 2 ,  1  ,  1 , 3 , 4 , 6 ,  5 ,  1 , 3  ,  4 ]

;ach=[ 1.,  2. ,  2 , 4 ,  4, 4 ,  5,   4,  5 ,  6]
;dch=[ 1., .5  , .5 , 1 , 1 , 1 ,  1,   1,  1.5,  1.5]

ach=[ 1.,  2. ,  2 , 5 ,5.5, 6 ,  7,   8,  9 ,  10]
dch=[ 1., .3  , .3 , 1 , 1 , 1 ,  1,   1,  1.,  1.]
;dch=dch/3

solab=[1.,.063/1000,.063,3e-4,2e-4,6e-4,1.3e-4,8e-5,3e-5,8e-6]

;den=[10., .01  , .5 ,.04,.02,.06,.005,.002,.002,  .05]
den= 10. * solab
mas=[ 1.,  3. ,  4.,12.,14.,16., 20.2,24.3,28.1, 55.85]
ions=0
for i=0,n_elements(nam)-1 do begin
  n = an[i]
  s1 = replicate(s,n)
  s1.an = n
  s1.q = indgen(n)+1
  s1.name = nam[i]+strcompress(s1.q,/rem);+'+'
  s1.m = mas[i]
  s1.n = exp(-((s1.q-ach[i])/dch[i])^2)
  s1.n = den[i] * s1.n/total(s1.n)
  s1.t = s1.m * 10.
  s1.tp= typ[i]
  s1.c = col[i]
  append_array,ions,s1
endfor
;ions = ions[where(ions.n gt .0001)]
ions = ions[where(ions.q le 16)]
par={vsw:[439.3d,0.d,0.d],magf:[1.,0.,0.],ion:ions}

endif


if n_params() eq 0 then return,0

if not keyword_set(theta) then theta= energy_q * 0.
if not keyword_set(phi) then phi = energy_q * 0.

bdir = par.magf/sqrt(total(par.magf^2))

ni = n_elements(par.ion)

efluxtot = 0.d
fluxtot = 0.d
sqrtpi = sqrt(!dpi)

if n_elements(ionsteps) eq 0 then ionsteps = indgen(ni)

for j=0,n_elements(ionsteps)-1 do begin
  i = ionsteps[j]
  ion = par.ion[i]
  energy = energy_q * ion.q *1000
  if keyword_set(true_nrg) then energy=energy_q * 1000.
  mass = ion.m * 931.494e6/299792.^2
  vth  = velocity(ion.t,mass)
  vel = velocity(energy,mass)
  dim = dimen(vel)
  sphere_to_cart,vel,theta,phi,vx,vy,vz
  v0 = par.vsw + bdir * ion.v
  vsx = vx[*] - v0[0] 
  vsy = vy[*] - v0[1]
  vsz = vz[*] - v0[2]
  vs = [[vsx],[vsy],[vsz]]
  rot = rot_mat(bdir,[0,0,1.])
  vsp2 = (rot ## vs)^2
;  vtot2 = vsx*vsx + vsy*vsy + vsz*vsz
;  f = ion.n / (sqrtpi*vth)^3 * exp( -vtot2 / vth^2 )
  vthperp2 = vth^2*ion.tr
  vthpara2 = vth^2/ion.tr
  ex = (vsp2[*,0]+vsp2[*,1])/vthperp2 + (vsp2[*,2])/vthpara2
  ex = reform(ex,dim,/overwr)
  f = ion.n / (sqrtpi)^3 / vthperp2 / sqrt(vthpara2) * exp(-ex)
  eflux = 2*f*energy^2/mass^2*1e5
  flux = eflux/energy
  efluxtot = efluxtot + eflux
  fluxtot = fluxtot + flux
endfor

if keyword_set(flux_units) then return,fluxtot
return,efluxtot
end
