function min_curv2,vx,vy,vz, data=df,parameter=dfpar , debug = debug , log=log

dim = n_params()
if dim eq 1 then begin
    return, min_curv(vx.x,vx.y,data=df,parameter=dfpar,log=log)
endif

if keyword_set(df) then begin
   logflag = keyword_set(log)
   if logflag then df0 = alog(df) else df0=df

   good = where(finite(vx) and finite(vy) and finite(df0))   ; valid points only
   vx0 = double(vx(good))
   vy0 = double(vy(good))
   if dim eq 3 then  vz0 = double(vz(good))
   df0 = double(df0(good))
   
   n = n_elements(df0)

   m = n + dim + 1		;# of eqns to solve
   a = dblarr(m, m)		;LHS

   for i=0, n-1 do for j=i,n-1 do begin
      d1 = ((vx0(i)-vx0(j))^2 + (vy0(i)-vy0(j))^2)
      if dim eq 3 then d1 = d1 + (vz0(i)-vz0(j))^2
      d1 = d1 > 1.0d-100
      d1 = sqrt(d1)
      d = d1*exp(-d1/3)
      a(i,j) = d
      a(j,i) = d
   endfor

   a(n,0:n-1) = 1.		; fill rest of array
   a(n+1,0:n-1) = vx0
   a(n+2,0:n-1) = vy0

   a(0:n-1,n) = 1.
   a(0:n-1,n+1) = vx0
   a(0:n-1,n+2) = vy0
   
   if dim eq 3 then begin
      a(n+3,0:n-1) = vz0
      a(0:n-1,n+3) = vz0
   endif

   b = dblarr(m)
   b(0:n-1) = df0

   c = reform(b # invert(a))

   if keyword_set(debug) then stop
   if dim ne 3 then dfpar = {x0:vx0,y0:vy0,dfc:c,logflag:logflag,dim:dim} $
   else dfpar = {x0:vx0,y0:vy0,z0:vz0,dfc:c,logflag:logflag,dim:dim}
   return,dfpar
endif

dim = dfpar.dim

vx0=dfpar.x0
vy0=dfpar.y0
if dim eq 3 then vz0=dfpar.z0
c = dfpar.dfc

n = n_elements(vx0)
s = c(n) + c(n+1) * vx + c(n+2) * vy 		;Last terms
if dim eq 3 then s = s + c(n+3) * vz
for i=0, n-1 do begin
   d1 = ((vx0(i)-vx)^2 + (vy0(i)-vy)^2)
   if dim eq 3 then d1 = d1 + (vz0(i)-vz)^2
   wz = where(d1 eq 0,count) 
   if count ne 0 then d1(wz) = 1.0d-100  
   d1 = sqrt(d1)
   d = d1*exp(-d1/3)
   s = s + d * c(i)
endfor

if keyword_set(debug) then stop

if dfpar.logflag then s = exp(s)
return,s


end
