function nrg_disp,time,parameters=p,p_names=p_names,pder_values=pder

if not keyword_set(p) then $
  p={t0:double(min(time))-60.,d:1.5d}

au = 150e6
c = 2.99792d5
e0 = 511000.d
mass = e0/c^2
  
dt = time - p.t0 + au/c
vel = p.d * au / dt

bad = where(dt lt 0,cnt)
if cnt ne 0 then vel(bad) = !values.f_nan

e = ( 1./sqrt(1.d - (vel/c)^2) -1) * e0

if keyword_set(p_names) then begin
  np = n_elements(p_names)
  dedv =  mass * (1 - (vel/c)^2) ^ (-1.5) * vel
  for i=0,np-1 do begin
    case strlowcase(p_names(i)) of 
      'd'  : pder(*,i) = dedv * au / dt
      't0' : pder(*,i) = dedv * au / dt^2 * p.d
    endcase
  endfor
endif

return,e

end