pro fhist,f,f2,h,plot=plot,range=range,nbins=nbins, $
  binsize=binsize,bins=bins,reverse=reverse

if n_params() eq 1 then plot=1

if n_elements(range) ne 2 then range = minmax_range(f)

bad  = where(finite(f) eq 0,nbad)
good = where(finite(f) ne 0,ngood)

if not keyword_set(nbins) then nbins=n_elements(f)^(1/3.d) > 4

if not keyword_set(binsize) then begin
   binsize = (range[1]-range[0])/nbins
   lsize = alog10(binsize)+.15
   esize = floor(lsize)
   msize = floor(3*(lsize-esize))
   binsize = 10.d^esize * ([1,2,5,10])[msize]
endif

;printdat,binsize,'binsize'

brange =  floor(range/ binsize)
bins = floor( double(f)/binsize ) - brange[0]
if nbad ne 0 then bins[bad] = -1

h = histogram(bins,min=0,max=brange[1]-brange[0],reverse=reverse)

f2 = (lindgen(n_elements(h))+brange[0] + .5)*binsize

if keyword_set(plot) then plot,f2,h,psym=10

end
