pro fhistogram,x,y,xp,yp,sx,sy,range=mm,nbins=nbins, $
   weight=weight,hist=h,fixbins=fixbins

if n_elements(mm) ne 2 then mm = minmax_range(x)   
if not keyword_set(nbins) then nbins = 20
binsize = (mm[1]-mm[0])/nbins

h = histogram( x,min=mm[0],max=mm[1],binsize=binsize,reverse=ri)
; note: histogram  does not work properly with the nan keyword set
; the size of h will be nbins+1


if not keyword_set(weight) then weight = replicate(1.,n_elements(y))
wy = weight * y
wx = weight * x
wy2 = weight * y^2
wx2 = weight * x^2

yp = replicate(!values.f_nan,nbins)
sy = yp
xp = replicate(!values.f_nan,nbins)
sx = xp

for i=0,nbins-1 do begin
  if h[i] ne 0 then begin
     ind = ri[ ri[i]: ri[i+1]-1 ]
     w = total(weight[ind])
     yp[i] = total(wy[ind]) / w
     sy[i] = sqrt( (total(wy2[ind]) / w -yp[i]^2) )   ; / (h[i]-1))
     xp[i] = total(wx[ind]) / w
     sx[i] = sqrt( (total(wx2[ind]) / w -xp[i]^2) )   ; / (h[i]-1))
  endif
endfor
if keyword_set(fixbins) then begin
   xp = (findgen(nbins)+.5)*binsize+mm[0]
   sx = xp*0+binsize/2
endif

report
end





