function hist2d,x,y,xrange=xrange,yrange=yrange,xbins=xbins,ybins=ybins, $
  xlims=xlims,ylims=ylims,reverse=ri,bin=bin

if not keyword_set(xbins) then xbins = 25
if not keyword_set(ybins) then ybins = 25

if not keyword_set(xrange) then xrange=minmax_range(x)
if not keyword_set(yrange) then yrange=minmax_range(y)

xlims = dgen(xbins+1,range=xrange)
ylims = dgen(ybins+1,range=yrange)

xb = interp(findgen(xbins+1),xlims,x)
yb = interp(findgen(ybins+1),ylims,y)

wb = where(finite(x) eq 0 or  finite(y) eq 0,nbad)

xb = floor(xb)
yb = floor(yb)

xb = 0 > xb < (xbins-1)
yb = 0 > yb < (ybins-1)

bin = yb * xbins + xb

if nbad ne 0 then bin[wb]=-1

h = histogram(bin,min=0,max=xbins*ybins-1,reverse=ri)
;help,h
h = reform(h,xbins,ybins,/over)
report
return,h
end



