


pro sp_pos , time,param=p,x=x,y=y,radius=r,th=th,psi=psi,period=period, $
  r_dot = r_dot,  th_dot = th_dot, vel = vel ,Gm=Gm,vx=vx,vy=vy
  
Re = 6378.2
if not keyword_set(Gm) then $
   Gm = 6.6732e-8 * 5.977e27 /1e5^3 * (3600.*24.)^2/Re^3


;if not keyword_set(p) then p ={apogee:30,perigee:1.2,t0:0.,th0:0.}

apogee = p.apogee
perigee = p.perigee

t0     = p.t0
th0    = p.th0 * !dtor


a = (apogee + perigee)/2
e = (apogee - perigee)/2/a

w = sqrt( Gm/ a^3 )
period = 2*!pi/ w

wt = w*(time - t0)

psi=e_anomaly(wt,e)

tan_psi_2 = tan(psi/2.)
ee = (1+e)/(1-e)

r = a*(1-e*cos(psi))
th = 2. * atan( sqrt(ee) * tan_psi_2 ) + th0

x  = r * cos(th)
y  = r * sin(th)

psi_dot = w / (1-e*cos(psi))
r_dot = a * e*sin(psi) * psi_dot
th_dot = sqrt(ee) * (1+tan_psi_2 ^2)/(1+ee*tan_psi_2 ^2) * psi_dot

vel = sqrt(r_dot^2 + (r * th_dot)^2)

return 
end
