; Returns roots of a polynomial
pro polyroots,b0,b1,b2,b3,nroots=nroots,z1=z1,z2=z2,z3=z3

;if n_params() eq 0 then return
;if n_params() eq 1 then return
;if n_params() eq 2 then return


; cubic:

a0 = double(b0)/b3
a1 = double(b1)/b3
a2 = double(b2)/b3

q = a1/3.d - a2^2/9.d
r = (a1*a2-3.d*a0)/6.d - a2^3 /27.d

q3r2 = dcomplex(q^3 + r^2)

i = dcomplex(0,1)
isqrt3_4 = i * sqrt(3.d)/2

s1 = (r + sqrt(q3r2)) 
w = where(abs(s1) ne 0,c)
if c ne 0 then s1[w] = s1[w] ^ (1/3.d)
s2 = (r - sqrt(q3r2)) 
w = where(abs(s2) ne 0,c)
if c ne 0 then s2[w] = s2[w] ^ (1/3.d)

z1 = double((s1+s2) - a2/3.d)             ; must be real!
z2 = -(s1+s2)/2 - a2/3 - isqrt3_4*(s1-s2)
z3 = -(s1+s2)/2 - a2/3 + isqrt3_4*(s1-s2)

end

