function prob_dens_data,name,trange,yrange=yrange,ylog=ylog,nbins=nbins

get_data,name,data=d,alim=lim

if not keyword_set(yrange) then yrange=struct_value(lim,'yrange',def=minmax(d.y))
if n_elements(ylog) eq 0   then ylog=struct_value(lim,'ylog',def=0)
if not keyword_set(nbins)  then nbins=struct_value(lim,'nbins',def=50)

t = d.x
res = .05
scale = (t-trange[0])/(trange[1]-trange[0])
irange = floor([-1.5,2.5]/res)
tind = floor(scale/res)-irange[0]
nt = irange[1]-irange[0]

prob = replicate(!values.f_nan,nt,nbins)
for  i=0,nt-1 do begin
;  print,i
  w = where(tind eq i,n)
  if n ne 0 then begin
     y = d.y[w]
     yp = histbins(/norm,y,yb,range=yrange,log=ylog,nbins=nbins)
     prob[i,*] = yp
;     if total(finite(yp)) gt 0 then plot,yb,yp,yrange=[0,10],xlog=ylog,psym=10
  endif
endfor

xb = (dindgen(nt)+irange[0]+.5) * res 
lim = struct(yrange=yrange,/ystyle,ylog=ylog,nbins=nbins)
str_element,/add,lim,'spec',1
str_element,/add,lim,'yrange',yrange
str_element,/add,lim,'ylog',ylog
data = {name:name,x:xb,y:prob,v:yb,lim:lim}
return,data
end
