function shock_data,dat0,magname=magname   ; ,format=fmt

if not keyword_set(magname) then magname=(tnames('wi_B3 wi_B',/all))[0]
if not keyword_set(velname) then velname=(tnames('Vp wi_pm_Vp',/all))[0]
if not keyword_set(denname) then denname=(tnames('Np wi_pm_Np',/all))[0]
if not keyword_set(tpname) then tpname=(tnames('Tp wi_pm_Tp',/all))[0]
if not keyword_set(tename) then tename=(tnames('em.AVGTEMP',/all))[0]
if not keyword_set(qename) then qename=(tnames('em.QVEC',/all))[0]
if not keyword_set(tername) then tername=(tnames('em.TRAT',/all))[0]
if not keyword_set(tprname) then tprname=(tnames('Tp_rat',/all))[0]
if not keyword_set(posname) then posname=(tnames('wi_pos',/all))[0]

printdat,/val,magname,'magname'
printdat,/val,velname,'velname'
printdat,/val,denname,'denname'
printdat,/val,tpname,'tpname'
printdat,/val,tprname,'tprname'
printdat,/val,tename,'tename'
printdat,/val,tername,'tername'
printdat,/val,posname,'posname'

dat = shock_struct(dat0)
    
;if keyword_set(fmt) then return,dat
   
if n_elements(dat0) eq 0 then begin
 
   print,'Click on shock transition:'
   ctime,ts,np=1
   timebar,ts
   print,'Click on Upstream time range:'
   wait,.2
   ctime,tr1,np=2
   timebar,tr1
   print,'Click on Downstream time range:'
   wait,.2
   ctime,tr2,np=2
   timebar,tr2
   dat.r1.tr = tr1
   dat.r2.tr = tr2
   dat.ts = ts
endif

if keyword_set(posname) then dat.scpos = data_cut(posname,dat.ts) 
   
r = dat.r1
tr = r.tr
if keyword_set(magname) then r.b  = tsample(magname,tr,/average)
if keyword_set(denname) then r.n  = tsample(denname,tr,/average) 
if keyword_set(velname) then r.v  = tsample(velname,tr,/average) 
if keyword_set(tpname) then r.tp  = tsample(tpname,tr,/average) 
if keyword_set(tename) then r.te  = tsample(tename,tr,/average) 
if keyword_set(qename) then r.qe  = (tsample(qename,tr,/average))[2] 
if keyword_set(tername) then r.te_rat  =  tsample(tername,tr,/average) 
if keyword_set(tprname) then r.tp_rat  =  tsample(tprname,tr,/average) 
if 1 then begin
 el = get_el2(average(tr))
 add_magf,el,magname
 add_vsw,el,velname
 el.sc_pot=8
 df = convert_vframe(/int,el)
 pd = pad(df)
 r.eldf.t = pd.time
 r.eldf.magf = el.magf
 r.eldf.sc_pot = el.sc_pot
 r.eldf.nrg = pd.energy
 r.eldf.df = pd.data
endif
dat.r1 = r

r = dat.r2
tr = r.tr
if keyword_set(magname) then r.b  = tsample(magname,tr,/average)
if keyword_set(denname) then r.n  = tsample(denname,tr,/average) 
if keyword_set(velname) then r.v  = tsample(velname,tr,/average) 
if keyword_set(tpname) then r.tp  = tsample(tpname,tr,/average) 
if keyword_set(tename) then r.te  = tsample(tename,tr,/average) 
if keyword_set(qename) then r.qe  = (tsample(qename,tr,/average))[2] 
if keyword_set(tername) then r.te_rat  =  tsample(tername,tr,/average) 
if keyword_set(tprname) then r.tp_rat  =  tsample(tprname,tr,/average) 
if 1 then begin
 el = get_el2(average(tr))
 add_magf,el,magname
 add_vsw,el,velname
 el.sc_pot=8
 df = convert_vframe(/int,el)
 pd = pad(df)
 r.eldf.t = pd.time
 r.eldf.magf = el.magf
 r.eldf.sc_pot = el.sc_pot
 r.eldf.nrg = pd.energy
 r.eldf.df = pd.data
endif
dat.r2 = r


if 1 then begin
  n = n_elements(dat.dat)
  get_data,denname,time,np
  get_data,velname,time,vp
  get_data,tpname,time,tp
  get_data,tprname,time,tpr
  magf = data_cut(magname,time)
  bmag = sqrt(total(magf^2,2))
  dummy = min(abs(time-dat.ts),wi)
  ind = wi+indgen(n)-n/2
  dat.dat.t = time[ind]
  dat.dat.n = np[ind]
  dat.dat.v  = transpose(vp[ind,*])
  dat.dat.tp = tp[ind]
  dat.dat.tpr = tpr[ind]
  dat.dat.b  = transpose(magf[ind,*])
endif



if 0 then begin
 t = get_el2(/times)
 dummy=min(abs(t-dat.ts),wi)
 n = 7
 ind = wi + indgen(n) - n/2
 for i=0,6 do begin
  el = get_el2(index=ind[i])
  el.sc_pot=8.
  add_magf,el,magname
  add_vsw,el,velname
  df = convert_vframe(/int,el)
  pd = pad(df)
  dat.eldf[i].t = pd.time
  dat.eldf[i].magf = el.magf
  dat.eldf[i].sc_pot = el.sc_pot
  dat.eldf[i].nrg = pd.energy
  dat.eldf[i].df = pd.data
 endfor
endif  


return,dat
end
