function shock_param,d,get_data=get_dat  ,format=fmt 


if n_params() eq 0 or keyword_set(get_dat) then d=shock_data(d)

f=!values.f_nan
if size(fmt,/type) eq 8 then sp=fmt else $
sp = {dat:d,  $
     rm:replicate(f,3,3),ok:-1,order:-1,  $
;     pos:[f,f,f],  $
     b1:f, b2:f,  $
     thbn1:f,thbn2:f,ang12:f, $
     beta1:f, beta2:f, $
     vel_norm1:f , vel_norm2:f, $
     vs_et:f,vs_mf:f,$
     vs_nmomf:f,vs_tmomf:f,$
     vshock:f, $
     m1:f, m2:f,  $
     fms1:f,fms2:f}

sp.dat = d

n1a = d.r1.n
v1a = d.r1.v
tp1 = d.r1.tp
te1 = d.r1.te
b1a = d.r1.b

n2a = d.r2.n
v2a = d.r2.v
tp2 = d.r2.tp
te2 = d.r2.te
b2a = d.r2.b

;sp.pos = average([[d.r1.pos],[d.r2.pos]],2)

vxb1 = crossp(v1a,b1a)
vxb2 = crossp(v2a,b2a)

dv = v2a-v1a
db = b2a-b1a
dvxb =vxb2-vxb1

bmag1 = norm(b1a)
bmag2 = norm(b2a)
sp.b1 = bmag1
sp.b2 = bmag2

sp.ok = d.r2.tp gt d.r1.tp
sp.order = average(d.r1.tr) lt average(d.r2.tr)

nhat = crossp(db,crossp(db,dv)) & nhat = nhat/norm(nhat)

sp.thbn1 = !radeg * acos(total(nhat * b1a)/bmag1)
sp.thbn2 = !radeg * acos(total(nhat * b2a)/bmag2)
sp.ang12 = !radeg * acos(total(b1a * b2a)/bmag2/bmag1)

rhat = crossp(db,nhat) & rhat = rhat/norm(rhat)
that = crossp(rhat,nhat) & that = that/norm(that)

rm = [[that],[rhat],[nhat]]
sp.rm = rm

sp.vs_et = -total(dvxb*rhat)/norm(db)

vn1 = total(v1a * nhat)
vn2 = total(v2a * nhat)
nv1 = n1a * vn1
nv2 = n2a * vn2
sp.vs_mf = (nv1-nv2)/(n2a-n1a)
;stop

p1 = n1a * tp1
p2 = n2a * tp2
mu0 = 4*!pi*1.609/100
c = 299792.
mass = 511000.*1836./c^2

sp.vs_nmomf = -(p2-p1+(bmag2^2-bmag1^2)/2/mu0)/n1a/mass/(vn2-vn1) - vn1

bn1 = total(b1a * nhat)
bn2 = total(b2a * nhat)
bt1 = total(b1a * that)
bt2 = total(b2a * that)
vt1 = total(v1a * that)
vt2 = total(v2a * that)
sp.vs_tmomf = bn1/n1a/mass/mu0*(bt2-bt1)/(vt2-vt1) -vn1

c_alf1 = 21.8 * norm(b1a) / sqrt(n1a)
c_s1 = 9.79 * sqrt(Te1+1.67*Tp1)
cms1 = sqrt(c_s1^2+c_alf1^2)

c_alf2 = 21.8 * norm(b2a) / sqrt(n2a)
c_s2 = 9.79 * sqrt(Te2+1.67*Tp2)
cms2 = sqrt(c_s2^2+c_alf2^2)

sp.vel_norm1 = total(v1a * nhat)
sp.vel_norm2 = total(v2a * nhat)

sp.fms1 = total(v1a * nhat)/cms1
sp.fms2 = total(v2a * nhat)/cms2

sp.m1 = norm(v1a)/cms1
sp.m2 = norm(v2a)/cms2

mass = .01044

Pb1 = bmag1^2/.403
Pb2 = bmag2^2/.403
Pp1 = n1a*(Tp1+Te1)
Pp2 = n2a*(Tp2+Te2)

sp.beta1 = Pp1/Pb1
sp.beta2 = Pp2/Pb2

dPb = Pb2-Pb1
dPp = Pp2-Pp1



vshock = 0.
sp.vshock = vshock

r2exp = d.r2   ; Assume v2 B2 are ok


nvn = n1a* (total(v1a * nhat)-vshock)
;r2exp.n =  n1a *( total(v1a * nhat) -vshock )/ (( total(v2a * nhat) -vshock )
;r2exp.tp =  

return,sp


end
