pro shock_rh_cons,sp,velname=velname,denname=denname,tpname=tpname,tename=tename

if not keyword_set(magname) then magname=(tnames('wi_B3 wi_B',/all))[0]
if not keyword_set(velname) then velname=(tnames('Vp',/all))[0]
if not keyword_set(denname) then denname=(tnames('Np',/all))[0]
if not keyword_set(tpname) then tpname=(tnames('Tp',/all))[0]
if not keyword_set(tprname) then tename=(tnames('Te',/all))[0]

printdat,/val,magname,'B'
printdat,/val,velname,'V'
printdat,/val,denname,'N'
printdat,/val,tpname,'Tp'
printdat,/val,tename,'Te'

get_data,velname,tvel,vel

mag = data_cut(magname,tvel)
den = data_cut(denname,tvel)
Tp  = data_cut(tpname,tvel)
Te  = data_cut(tename,tvel)

vel_rot = rotate_data(vel,sp.rm)
mag_rot = rotate_data(mag,sp.rm)

store_data,'B_RH',data={x:tvel,y:mag_rot},dlim={ynozero:1}

vshock = sp.vshock
vn = (vel_rot[*,0]-vshock)
nvn = den * vn
store_data,'nVn_RH',data={x:tvel,y:nvn},dlim={ynozero:1}

mass =.01044 

nmvnvn = mass*den*vn^2
P_p = den*tp
P_e = den*te
P_b = total(mag^2,2)/.403
Fn = nmvnvn+P_p+P_e+P_b

store_data,'Fn_RH',data={x:tvel,y:[[nmvnvn],[P_p],[P_e],[P_b],[Fn]]},dlim={colors:'rgcbd',ynozero:1}

nmvnvt = mass*den*vn*(vel_rot[*,2])
bnbt = mag_rot[*,0]*mag_rot[*,2]/.403*2
Ft = nmvnvt-bnbt

store_data,'Ft_RH',data={x:tvel,y:[[nmvnvt],[bnbt],[Ft]]},dlim={colors:'rbd',ynozero:1}

bnvt = mag_rot[*,0] * vel_rot[*,2]
vnbt = vn * mag_rot[*,2]
Et = bnvt-vnbt

store_data,'Et_RH',data={x:tvel,y:[[bnvt],[vnbt],[et]]},dlim={colors:'gbd',ynozero:1}


end
