pro temppad,names,kelvin=kelvin

if not keyword_set(names) then names='elpd-2-*'

exnames = tnames(names)
exnames = strfilter(exnames,'*_temp',/neg)  ;ignore names that include '_temp'

for i=0,n_elements(exnames)-1 do begin
name = exnames[i]

get_data,name,ptr=p,alim=alim
flux = *p.y
energy = *p.v
logdf = alog(flux/energy)
dlogdf_de = (logdf-shift(logdf,0,1))/(energy-shift(energy,0,1))
y = -1./dlogdf_de[*,1:*]
range = [1,300.]
ytitle=''
str_element,alim,'ytitle',ytitle
yunits = 'T (eV)'

if keyword_set(kelvin) then begin
  y = y * 11600.e-6
  range = range*11600.e-6
  yunits = 'T (10!u6!nK)'
endif
if  keyword_set(ytitle) then ytitle=yunits+'!c'+ytitle
energy2 = (energy+shift(energy,0,1))/2

nrg = (average(energy2,1,/nan))[1:*]
labels = strmid(strtrim(roundsig(nrg,sig=2),2),0,4)
data = {x:p.x,  y:y,  v:energy2[*,1:*] }

store_data,name+'_temp',data=data,dlim={yrange:range,ylog:1,ystyle:1, $
  panel_size:2.,ytitle:ytitle,labels:labels}

endfor

end
