;+
;Procedure:  tplot_print
;Purpose:
;  Creates an ascii file for selected tplot variables.
;-

pro tplot_print,names,trange=trange,filename=filename, $
  format=format,reftime=reftime

tvar = tnames(/all,names,nv)


get_data,tvar[0],ptr=p0

t = *p0.x

if keyword_set(trange) then begin
   mmtr = minmax_range(time_double(trange))
   w= where(t ge mmtr[0] and t lt mmtr[1],c)
   if c eq 0 then begin
     message,/info, 'No data to print'
     return
   endif
   t=t[w]
endif


ps = ptrarr(nv)
for n=0,nv-1 do begin
   ps[n]=ptr_new(transpose( data_cut(tvar[n],t) ) )
endfor


if keyword_set(filename) then openw,/get_lun,lun,filename,width=800 else lun=-1

if n_elements(reftime) ne 0 then begin
  rt = time_double(reftime)
  printf,lun,'Start time: '+time_string(rt)
  s = '  Seconds '
endif  else  s= '  Time                '
for n=0,nv-1 do begin
   d = dimen1(*ps[n])
   sn = replicate(tvar[n],d)
   s=s + string(sn,/print,format='(20a11)')
endfor
printf,lun,s

format = '(20(" ",f10.5))'
for i=0l,n_elements(t)-1 do begin
  if n_elements(rt) ne 0 then s=string(t[i]-rt,format='(f12.1)') $
  else  s=string(time_string(t[i],prec=1),format='(a21," ")')
  for n=0,nv-1 do begin 
     s=s+string(/print,(*ps[n])[*,i],format=format)
  endfor
  printf,lun,s
endfor

ptr_free,ps

if keyword_set(filename) then free_lun,lun
   
end
