function mfihres_fname_to_time,fpnames

pos = strpos(fpnames,'/',/reverse_search)
pos = pos[0]


tfile1 = replicate(time_struct(0.d),n_elements(fpnames))
tfile1.year  = fix(strmid(fpnames,pos+11,4))
tfile1.month = fix(strmid(fpnames,pos+15,2))
tfile1.date  = fix(strmid(fpnames,pos+17,2))
tfile2 = tfile1
t0 = time_double(tfile1)
tfile1.hour = fix(strmid(fpnames,pos+20,2))
tfile1.min  = fix(strmid(fpnames,pos+22,2))
tfile2.hour = fix(strmid(fpnames,pos+25,2))
tfile2.min  = fix(strmid(fpnames,pos+27,2))

trrs = transpose(time_double([[tfile1],[tfile2]]))


return,trrs
end





pro convert_wi_hr_mfi,fname

;dir ="/home/davin/wind/analysis/magdata/"

;fpnames = findfile(dir+'*.gse')

;print,transpose(fpnames)
if not keyword_set(fname) then begin
  file=''
  read,file,prompt="file name? "
  fnames = strsplit(file,/extract)
endif
if ndimen(fname) eq 0 then fnames=strsplit(fname,/extract) ; else fnames=fname

for i=0,n_elements(fnames)-1 do begin
file = fnames[i]
tr = mfihres_fname_to_time(file)

print,time_string(tr)
t0 = floor(tr[0]/86400d)*86400
format = {mfi_hres,time:0.d,phase:0.,mode:0,B:[0.,0.,0.]}
dat=read_asc(file,format=format)
dat.time = dat.time/1000 + t0
file_out = file
pos = strpos(file_out,'.',/reverse_search)
strput, file_out,'idl',pos+1
save,dat,file=file_out
;store_data,'Bfoo',data={x:dat.time,y:transpose(dat.b)}
endfor

end





pro clean_spinfreq_wi_hr_mfi,spinfreq=spinfreq,trange=trange,dfreq=df

get_data,'Bh2',data = pp
pad = 3

if keyword_set(trange) then begin
   ind = where(pp.x ge trange[0] and pp.x le trange[1],n2)
   if n2 eq 0 then message,'No data in time range'  
endif else begin
   n2 = n_elements(pp.x)
   ind = lindgen(n2)
endelse

if not keyword_set(df) then df = .0002d

dt0 = pp.x[1]-pp.x[0]
printdat,dt0
dt0 = total(minmax(pp.x)*[-1,1])/(n_elements(pp.x)-1)
printdat,dt0

!p.multi=[0,2,2]

harmon_max = round(3./dt0/2-1)

for k=0,1 do begin    ; no corrections to Bz

bx = pp.y[*,k]
interp_gap,pp.x,bx,index=bad,count=nbad,/verbose
bx = bx[ind]

bx = padfftarray(bx,pad)
fbx = fft2(bx,dt0,f,/double)
;plot,f,abs(fbx),/ylog ;,/xlog

if not keyword_set(spinfreq) then begin
   !p.multi=[0,1,3]
   n1 = n_elements(f)
   f_ = f[0:n1/2]
   p1  = abs(fbx[0:n1/2])^2
;   ps = smooth(p1,512,/edge)
   ps = smooth(p1,128,/edge)
   dp = abs(p1-ps)/ps
   plot,f_,dp,/ylog
   w1 = where(dp gt 10)
   f1 = f_[w1]
   df1 = f1 - shift(f1,1)
   sf = 1/[3.3,2.8]
   w2 = where(df1 gt sf[0] and df1 lt sf[1],c)
   sf = average(df1[w2])
   harm = round(f1/sf)
   df1 = f1-harm*sf
   plot,harm,df1,/ps
;   w2 = where(df1^2 lt average(df1^2)*1.5)
   w2 = where(df1^2 lt (df*3)^2)
   f1=f1[w2]
   harm = round(f1/sf)
   df1 = f1-harm*sf
   oplot,harm,df1,ps=4,col=6
   fit,harm,f1,funct='polycurve',name='a0 a1',par=par
   sf = par.a1
   harm = round(f1/sf)
   df1 = f1-harm*sf
   plot,harm,df1,/ps
   spinfreq = sf
   printdat,spinfreq,'spin frequency'

!p.multi=[0,3,5]
for harmon=1,15 do begin
;  plot,f,abs(fbx),/ylog,/xstyle,xrange=[-.005,.005]+spinfreq*harmon
  plot,f_,dp,/ylog,/xstyle,xrange=[-.005,.005]+spinfreq*harmon,yrange=[.001,100]
  oplot,(spinfreq*harmon-df)*[1,1],10^!y.crange,/col
  oplot,(spinfreq*harmon+df)*[1,1],10^!y.crange,/col
endfor
endif  


if 0 then begin
  bad = finite(f) eq 0
  for i=1,16 do begin
    bad = bad or (f lt (spinfreq*i+df) and f gt (spinfreq*i-df))
    bad = bad or (-f lt (spinfreq*i+df) and -f gt (spinfreq*i-df))
  endfor
  fbx[where(bad)] = 1e-8
  plot,f,abs(fbx),/ylog,/xstyle,xrange=[-.015,.015]+spinfreq*harmon
endif else begin
if not keyword_set(filter) then begin
  filter = 0d
  for i=1,harmon_max-1 do begin
    fi = spinfreq*i
    filter = filter+ exp(- ((f-fi)/df)^2 )
    filter = filter+ exp(- ((f+fi)/df)^2 )
  endfor
  filter = 1-filter
endif  
fbx = fbx*filter
oplot,f,abs(fbx),col=6
endelse

plot,f,abs(fbx),/ylog


bx = fft(fbx,/inv)
bx = bx[0:n2-1]

;plot,bx

pp.y[ind,k] = bx

if nbad gt 0 then pp.y[bad,k]=!values.f_nan

endfor
store_data,'Bh2',data=pp
!p.multi=0
end







pro load_wi_hr_mfi,trange=trange,polar=polar

dir ="/home/davin/dat/wi/mfi/hr/"

fpnames = findfile(dir+'wi_hr_mfi_*.???')
tr = mfihres_fname_to_time(fpnames)
u = uniq(reform(tr[0,*]))
fpnames = fpnames[u]
tr = tr[*,u]
print,time_string(tr)
if not keyword_set(trange) then begin
   print,'Select a time:'
   ctime,trange
endif
mm = minmax(time_double(trange))
w = where(tr[1,*] ge mm[0] and tr[0,*] le mm[1],c)

if c ne 0 then print,w

for i=0,c-1 do begin
  fpn = fpnames[w[i]]
  extpos = strpos(/reverse_search,fpn,'.gse')
  if extpos ge 1 then begin
     print,'converting file: ',fpn
     convert_wi_hr_mfi,fpn
     strput,fpn,'.idl',extpos
  endif
  print,'Loading file: ',fpn
  restore,file=fpn;,/verbose
  if keyword_set(alldat) then alldat=[temporary(alldat),temporary(dat)] else alldat=temporary(dat)
endfor

if not keyword_set(no_clean) then begin
   time=alldat.time
   dt = time-shift(time,1)

   tr = minmax(time)
   dt0 = (tr[1]-tr[0])/(n_elements(time)-1)
   help,time,dt0
   ok = dt gt .04 and dt lt .1
   good2 = where(dt gt .04 and dt lt .05,c2)
   good1 = where(dt gt .09 and dt lt .10,c1)
   if c2 gt c1  then dt0 = average(dt[good2]) else dt0 = average(dt[good1])

   fi = (time-time[0])/dt0
   i = round(fi)
   dfi = minmax(fi-round(fi))
   if dfi[0] lt -.02 or dfi[1] gt .02 then begin
      plot,fi-round(fi)
      wi
      message,'cleanup error'
   endif

   a=fill_nan(alldat[0])
   a.mode = -1
   n = max(i)+1
   alldat2 = replicate(a,n)
   alldat2[i,*] = alldat
   alldat2.time = dindgen(n)*dt0 + time[0]
   help,dt0,good1,good2,n
   alldat = temporary(alldat2)

endif 



if keyword_set(alldat) then begin
  w= where(alldat.phase gt 6.3,c)
  if c ne 0 then Message,/info,"Some bad data!"
  store_data,'Bh',data={x:alldat.time,y:transpose(alldat.B)}
  store_data,'Bh_phase',data={x:alldat.time,y:alldat.phase}
  store_data,'Bh_mode',data={x:alldat.time,y:alldat.mode}
  ylim,'Bh_mode',-.2,2.2
  ylim,'Bh_phase',0,6.5

if keyword_set(polar) then begin
  xyz_to_polar,'Bh',/ph_0_360
endif

endif  else message,/info,'No data found in time range'

end
