;+
;PROCEDURE:  xylim
;PURPOSE:    adds the tag 'xrange' to the structure "struct"
;INPUTS: 
;   struct:  structure to be added to.  (Created if non-existent)
;   min:     min value of range
;   max:     max value of range
;   type:  (optional)  0: linear,   1: log
;If struct is a string then the limit structure associated with that string
; is used
;Typical usage:
;   xlim,lim,-20,100
;
;CREATED BY:	Davin Larson
;LAST MODIFICATION:	@(#)xlim.pro	1.3 95/08/24
;-
pro xylim,lim

wshow,icon=0

print,'Select the box limits with the cursor.'
cursor,x0,y0,/data,/down
print,'Select the upper right corner.
cursor,x1,y1,/data,/down

y = [y0,y1]
x = [x0,x1]

xlim,lim,x0,x1
ylim,lim,y0,y1
return
end

