;  divgradcurl spherical


function del2,f,state,ll

dx = state[*].dx
h  = state[*].h

d   = (( f[ll.si_0p] - f[ll.si_0m] ) / dx[0,*] / h[0,*]^2)
d2  =  ( d[ll.si_0p] - d[ll.si_0m] ) / dx[0,*]

d   = (( f[ll.si_1p] - f[ll.si_1m] ) / dx[1,*] / h[1,*]^2)
d2 +=  ( d[ll.si_1p] - d[ll.si_1m] ) / dx[1,*]

d   = (( f[ll.si_2p] - f[ll.si_2m] ) / dx[2,*] / h[2,*]^2)
d2 +=  ( d[ll.si_2p] - d[ll.si_2m] ) / dx[2,*]

d2 /= state[*].omega

return,d2
end





function grad,n,state,ll

dim = ll.dim
ndim = ll.ndim
g = dblarr([ndim,dim])
dx = state.dx
h  = state.h
g[0,*] = (( n[ll.si_0p] - n[ll.si_0m] ) / dx[0,*] / h[0,*])
g[1,*] = (( n[ll.si_1p] - n[ll.si_1m] ) / dx[1,*] / h[1,*])
g[2,*] = (( n[ll.si_2p] - n[ll.si_2m] ) / dx[2,*] / h[2,*])

return,g
end


function div,v,state,ll
compile_opt    strictarrsubs

vo_h = state[*].o_h * v
dx = state[*].dx
d  = ( vo_h[0,ll.si_0p] - vo_h[0,ll.si_0m] ) / dx[0,*]
d += ( vo_h[1,ll.si_1p] - vo_h[1,ll.si_1m] ) / dx[1,*]
d += ( vo_h[2,ll.si_2p] - vo_h[2,ll.si_2m] ) / dx[2,*]
;d = reform(d,/overwrite)
d /= state.omega
d = reform(/overwrite,d,[ll.dim])

return,d
end



function curl,v,state,ll
compile_opt    strictarrsubs
vh =  state[*].h  * v
dx =  state[*].dx
o_h = state[*].o_h
c = dblarr([ll.ndim,ll.nd])

;if 1 then begin
c[0,*] = ((vh[2,ll.si_1p]-vh[2,ll.si_1m])/dx[1,*] - (vh[1,ll.si_2p]-vh[1,ll.si_2m])/dx[2,*])/O_h[0,*]
c[1,*] = ((vh[0,ll.si_2p]-vh[0,ll.si_2m])/dx[2,*] - (vh[2,ll.si_0p]-vh[2,ll.si_0m])/dx[0,*])/O_h[1,*]
c[2,*] = ((vh[1,ll.si_0p]-vh[1,ll.si_0m])/dx[0,*] - (vh[0,ll.si_1p]-vh[0,ll.si_1m])/dx[1,*])/O_h[2,*]
;endif else begin
;r = state[*].x[0]
;v = reform(v,ll.ndim,ll.nd,/overwrite)
;;c[0,*] = ((vh[2,ll.si_1p]-vh[2,ll.si_1m])/dx[1,*] - (vh[1,ll.si_2p]-vh[1,ll.si_2m])/dx[2,*])/O_h[0,*]
;c[1,*] = ((v[0,ll.si_2p]-v[0,ll.si_2m])/dx[2,*]- v[2,*])/r - (v[2,ll.si_0p]-v[2,ll.si_0m])/dx[0,*]
;;c[2,*] = ((vh[1,ll.si_0p]-vh[1,ll.si_0m])/dx[0,*] - (vh[0,ll.si_1p]-vh[0,ll.si_1m])/dx[1,*])/O_h[2,*]
;endelse

return,reform(c,[ll.ndim,ll.dim],/overwrite)
end


function dot_prod,v1,v2
  dim = size(/dimension,v1)
  dotp = dblarr(dim[1:*])
  dotp  = v1[0,*,*,*] * v2[0,*,*,*]
  dotp += v1[1,*,*,*] * v2[1,*,*,*]
  dotp += v1[2,*,*,*] * v2[2,*,*,*]
  return,dotp
end


function cross_prod,A,B
C = A
C[0,*,*,*] = ( A[1,*,*,*] * B[2,*,*,*] - A[2,*,*,*] * B[1,*,*,*])
C[1,*,*,*] = ( A[2,*,*,*] * B[0,*,*,*] - A[0,*,*,*] * B[2,*,*,*])
C[2,*,*,*] = ( A[0,*,*,*] * B[1,*,*,*] - A[1,*,*,*] * B[0,*,*,*])
return,C
end


pro def_constants,dim

defsysv,'!cc',exists=exists
if keyword_set(exists) then begin
  dprint,'!cc already exists'
  return
endif

mu0 = 4*!dpi*1e-7
C = 2.99792d8        ; m/s
eps0 = 1/C^2/mu0
Mp    = 1.6726d-27   ; kg
Me  = Mp /1836       ; kg
Mt = Mp+Me           ; kg
q_e = 1.6022d-19     ; C
J_ev =  q_e
const={ $
;   ndim:n_elements(dim),  $ ; obsolete
;   dim:dim,  $              ; obsolete
;   dr:dim*0d, $             ; obsolete
   c:c,  $
   mu0: mu0,  $
   eps0 : eps0,  $
   Mp    : Mp,   $
   Me  : Me,     $
   Mt : Mp+Me,     $
   q_e : q_e,  $
   R_sun : 1.392e9/2,  $  ; Radius of sun;  meters
   M_sun : 1.9891e30,  $  ; Mass of sun;  kg
   w_sun : 1/27./24d/3600.,  $  ; Rotation rate of sun (approx.)
   G     : 6.67428e-11,  $  ; m^3/kg/s^2
   sigma:0d,   $
   diffusion:1d-10 ,  $
   nmod: 1  $
   }
defsysv,'!cc',const
end




function define_state,desc

def_constants
def = {desc2,tag:'',name:'',units0:'',scale:1d,units:'',ndim:-1,dim:[0,0,0], dep:0 }

if not keyword_set(desc) then begin

  desc=[  {desc2,'X'   ,'R,P,T','m,r,r' ,1e-3             ,'km'     , 1   ,[3,0,0], 0 } $
         ,{desc2,'dX'  ,'R'    ,'m'     ,1e-3             ,'km'     , 1   ,[3,0,0], 0 } $
         ,{desc2,'h'   ,'h'    ,'?'     , 1               ,'?'      , 1   ,[3,0,0], 0 } $
         ,{desc2,'O_h'  ,'O_h'   ,'?'     , 1               ,'?'      , 1   ,[3,0,0], 0 } $
         ,{desc2,'Omega','Omega' ,'?'     , 1               ,'?'      , 0   ,[0,0,0], 0 } $
         ,{desc2,'BNDRY'  ,' '   ,' ' ,0  ,' '  , 0   ,[0,0,0], 0 } $
         ,{desc2,'B'   ,'B'    ,'T'     ,1e9              ,'nT'     , 1   ,[3,0,0], 1 } $
         ,{desc2,'E'   ,'E'    ,'V/m'   ,1e3              ,'mV/m'   , 1   ,[3,0,0], 1 } $
         ,{desc2,'RHO' ,'rho'  ,'C/m^3' ,1e-6/!cc.q_e     ,'e/cc'   , 0   ,[0,0,0], 1 } $
         ,{desc2,'J'   ,'J'    ,'A/m^2' ,1e6              ,'uA/m^2' , 1   ,[3,0,0], 1 } $
         ,{desc2,'MN'  ,'n'    ,'Kg/m^3',1e-6/!cc.mt      ,'1/cc'   , 0   ,[0,0,0], 1 } $
         ,{desc2,'V'   ,'V'    ,'m/s'   ,1e-3             ,'km/s'   , 1   ,[3,0,0], 1 } $
         ,{desc2,'PE'  ,'Pe'   ,'J/m^3' ,1e-6/!cc.q_e     ,'eV/cc'  , 2   ,[3,3,0], 1 } $
         ,{desc2,'PI'  ,'Pi'   ,'J/m^3' ,1e-6/!cc.q_e     ,'eV/cc'  , 2   ,[3,3,0], 1 } $
 ]
endif

scaler = !values.d_nan
for i=0,n_elements(desc)-1 do begin
     desc[i].ndim = total(/pres,desc[i].dim gt 1)    ; make correction if needed
     d = desc[i]
     v = keyword_set(d.ndim) ? replicate(scaler,d.dim > 1) : scaler
     s = keyword_set(s) ?  create_struct(s,d.tag,v) : create_struct(d.tag,v)
endfor

return,s
end




pro diagnostics,S,dgn,d_desc=diag,debug=debug

diag  = [ {desc2,'EPS'     , 'Epsilon'  ,''        ,1d           ,''          , 0, [0,0,0] }  $
         ,{desc2,'eDIV_E'  , 'DEL.E-rho','C/cc'    ,1d-6/!cc.q_e ,'e/cc'      , 0, [0,0,0] }  $
         ,{desc2,'VE'      , 'Ve'       ,'m/s'     ,1d-3         ,'km/s'      , 1, [3,0,0] }  $
         ,{desc2,'VI'      , 'Vi'       ,'m/s'     ,1d-3         ,'km/s'      , 1, [3,0,0] }  $
         ,{desc2,'J_dot_E' , 'J.E'      ,'J/m^3/s' ,1d-6/!cc.q_e ,'eV/cc/s'   , 0, [0,0,0] }  $
         ,{desc2,'JXB'     , 'JxB'      ,'MKS' ,1e-6/!cc.q_e ,'?', 1, [3,0,0] }  $
         ,{desc2,'Se'      , 'Se'       ,'J/m^2/s' ,1d-6/!cc.q_e ,'eV/cc-m/s?', 1, [3,0,0] }  $
         ,{desc2,'Si'      , 'Si'       ,'J/m^2/s' ,1d-6/!cc.q_e ,'eV/cc-m/s?', 1, [3,0,0] }  $
         ,{desc2,'Sf'      , 'Sf'       ,'J/m^2/s' ,1d-6/!cc.q_e ,'eV/cc-m/s?', 1, [3,0,0] }  $
         ,{desc2,'DIV_SF'  , 'DEL.Sf'   ,'J/m^3/s' ,1d-6/!cc.q_e ,'eV/cc/s'   , 0, [0,0,0] }  $
         ,{desc2,'Ee'      , 'E_e'      ,'J/m^3'   ,1d-6/!cc.q_e ,'eV/cc'     , 0, [0,0,0] }  $
         ,{desc2,'Ei'      , 'E_i'      ,'J/m^3'   ,1d-6/!cc.q_e ,'eV/cc'     , 0, [0,0,0] }  $
         ,{desc2,'Ef'      , 'E_f'      ,'J/m^3'   ,1d-6/!cc.q_e ,'eV/cc'     , 0, [0,0,0] }  $
         ,{desc2,'Et'      , 'E_t'      ,'J/m^3'   ,1d-6/!cc.q_e ,'eV/cc'     , 0, [0,0,0] }  $
         ,{desc2,'E_VXB'   , 'E-VxB'    ,'V/m'     ,1d3          ,'mV/m'      , 1, [3,0,0] }  $
         ,{desc2,'J_EN'    , 'J/en'     ,'m/s'     ,1d-3         ,'km/s'      , 1, [3,0,0] }  $
         ,{desc2,'FREQ'    , 'omega'    ,'1/s'     ,1d           ,'1/s'       , 1, [4,0,0] }  $
         ,{desc2,'VTH'     , 'Vth'      ,'m/s'     ,1d-3         ,'km/s'      , 1, [2,0,0] }  $
         ]


if size(dgn,/type) ne 8 then  dgn= replicate(define_state(diag),size(S,/dimen))


mn3 = [1,1,1] # s.mn
J_mn = s.J / mn3
dgn.eps= (!cc.mt/!cc.q_e) * s.rho/s.mn
epsilon3 = [1,1,1] # dgn.eps

N_e = s.mn/!cc.mt * (1- !cc.mp/!cc.mt * dgn.eps)
N_i = s.mn/!cc.mt * (1+ !cc.me/!cc.mt * dgn.eps)
dgn.Ve = (s.V - !cc.mp/!cc.q_e * J_mn)  /   (1-(!cc.mp/!cc.mt)*epsilon3)
dgn.Vi = (s.V + !cc.me/!cc.q_e * J_mn)  /   (1+(!cc.me/!cc.mt)*epsilon3)
dgn.Ee    = (!cc.me * N_e * dot_prod(dgn.Ve,dgn.Ve) + trace_3d(s.Pe))/2
dgn.Ei    = (!cc.mp * N_i * dot_prod(dgn.Vi,dgn.Vi) + trace_3d(s.Pi))/2
Pe_dot_Ve =0
for i=0,2 do Pe_dot_Ve += reform(s.Pe[i,*]) * dgn.Ve
dgn.Se = ([1,1,1] # dgn.Ee)*dgn.Ve + Pe_dot_Ve
Pi_dot_Vi =0
for i=0,2 do Pi_dot_Vi += reform(s.Pi[i,*]) * dgn.Vi
dgn.Si = ([1,1,1] # dgn.Ei)*dgn.Vi + Pi_dot_Vi
dgn.J_dot_E = dot_prod(S.J,S.E)
dgn.JxB   = cross_prod(S.J,S.B)
dgn.Sf     = cross_prod(S.E,S.B)/!cc.mu0
dgn.Div_Sf  = div(dgn.Sf)
dgn.eDiv_E = !cc.eps0 * div(S.E)  - S.rho
dgn.Ef    = dot_prod(S.B,S.B)/(2*!cc.mu0) + dot_prod(S.E,S.E)*(!cc.eps0/2)
;dgn.Div_Ep= div_2d(dgn.Ep)

dgn.E_VxB = s.E + cross_prod(s.V,S.B)
dgn.J_en    = !cc.mt/!cc.q_e * J_mn

Bmag = sqrt(total(s.B*s.B,1))
dgn.freq[0] = !cc.q_e/!cc.me * Bmag
dgn.freq[1] = !cc.q_e/!cc.mp * Bmag
dgn.freq[2] = sqrt(!cc.q_e^2/!cc.me/!cc.eps0 * n_e)
dgn.freq[3] = sqrt(!cc.q_e^2/!cc.mp/!cc.eps0 * n_i)

Te = trace_3d(s.Pe)/n_e / 3
dgn.vth[0] = sqrt(2*Te/!cc.me)
Ti = trace_3d(s.Pi)/n_i / 3
dgn.vth[1] = sqrt(2*Ti/!cc.mp)

dgn.et = dgn.ef + dgn.ee + dgn.ei

if keyword_set(debug) then stop

for i=0,n_tags(dgn)-1 do dgn.(i) *= diag[i].scale

end




pro init_coords,state,lattice,dim=dim,dscale=dscale,coordsys=coordsys

    if not keyword_set(coordsys) then coordsys = 'cartesian'
    if not keyword_set(dscale) then     dscale = 10d
    if not keyword_set(dim) then dim = [3,4,5]
    ndim = n_elements(dim)
    state=replicate(define_state(s_desc),dim)
    xr = dgen(dim[0],range=[0,1]*dscale)
    yr = dgen(dim[1],range=[0,1]*dscale)
    zr = dgen(dim[2],range=[0,1]*dscale)

    r_i = [0d,0d,0d]
    r_f = [1,1,1] * dscale

    ndim = n_elements(dim)
    bndry = uintarr(dim)
    if dim[0] gt 1 then bndry[0,*,*]        or= 1
    if dim[0] gt 1 then bndry[dim[0]-1,*,*] or= 2
    if dim[1] gt 1 then bndry[*,0,*]        or= 4
    if dim[1] gt 1 then bndry[*,dim[1]-1,*] or= 8
    if dim[2] gt 1 then bndry[*,*,0]        or= 16
    if dim[2] gt 1 then bndry[*,*,dim[2]-1] or= 32
    wbndry = where(bndry ne 0)
    tbndry = bndry[wbndry]
    state.bndry = bndry


    index = lindgen(dim)
    sindex_0m = shift(index,[+1,0,0])
    sindex_0p = shift(index,[-1,0,0])
    sindex_1m = shift(index,[ 0,+1,0])
    sindex_1p = shift(index,[ 0,-1,0])
    sindex_2m = shift(index,[ 0,0,+1])
    sindex_2p = shift(index,[ 0,0,-1])
    if keyword_set( set_boundary ) then begin
      sindex_0m[ 0 , * ,* ] = index[0, *, *]
      sindex_0p[ dim[0]-1 , * ,* ] = index[dim[0]-1, *, *]
      sindex_2m[ * , * ,0 ] = index[ *, *, 0]
      sindex_2p[*,*, dim[2]-1] = index[*, *, dim[2]-1]
    endif

    x0 =   outer_prod(xr    , yr*0+1, zr*0+1)
    x1 =   outer_prod(xr*0+1, yr    , zr*0+1)
    x2  =  outer_prod(xr*0+1, yr*0+1, zr    )
;    x = dblarr([ndim,dim])
    state.x[0] = x0
    state.x[1] = x1
    state.x[2] = x2

;    h = dblarr([ndim,dim])

 case coordsys of
 'spherical' : begin
    state.h[0] = dscale * 1
    state.h[1] = dscale * x0 * cos(x2)
    state.h[2] = dscale * x0
    end
 'cartesian' :  begin
    state.h[0] = dscale
    state.h[1] = dscale
    state.h[2] = dscale
    end
 endcase


;    O_h = dblarr([ndim,dim])
    state.O_h[0] = state.h[1] * state.h[2]
    state.O_h[1] = state.h[0] * state.h[2]
    state.O_h[2] = state.h[0] * state.h[1]

    state.Omega = state.h[0] * state.h[1] * state.h[2]

    state.dx[0] = state[sindex_0p].x[0] - state[sindex_0m].x[0]
    state.dx[1] = state[sindex_1p].x[1] - state[sindex_1m].x[1]
    state.dx[2] = state[sindex_2p].x[2] - state[sindex_2m].x[2]

    w = where(dim eq 1,nw)
    for i=0,nw-1 do state.dx[w[i]] = 1.

    lattice = {  $
    coords: coordsys, $
    scale: dscale, $
    ndim: ndim, $
    dim: dim, $
    dimscales: (r_f - r_i) / dim, $
    nd:  n_elements(state), $
    index: index, $
    si_0p: sindex_0p[*] , $
    si_0m: sindex_0m[*] , $
    si_1p: sindex_1p[*] , $
    si_1m: sindex_1m[*] , $
    si_2p: sindex_2p[*] , $
    si_2m: sindex_2m[*] , $
    wbndry: wbndry  ,$
    tbndry: tbndry  ,$
    xv: xr, $
    yv: yr, $
    zv: zr, $
    valid:1 }

;    wait,0 ;b p
    return
end



pro init_spherical,state,lattice,dim=dim

    if not keyword_set(dim) then dim = [9,1,11]
    ndim = n_elements(dim)
    state=replicate(define_state(s_desc),dim)
    dscale = 1d * !cc.r_sun
    rr = dgen(dim[0],range=[1,210]*dscale)
    phir = dgen(dim[1],range=[0,0])
    thr  = dgen(dim[2],range=60*[-1,1]*!dpi/180)


    ndim = n_elements(dim)
    bndry = uintarr(dim)
    if dim[0] gt 1 then bndry[0,*,*]        or= 1
    if dim[0] gt 1 then bndry[dim[0]-1,*,*] or= 2
    if dim[1] gt 1 then bndry[*,0,*]        or= 4
    if dim[1] gt 1 then bndry[*,dim[1]-1,*] or= 8
    if dim[2] gt 1 then bndry[*,*,0]        or= 16
    if dim[2] gt 1 then bndry[*,*,dim[2]-1] or= 32
    wbndry = where(bndry ne 0)
    tbndry = bndry[wbndry]
    state.bndry = bndry


    index = lindgen(dim)
    sindex_0m = shift(index,[+1,0,0])
    sindex_0m[ 0 , * ,* ] = index[0, *, *]
    sindex_0p = shift(index,[-1,0,0])
    sindex_0p[ dim[0]-1 , * ,* ] = index[dim[0]-1, *, *]

    sindex_1m = shift(index,[ 0,+1,0])
    sindex_1p = shift(index,[ 0,-1,0])

    sindex_2m = shift(index,[ 0,0,+1])
    sindex_2m[ * , * ,0 ] = index[ *, *, 0]
    sindex_2p = shift(index,[ 0,0,-1])
    sindex_2p[*,*, dim[2]-1] = index[*, *, dim[2]-1]

    x0 =   outer_prod(rr    , phir*0+1, thr*0+1)
    x1 =   outer_prod(rr*0+1, phir    , thr*0+1)
    x2  =  outer_prod(rr*0+1, phir*0+1, thr    )
;    x = dblarr([ndim,dim])
    state.x[0] = x0
    state.x[1] = x1
    state.x[2] = x2

;    h = dblarr([ndim,dim])
    state.h[0] = dscale * 1
    state.h[1] = dscale * x0 * cos(x2)
    state.h[2] = dscale * x0

;    O_h = dblarr([ndim,dim])
    state.O_h[0] = state.h[1] * state.h[2]
    state.O_h[1] = state.h[0] * state.h[2]
    state.O_h[2] = state.h[0] * state.h[1]

    state.Omega = state.h[0] * state.h[1] * state.h[2]

    state.dx[0] = state[sindex_0p].x[0] - state[sindex_0m].x[0]
    state.dx[1] = state[sindex_1p].x[1] - state[sindex_1m].x[1]
    state.dx[2] = state[sindex_2p].x[2] - state[sindex_2m].x[2]

    w = where(dim eq 1,nw)
    for i=0,nw-1 do state.dx[w[i]] = 1.

    lattice = {  $
    coords: 'Spherical', $
    ndim: ndim, $
    dim: dim, $
    nd:  n_elements(state), $
    index: index, $
    si_0p: sindex_0p[*] , $
    si_0m: sindex_0m[*] , $
    si_1p: sindex_1p[*] , $
    si_1m: sindex_1m[*] , $
    si_2p: sindex_2p[*] , $
    si_2m: sindex_2m[*] , $
    wbndry: wbndry  ,$
    tbndry: tbndry  ,$
    rv: rr, $
    pv: phir, $
    tv: thr, $
    valid:1 }

;    wait,0 ;b p
    return
end


pro splot,z,state,ll,ztitle=ztitle,zrange=zrange

  if not keyword_set(ztitle) then ztitle=''

  si = [-3,-2,-1,0,1,2,3]
  cdim = ll.dim / 2
  ind = ll.index[cdim[0]+si,0,cdim[2]+si]
  zz = z[ind]
  print,ztitle
  print,zz

  if not keyword_set(zrange) then zrange = minmax(z[ where(state.bndry eq 0) ])
  lim = { $
     zrange:zrange , $
     ztitle:ztitle $
  }
  specplot,/no_interp,ll.rv/!cc.r_sun,ll.tv*180/!dpi, reform(z) ,lim=lim


end




pro init_state_sw,s,ll,ngrid=ngrid  ; ,s_desc=s_desc

if not keyword_set(ngrid) then ngrid = 5
init_spherical,s,ll,dim=ngrid*[10,0,8] + 1

R0= !cc.r_sun
B1= 4.d-9   ; Tesla
R1= 210 * R0
B0= B1 * (R1/R0)^2

w_sun = 1/28./24./3600d ; 1/sec
Vc = 400e3      ;  m/s
Rs = 7d8        ; m

RW_V = Rs*w_sun/Vc * 10 ;???
;z = s.x[0] * sin(s.x[2])
;stpf = ( 1-erfc(2*z/R0) )
stpf = ( 1-erfc(2*s.x[2]) )


s.B[0] =  B0 * R0^2 / s.x[0]^2   * stpf
s.B[1] = -B0 * RW_V * R0/s.x[0] * cos(s.x[2])   * stpf
s.B[2] = 0

b_dip = B0/2
;s.B = 0
;s.B[0] += 2*B_dip* (R0/s.x[0])^3  * sin(s.x[2])
;s.B[2] +=  -B_dip* (R0/s.x[0])^3  * cos(s.x[2])

s.J = curl(s.B,s,ll) / !cc.mu0   ;  s.j[0] , s.j[1] , s.j[2]


s.v=0
s.v[0] = vc

dens = .049d *1e6
s.mn = !cc.Mt * dens

;s.J = curl(s.B,s,ll) / !cc.mu0
s.E = cross_prod(s.B,s.V)  ; + other ohms law terms

s.rho = !cc.eps0 * div(s.E,s,ll)

jxb = cross_prod(s.J,s.B)
rhoE =  outer_prod([1,1,1] , s.rho) * s.E
FF =  JxB  + rhoE

pmag = 0
for i=0,2 do pmag += s.b[i]^2/2/!cc.mu0
pmax = max(pmag)*1.1

pt = pmax - (-s.b[0]^2 + s.b[1]^2 + s.b[2]^2)/2/!cc.mu0 - s.mn * s.v[0]^2

s.pi=0
s.pi[0,0] = pt/2
s.pi[1,1] = pt/2
s.pi[2,2] = pt/2
s.pe = s.pi

;ds = ds_dt(s)
;printdat,ds
; try to force dj/dt to be zero
;s.E -= !cc.mp*!cc.me/!cc.q_e^2 * ds.J/([1,1,1] # s.mn)
;s.rho = !cc.eps0* div_2d(s.e,s.r)
return  ;,s
end




setbp,/thisfile

init_state_sw,s,ll,ngrid=5
  si = [-3,-2,-1,0,1,2,3]
  cdim = ll.dim / 2
  ind = ll.index[cdim[0]+si,0,cdim[2]+si]
  ss = s[ind]
  printdat,ll.dim
  b = sqrt(total(s.b^2,1) )
  r = s.x[0]

  db = div(s.b,s,ll)
  splot, db*r/b,s,ll ,ztitle='r*del.B/B'  ; bp

  splot, s.b[0]/b  ,s,ll, zrange=[-1,1] ,ztitle='b[0]/B' ;bp
  splot, s.b[1]/b  ,s,ll, zrange=[-1,1] ,ztitle='b[1]/B' ;bp
  splot, s.b[2]/b  ,s,ll, zrange=[-1,1] ,ztitle='b[2]/B' ;bp

  splot, s.j[0] /b ,s,ll ,ztitle='j[0]/B' ;bp
  splot, s.j[1] /b ,s,ll ,ztitle='j[1]/B' ;bp
  splot, s.j[2] /b ,s,ll ,ztitle='j[2]/B' ;bp

  splot, s.j[0]*r*!cc.mu0 / b ,s,ll ,ztitle='j[0]*r/B' ;bp
  splot, s.j[1]*r*!cc.mu0 / b ,s,ll ,ztitle='j[1]*r/B' ;bp
  splot, s.j[2]*r*!cc.mu0 / b ,s,ll ,ztitle='j[2]*r/B' ;bp

end
