



secs_per_year  = 365.25*24*3600.      ; seconds
Period_sun  = 27d*24*3600.   ;  seconds
w_sun = 2*!pi/period_sun     ; rad/sec


R_sun = 6.960d8        ; m
M_sun = 1.9891d30      ; kg
G_c   = 6.67300d-11    ;  m3 kg-1 s-2
au  = 150d9        ; m

Vsw_E = 500d3   ; m /s
nsw_E = 5d6   ;  m-3
Mp    = 1.6726d-27   ; kg
Me  = Mp /1836  ; kg
Mt = Mp+Me  ; kg

massflux = Mt * nsw_E *  Vsw_E     ; kg /s / m2

masslossrate = massflux * 4*!dpi * au^2   ; kg/s

print, M_sun/ masslossrate / secs_per_year  ,' years'

energyflux = .5 * mp * nsw_E * vsw_E^3   ; kg/m^3*(m/s)^3
energylossrate = energyflux *4*!dpi *au^2   ; J/s

I_sun = 2./5.*m_sun*R_sun^2
rotational_energy_sun = .5 * I_sun * w_sun^2

print, rotational_energy_sun / energylossrate  / secs_per_year , ' years'


c = 299792458.   ; m/s
q_e = 1.6022d-19    ; C
mu0  = 4*!dpi*1e-7  ;  N/A^2
eps0 = 1/c^2/mu0   ;  C2 N-1 m-2

r = dgen(200,[1,220.],/log)

vel_e =  Vsw_E
dens = Vsw_E*Nsw_E / Vel_e / (r/au*r_sun)^2
T_e = 100   ; eV
E_delPe = - Mp/Mt * deriv(r*R_sun,dens*T_e) /dens

E_par = E_delPe
div_E = deriv(r*R_sun, E_par * r^2) / r^2
div_E = deriv(r*R_sun, E_par * (r*r_sun)^2) / (r*r_sun)^2
rho_c = eps0 * div_E

eps = rho_c / dens / q_e

L_ohm = eps0*Me*M_sun*G_c/q_e^2/(nsw_E*au^2)

print,Me/q_e * G_c*M_sun/(r*r_sun)^2


;j = curl_sph2(B,grid)/mu0
;E = -cross_sph2(vel,B,grid) + eta(rho,e_press,grid)*j

;curl_sph2(E) = 0





end
