pro thm_handle_packet_61,pkt

name = 'FGM'

ps = thm_pkt_status(pkt)

config = pkt[12]
message= pkt[13]
xrange = pkt[14] / 16
yrange = pkt[14] mod 16
zrange = pkt[15] / 16

range = [[xrange],[yrange],[zrange]]

Bx = fix(pkt[17:*:6] * 256 + pkt[16:*:6])
By = fix(pkt[19:*:6] * 256 + pkt[18:*:6])
Bz = fix(pkt[21:*:6] * 256 + pkt[20:*:6])
dt = 0.0077841312d
time = ps.time + dindgen(n_elements(bx))*dt
Bvec = [[Bx],[By],[Bz]]

if n_elements(bx) ne 512 then message,'Bad FGM packet'

get_data,name,ptr=p
if not keyword_set(p) then begin
   store_data,name,data={x:ptr_new(time),y:ptr_new([[Bx],[By],[Bz]]) ,i:ptr_new(n_elements(time))}
endif else begin
   i = *p.i
   append_array,*p.x,time   ;,index=*p.i
   append_array,*p.y,Bvec
   *p.i = n_elements(*p.x)
endelse

;stop
end