

function eflux2,nrg,ph,th,param=pp    ; q assumed to be +1 or -1
if not keyword_set(pp) then begin
   pp = {q:-1, mass:511000.d/299792.d^2, density: 10.d,  vel: [100.d,5d,-5d],  $
          Ttens: 1000d * [1,1,1,.05,-.025,.025d], qflux:[0d,0,0]  , pot:0d ,photo:0}
endif
if n_params() eq 0 then return,pp

dim = size(/dimension,nrg)
if array_equal(dim,size(/dimension,ph)) eq 0 then message,'Bad input'
if array_equal(dim,size(/dimension,th)) eq 0 then message,'Bad input'

npts = n_elements(nrg)

sinph = sind(ph)
cosph = cosd(ph)
sinth = sind(th)
costh = cosd(th)
sx = cosph * costh  ;sx = reform( cosph # costh ,nth*nph)
sy = sinph * costh  ;sy = reform( sinph # costh,nth*nph)
sz = sinth          ;  sz = reform( replicate(1,nph) # sinth,nth*nph)

map = [[0,3,4],[3,1,5],[4,5,2]]

eflx=0
for j=0,n_elements(pp)-1 do begin
p=pp[j]
    mass = p.mass
    q = p.q
    pot = p.pot
    ttens = p.ttens[map]
    ivv = invert(2*ttens/mass)

    nrg_inf = nrg+q*pot
    w = where(nrg_inf lt 0,nw)
    if nw gt 0 then nrg_inf[w] = !values.f_nan
    v  = velocity(nrg_inf,mass)

    vx = reform(v * sx, npts)   ;vx = reform( v # sx , npts)
    vy = reform(v * sy, npts)   ;vy = reform( v # sy , npts)
    vz = reform(v * sz, npts)   ;vz = reform( v # sz , npts)

    dvel = [[vx-p.vel[0]],[vy-p.vel[1]],[vz-p.vel[2]]]

    x =  total(dvel * (ivv ## dvel) , 2)
    f =  p.density / !dpi^1.5 * (determ(ivv))^.5  * exp(-x)         ; s^3/cm^3/km^3
    w = where(finite(x) eq 0,nw)
    if nw gt 0 then f[w] = 0
    eflx += f * 2 / mass^2 * (reform(nrg,npts)^2) * 1e5   ; #/cm^2/s/ster
endfor
eflx= reform(eflx,dim)

if p.photo then begin
    dprint,'Photo eflux'
;    message,'Not working? ...',/info
    ind = where(nrg + p.q * p.pot lt 0,n)
    if n gt 0 then begin
       phe =  themis_photo_eflux(nrg[ind])
       for i=0,n-1 do eflx[ind[i]] = phe[i]
    endif
endif

return,eflx
end


