


function thm_etc_simulated_counts,steps,parameter=p,seed,testpulse=testpulse
if not keyword_set(p) then p = eflux2()
;p.mass = steps.mass
;p.q = steps.q

if keyword_set(testpulse) then begin
  if steps.name eq 'eesa' or steps.name eq 'iesa' then begin
   c = reform(steps.dacvals[0,*])
   c = rshft(rshft(c,3)+1,1)
   c = replicate(1u,nthe) # c
   counts = reform(c[*] # replicate(1u,nphi),nthe,nnrg,nphi)
   return,counts
  endif
  if steps.name eq 'foil' or steps.name eq 'open' then begin
   counts = replicate(0,nthe,nnrg,nphi)
   counts[*,9,*] = 39
   ;counts[*,9,*] = 2
   return,counts
  endif
  message,'Incorrect instrument name'
endif

if 1 then begin
    if steps.inst eq 'ESA' then begin
      nthe = n_elements(steps.theta)
      nnrg = n_elements(steps.nrg)
      nphi2 = n_elements(steps.phi) / steps.mode
      nesteps = nnrg / steps.mode
      theta = outer_prod( steps.theta,    replicate(1,nnrg) , replicate(1,nphi2) )
      nrg = outer_prod( steps.theta*0+1 , steps.nrg   ,      replicate(1,nphi2) )
;      phi_t =  (dindgen(nnrg,nphi2)+.5d) * 360d / (nnrg*nphi2)
      phi_t =  steps.phi(indgen(nnrg,nphi2)/nesteps)
      phi = outer_prod( steps.theta*0+1 , phi_t )
      geom = outer_prod( steps.tgeom, steps.egeom, replicate(steps.gf,nphi2) )
    endif
    if steps.inst eq 'SST' then begin
      theta = steps.theta3
      nrg   = steps.nrg3
      phi   = steps.phi3
      geom  = steps.geom3
    endif
    ef = eflux2(nrg,phi,theta,param=p)
endif else begin
    nrg = steps.nrg
    phi = steps.phi
    theta = steps.theta
    nnrg = n_elements(nrg)
    nthe = n_elements(theta)
    if size(/n_dimen,phi) eq 2 then $
        phi = average(phi,1)
    nphi = n_elements(phi)
    ef = eflux(nrg,phi,theta,param=p)
    ef = transpose(counts,[2,0,1])
    geom = reform(steps.tgeom # reform(steps.egeom # replicate(1,nphi),nnrg*nphi) ,nthe,nnrg,nphi) * steps.gf
endelse


counts = ef * geom * steps.dt
if keyword_set(seed) then counts = randomp(counts,seed)
return,counts
end


