FUNCTION get_th_456,time,START=st,EN=en,ADVANCE=adv,RETREAT=ret,calib=calib

common th_e3d_456,get_ind,all_dat

decompress=1.*[indgen(16),16+2*indgen(8),32+4*indgen(24),128+8*indgen(16),256+16*indgen(16),$
	512+32*indgen(16),1024+64*indgen(16),2048+128*indgen(48),8192+256*indgen(32),$
	16384+512*indgen(32),32768+1024*indgen(32)]

if (n_elements(time) eq 0) and (not keyword_set(st)) and (not keyword_set(en)) $
        and (not keyword_set(adv)) and (not keyword_set(ret)) then ctime,time,npoints=1

tmpmin = min(abs(all_dat.time-time),ind)
if keyword_set(st) then ind=0
if keyword_set(en) then ind=n_elements(all_dat.time)-1 
if keyword_set(adv) then ind=get_ind+1
if keyword_set(ret) then ind=get_ind-1

if ind lt 0 or ind ge n_elements(all_dat.time) then begin

dat = 		{project_name:		all_dat.project_name,		$
		data_name:		all_dat.data_name, 		$
		data_product:		all_dat.data_product,		$
		valid: 			0}

endif else begin

	nenergy=all_dat.nenergy(all_dat.en_ind(ind))
	nbins=88
	en_ind=all_dat.en_ind(ind)
	energy =reform( all_dat.energy(*,en_ind))#replicate(1.,88)
	denergy=reform(all_dat.denergy(*,en_ind))#replicate(1.,88)
	eff=reform(all_dat.eff(*,en_ind))#replicate(1.,88)
	counts=decompress(reform(all_dat.data(ind,*,*)))
	bins=all_dat.bins
	theta=all_dat.theta
	dtheta=all_dat.dtheta
	phi=all_dat.phi
	dphi=all_dat.dphi
	domega=all_dat.domega
	if nenergy eq 16 then begin
		nbins=176
		bins=reform(bins,16,176)
		energy=reform(energy,16,176)
		denergy=reform(denergy,16,176)
		eff=reform(eff,16,176)
		counts=reform(counts,16,176)
		theta=reform(theta,16,176)
		dtheta=reform(dtheta,16,176)
		phi=reform(phi,16,176)
		dphi=reform(dphi,16,176)
		domega=reform(domega,16,176)
	endif

dat = 		{project_name:		all_dat.project_name,		$
		data_name:		all_dat.data_name, 		$
		data_product:		all_dat.data_product,		$
		units_name: 		'counts', 			$
		units_procedure: 	all_dat.units_procedure, 	$
		valid: 			all_dat.valid, 			$
		time: 			all_dat.time(ind), 		$
		end_time: 		all_dat.end_time(ind), 		$
		delta_t: 		all_dat.delta_t(ind),		$
		integ_t: 		all_dat.integ_t(ind),		$
		geom_factor: 		all_dat.geom_factor(ind), 	$
		nenergy: 		nenergy, 			$
		nbins: 			nbins,	 			$
		bins: 			bins, 				$
		energy: 		energy, 			$
		denergy: 		denergy,     		 	$
		en_ind:			all_dat.en_ind(ind),		$
		theta: 			theta,  			$
		dtheta: 		dtheta,  			$
		phi: 			phi,  				$
		dphi: 			dphi,	  			$
		domega: 		domega,  			$
		eff: 			eff,	 			$
		mass: 			all_dat.mass, 			$
		gf: 			all_dat.gf, 			$
		charge: 		all_dat.charge, 		$
		sc_pot: 		all_dat.sc_pot(ind), 		$
		data: 			counts}
get_ind=ind

endelse

return,dat

end
