FUNCTION get_th_458,time,START=st,EN=en,ADVANCE=adv,RETREAT=ret,calib=calib

common th_e3d_458,get_ind,all_dat

decompress=1.*[indgen(16),16+2*indgen(8),32+4*indgen(24),128+8*indgen(16),256+16*indgen(16),$
	512+32*indgen(16),1024+64*indgen(16),2048+128*indgen(48),8192+256*indgen(32),$
	16384+512*indgen(32),32768+1024*indgen(32)]

if (n_elements(time) eq 0) and (not keyword_set(st)) and (not keyword_set(en)) $
        and (not keyword_set(adv)) and (not keyword_set(ret)) then ctime,time,npoints=1

if keyword_set(st) then ind=0 $
	else if keyword_set(en) then ind=n_elements(all_dat.time)-1 $
	else if keyword_set(adv) then ind=get_ind+1 $
	else if keyword_set(ret) then ind=get_ind-1 $
	else tmpmin = min(abs(all_dat.time-time),ind)

if ind lt 0 or ind ge n_elements(all_dat.time) then begin

dat = 		{project_name:		all_dat.project_name,		$
		data_name:		all_dat.data_name, 		$
		data_product:		all_dat.data_product,		$
		valid: 			0}

endif else begin

	time=all_dat.time(ind)

	en_ind=all_dat.en_ind(ind)
	nenergy=all_dat.nenergy
	nbins=all_dat.nbins
	bins=replicate(1,nbins)

	energy =reform( all_dat.energy(*,en_ind))#replicate(1.,nbins)
	denergy=reform(all_dat.denergy(*,en_ind))#replicate(1.,nbins)
	eff    =reform(all_dat.eff(*,en_ind))    #replicate(1.,nbins)

	counts=decompress(reform(all_dat.data(ind,*,*)))
	valid=all_dat.valid

dat = 		{project_name:		all_dat.project_name,		$
		data_name:		all_dat.data_name, 		$
		data_product:		all_dat.data_product,		$
		units_name: 		'counts', 			$
		units_procedure: 	all_dat.units_procedure, 	$
		valid: 			valid, 				$
		time: 			all_dat.time(ind), 		$
		end_time: 		all_dat.end_time(ind), 		$
		delta_t: 		all_dat.delta_t(ind),		$
		integ_t: 		all_dat.integ_t(ind),		$
		dt_arr: 		all_dat.dt_arr,			$
		dead: 			1.e-7,				$
		geom_factor: 		all_dat.geom_factor(ind), 	$
		nenergy: 		nenergy, 			$
		nbins: 			nbins,	 			$
		bins: 			bins, 				$
		energy: 		energy, 			$
		denergy: 		denergy,     		 	$
		eff: 			eff,	 			$
		en_ind:			en_ind,				$
		theta: 			all_dat.theta,  		$
		dtheta: 		all_dat.dtheta,  		$
		phi: 			all_dat.phi,  			$
		dphi: 			all_dat.dphi,	  		$
		domega: 		all_dat.domega,  		$
		gf: 			all_dat.gf, 				$
		mass: 			all_dat.mass, 			$
		charge: 		all_dat.charge, 		$
		sc_pot: 		all_dat.sc_pot(ind), 		$
		data: 			counts}
get_ind=ind

endelse

return,dat

end
