;Read ESA APID 453 - ESA and SST Moments [212 bytes/spin x 16 spins]
;Assumes a fixed size for the packets
;Energy sweep determination requires definition

pro read_esagse_apid453,file=file,range=range,nsamples=nsamples,adat=adat,time=time,tshiftparam=tshiftparam,time_order=time_order

cols=get_colors()
sat='1'
if not keyword_set(file) then file = dialog_pickfile(filter='*_453.pkt')
openr, fp, file, /get_lun
fs = fstat(fp)
printdat,fs
if keyword_set(range) then begin
  ptr = round(double(range)*fs.size/3408) *3408
  point_lun,fp,ptr[0]
  nrec = (ptr[1]-ptr[0])/ 3408
endif else if keyword_set(nsamples) then begin
  ptr = fs.size-nsamples*3408l
  if ptr lt 0 then begin
    ptr=0
    nrec=fs.size/3408
  endif else nrec=nsamples
  point_lun,fp,ptr
endif else nrec = fs.size / 3408
dat = {	vers:bytarr(1),		$
	apid:bytarr(1), 	$
	sequ:bytarr(1), 	$
	cntr:bytarr(1), 	$
	leng:bytarr(2), 	$
	time:bytarr(6), 	$
	etc:bytarr(4), 		$
	dat:bytarr(212,16)}
adat = replicate(dat,nrec)


readu,fp,adat
free_lun,fp

tt=adat.time
time = 1.d*((tt(0,*)*256ul+tt(1,*))*256ul+tt(2,*))*256ul + tt(3,*) + (tt(4,*)+tt(5,*)/256.d)/256.
time = reform(time)
if keyword_set(time_order) then begin
	dat=adat.dat
	wset,1
	plot,time-time(0),psym=1,ytitle='Seconds after first packet',xtitle='Packet Number',title='APID 453'					; test for time order
	wset,2
	cntr=reform(adat.cntr) & npkts=n_elements(cntr)
	plot,cntr,psym=1,ytitle='APID Counter',xtitle='Packet Number',title='APID 453'
	oplot,10*(cntr(1:npkts-1)-cntr(0:npkts-2)-1) < 200,psym=0,color=cols.red
	for i=0,nrec-1 do begin
		ind=where(cntr(i) eq cntr,count)
		if count gt 1 then begin
			print,i,'  duplicate packet',ind
			print,total(dat(*,*,ind(0))),'data differ=',total(dat(*,*,ind(0))-dat(*,*,ind(1)))
		endif
	endfor
	popen,/port,'453_packet_order'
		plot,time-time(0),psym=1,ytitle='Seconds after first packet',xtitle='Packet Number',title='APID 453'					; test for time order
		plot,adat.cntr,psym=1,ytitle='APID Counter',xtitle='Packet Number',title='APID 453'
	pclose
	print,'Exiting time order'
endif
time0 = time_double('1900-1-1')		
tmp_time=time+time0						; assume no delay for header creation

spin16_period=(tmp_time(1:nrec-1)-tmp_time(0:nrec-2))/16.
ind=where(spin16_period lt 16.5*3.,count)
spin_period=total(spin16_period)/(16.*count)
spin_period=3.

end_time=dblarr(16l*nrec)
start_time=dblarr(16l*nrec)

tmp=adat.dat
status=reform(tmp(0:1,*,*),2,16*nrec)
sc_pot=reform(tmp(2,*,*),16*nrec)+256l*reform(tmp(3,*,*),16*nrec)
idat=transpose(reform(tmp(4:55,*,*),4,13,16l*nrec))
help,idat
edat=transpose(reform(tmp(56:107,*,*),4,13,16l*nrec))
sstdat=transpose(reform(tmp(108:211,*,*),104,16l*nrec))
imom=reform(idat(*,*,0))+256l*reform(idat(*,*,1))+256l^2*reform(idat(*,*,2))+256l^3*reform(idat(*,*,3))
emom=reform(edat(*,*,0))+256l*reform(edat(*,*,1))+256l^2*reform(edat(*,*,2))+256l^3*reform(edat(*,*,3))

for i=0,nrec-1 do begin
	for j=0,15 do start_time(i*16+j)=tmp_time(i)-(16-j)*spin_period		
endfor	
	end_time=start_time + spin_period					

help,imom
	
;***********************************************************************************
; Make tplot structures

store_data,'Vsc_'+sat,data={x:(start_time+end_time)/2.,y:sc_pot}
	ylim,'Vsc_'+sat,0,0,0

n_i=reform(imom(*,0))
store_data,'Ni_'+sat,data={x:(start_time+end_time)/2.,y:n_i}
	ylim,'Ni_'+sat,0,0,0

v_i=imom(*,1:3)/(n_i#replicate(1.,3))
store_data,'Vi_'+sat,data={x:(start_time+end_time)/2.,y:v_i}
	ylim,'Vi_'+sat,0,0,0

p_i=imom(*,4:9) & p_i(*,0:2)=p_i(*,0:2)-imom(*,1:3)*v_i
store_data,'Pi_'+sat,data={x:(start_time+end_time)/2.,y:p_i}
	ylim,'Pi_'+sat,0,0,0

q_i=imom(*,10:12)
store_data,'Qi_'+sat,data={x:(start_time+end_time)/2.,y:q_i}
	ylim,'Qi_'+sat,0,0,0

n_e=reform(emom(*,0))
store_data,'Ne_'+sat,data={x:(start_time+end_time)/2.,y:n_e}
	ylim,'Ne_'+sat,0,0,0

v_e=emom(*,1:3)/(n_e#replicate(1.,3))
store_data,'Ve_'+sat,data={x:(start_time+end_time)/2.,y:v_e}
	ylim,'Ve_'+sat,0,0,0

p_e=emom(*,4:9) & p_e(*,0:2)=p_e(*,0:2)-emom(*,1:3)*v_e
store_data,'Pe_'+sat,data={x:(start_time+end_time)/2.,y:p_e}
	ylim,'Pe_'+sat,0,0,0

q_e=emom(*,10:12)
store_data,'Qe_'+sat,data={x:(start_time+end_time)/2.,y:q_e}
	ylim,'Qe_'+sat,0,0,0

tplot,['Vsc_'+sat,'Ni_'+sat,'Vi_'+sat,'Pi_'+sat,'Qi_'+sat,'Ne_'+sat,'Ve_'+sat,'Pe_'+sat,'Qe_'+sat]

end
