;
pro read_esagse_raw,file=file,range=range,nsamples=nsamples,adat=adat,time=time,tshiftparam=tshiftparam,dlsavings=dlsavings
if not keyword_set(file) then file = dialog_pickfile(filter='*.raw')
openr, fp, file, /get_lun
fs = fstat(fp)
printdat,fs
;if keyword_set(range) then begin
;  ptr = round(double(range)*fs.size/1546) *1546
;  point_lun,fp,ptr[0]
;  nrec = (ptr[1]-ptr[0])/ 1546
;endif else nrec = fs.size / 1546
if keyword_set(range) or keyword_set(nsamples) then begin
  if keyword_set(range) then begin
	ptr = round(double(range)*fs.size/1546) *1546
  	point_lun,fp,ptr[0]
 	nrec = (ptr[1]-ptr[0])/ 1546
  endif else begin
	print,fs.size
	print,fs.size-nsamples*1546l
	point_lun,fp,fs.size-nsamples*1546l
	nrec=nsamples
  endelse
endif else nrec = fs.size / 1546
dat = {t:bytarr(10), $
       s:uintarr(768)}
adat = replicate(dat,nrec)

print,'Read data in'
readu,fp,adat
free_lun,fp
tt=adat.t
time = 1.d*((tt(4,*)*256ul+tt(5,*))*256ul+tt(6,*))*256ul + tt(7,*) + (tt(8,*)+tt(9,*)/256.d)/256.
time0 = time_double('1900-1-1')-3600d*8			; convert to UT, assume PST
;if keyword_set(dlsavings) time0=time0-3600d		; convert to daylight savings
time=time+time0	
dt=time(11)-time(10)
t=replicate(1.,32)#time
for i=1,31 do t(i,*)=t(i,*)+i*dt/32.
t=reform(t,nrec*32)

print,'Make tplot structures'
sdat=transpose(reform(adat.s,24,nrec*32l))
byteorder,sdat,/swap_if_little_endian
store_data,'IESA_Sweeps',data={x:t,y:sdat(*,0:15),v:findgen(16)}
	max_iesa=max(sdat(*,0:15))
	ylim,'IESA_Sweeps',.5,max_iesa*1.1,1
	options,'IESA_Sweeps','labels',strcompress(string(indgen(16)))
	options,'IESA_Sweeps','labflag',1
	options,'IESA_Sweeps','labpos',max_iesa^findgen(16)/16.
store_data,'IESA_Spec',data={x:t,y:sdat(*,0:15),v:findgen(16)}
	options,'IESA_Spec','spec',1
	options,'IESA_Spec','x_no_interp',1
	options,'IESA_Spec','y_no_interp',1
store_data,'EESA_Sweeps',data={x:t,y:sdat(*,16:23),v:findgen(8)}
	max_eesa=max(sdat(*,16:23))
	ylim,'EESA_Sweeps',.5,max_eesa*1.1,1
	options,'EESA_Sweeps','labels',strcompress(string(indgen(8)))
	options,'EESA_Sweeps','labflag',1
	options,'EESA_Sweeps','labpos',max_eesa^findgen(8)/8.
store_data,'EESA_Spec',data={x:t,y:sdat(*,16:23),v:findgen(8)}
	options,'EESA_Spec','spec',1
	options,'EESA_Spec','x_no_interp',1
	options,'EESA_Spec','y_no_interp',1

print,'Plot the data'
;tplot,['EESA_Sweeps','EESA_Spec','IESA_Sweeps','IESA_Spec']
tplot,['EESA_Spec','IESA_Spec']
if keyword_set(nsamples) then wait,2

; Make 2D data structures
print,'Make the 2D structure'

dat=transpose(reform(adat.s,24,32,nrec))
byteorder,dat,/swap_if_little_endian

theta=78.75-findgen(8)*22.5
dtheta=22.5
p0=theta+dtheta/2.
p1=theta-dtheta/2.
domega=2*!pi*(sin(p0/!radeg)-sin(p1/!radeg))
energy=1.#findgen(32)
denergy=1.#findgen(32)
en_swp=replicate(0,nrec)
geom_factor=0.001

e2d_dat = 	{project_name:		'THEMIS I&T',				$
		data_name:		'EESA 2D', 				$
		data_product:		0,					$
		units_name: 		'counts', 				$
		units_procedure: 	'convert_themis_units', 		$
		valid: 			1, 					$
		time: 			time,	 				$
		end_time: 		time+dt, 				$
		delta_t: 		replicate(dt,nrec),			$
		integ_t: 		replicate(dt/32.,nrec),			$
		geom_factor: 		replicate(geom_factor,nrec),		$
		nenergy: 		32, 					$
		nbins: 			8, 					$
		bins: 			replicate(1,32,8), 			$
		energy: 		energy, 				$
		denergy: 		denergy, 				$
		en_swp:			en_swp,					$
		theta: 			replicate(1.,32)#theta,		  	$
		dtheta: 		replicate(1.,32,8)*dtheta,  		$
		domega: 		replicate(1.,32)#domega,  		$
		eff: 			1.,	 				$
		mass: 			5.68566e-06, 				$
		gf: 			replicate(1.,32,8), 			$
		charge: 		-1., 					$
		sc_pot: 		replicate(0.,nrec), 			$
		data: 			reform(dat(*,*,16:23))}
common th_e2d,th_e2d_ind,all_e2d & all_e2d=e2d_dat


dtheta=[22.5,22.5,11.25,11.25,5.625,5.625,5.625,5.625,5.625,5.625,5.625,5.625,11.25,11.25,22.5,22.5]
theta=fltarr(16)
for i=0,15 do theta(i)=90.-total(dtheta(0:i))+dtheta(i)/2.
gf=dtheta/22.5
p0=theta+dtheta/2.
p1=theta-dtheta/2.
domega=2*!pi*(sin(p0/!radeg)-sin(p1/!radeg))
energy=1.#findgen(32)
denergy=1.#findgen(32)
en_swp=replicate(0,nrec)
geom_factor=.001


i2d_dat = 	{project_name:		'THEMIS I&T',				$
		data_name:		'IESA 2D', 				$
		data_product:		0,					$
		units_name: 		'counts', 				$
		units_procedure: 	'convert_themis_units', 		$
		valid: 			1, 					$
		time: 			time,	 				$
		end_time: 		time+dt, 				$
		delta_t: 		replicate(dt,nrec),			$
		integ_t: 		replicate(dt/32.,nrec),			$
		geom_factor: 		replicate(geom_factor,nrec),		$
		nenergy: 		32, 					$
		nbins: 			16, 					$
		bins: 			replicate(1,32,16), 			$
		energy: 		energy, 				$
		denergy: 		denergy, 				$
		en_swp:			en_swp,					$
		theta: 			replicate(1.,32)#theta,  		$
		dtheta: 		replicate(1.,32)#dtheta,  		$
		domega: 		replicate(1.,32,16)*22.5,  		$
		eff: 			1.,	 				$
		mass: 			1.0438871e-02, 				$
		gf: 			replicate(1.,32)#gf, 			$
		charge: 		1., 					$
		sc_pot: 		replicate(0.,nrec), 			$
		data: 			reform(dat(*,*,0:15))}
common th_i2d,th_i2d_ind,all_i2d & all_i2d=i2d_dat

print,'Finished'

end
