;
pro read_idpugse_log,file
lt_to_ut=7.*3600.
cols=get_colors()
if not keyword_set(file) then file = dialog_pickfile(filter='*.log')
openr, fp, file, /get_lun
fs = fstat(fp)
;printdat,fs

a=string(100)
cc=replicate(a,10000)

n=0
while not eof(fp) do begin
	readf,fp,a
	cc(n)=a
	n=n+1
endwhile

close,fp

cc=cc(0:n-1)

ind = where(strpos(cc,'-20') ne -1)	; in case file has extra returns
cc=cc(ind)
n=n_elements(ind)

; get first and last time
	yr=strmid(cc(0),8,2)
	mo=strmid(cc(0),0,2)
	da=strmid(cc(0),3,2)
	ti=strmid(cc(0),11,8)
	t0=str_to_time(yr+'-'+mo+'-'+da+'/'+ti) + lt_to_ut
	yr=strmid(cc(n-1),8,2)
	mo=strmid(cc(n-1),0,2)
	da=strmid(cc(n-1),3,2)
	ti=strmid(cc(n-1),11,8)
	t1=str_to_time(yr+'-'+mo+'-'+da+'/'+ti) + lt_to_ut

; make structures for CDI command 0x03
ind = where(strpos(cc,'/ipcbrawhex 0x03') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,2))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,2))]
	store_data,'0x03',data={x:time,y:log_v}
	options,'0x03','ytitle','TP DAC'
	ylim,'0x03',-10.,270.,0
endif

; make structures for CDI command 0x04
ind = where(strpos(cc,'/ipcbrawhex 0x04') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,1))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,1))]
	lin_v=fltarr(2+count*2)
	lin_v(ind1)=[0,hexval(strmid(cc(ind),39,1))]+.1
	lin_v(ind2)=[0,hexval(strmid(cc(ind),39,1))]+.1
	store_data,'0x04',data={x:time,y:[[log_v],[lin_v]]}
	options,'0x04','ytitle','i+ 0-7 MASK'
	ylim,'0x04',-1.,16.,0
	options,'0x04','labels',['MSB','LSB']
	options,'0x04','labpos,[2,6]
	options,'0x04','labflag',1
	options,'0x04','colors',[cols.red,cols.green]
endif

; make structures for CDI command 0x05
ind = where(strpos(cc,'/ipcbrawhex 0x05') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,1))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,1))]
	lin_v=fltarr(2+count*2)
	lin_v(ind1)=[0,hexval(strmid(cc(ind),39,1))]+.1
	lin_v(ind2)=[0,hexval(strmid(cc(ind),39,1))]+.1
	store_data,'0x05',data={x:time,y:[[log_v],[lin_v]]}
	options,'0x05','ytitle','i+ 8-15 MASK'
	ylim,'0x05',-1.,16.,0
	options,'0x05','labels',['MSB','LSB']
	options,'0x05','labpos,[2,6]
	options,'0x05','labflag',1
	options,'0x05','colors',[cols.red,cols.green]
endif

; make structures for CDI command 0x06
ind = where(strpos(cc,'/ipcbrawhex 0x06') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,1))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,1))]
	lin_v=fltarr(2+count*2)
	lin_v(ind1)=[0,hexval(strmid(cc(ind),39,1))]+.1
	lin_v(ind2)=[0,hexval(strmid(cc(ind),39,1))]+.1
	store_data,'0x06',data={x:time,y:[[log_v],[lin_v]]}
	options,'0x06','ytitle','e- MASK'
	ylim,'0x06',-1.,16.,0
	options,'0x06','labels',['MSB','LSB']
	options,'0x06','labpos,[2,6]
	options,'0x06','labflag',1
	options,'0x06','colors',[cols.red,cols.green]
endif

; make structures for CDI command 0x07
ind = where(strpos(cc,'/ipcbrawhex 0x07') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,2))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,2))]
	store_data,'0x07',data={x:time,y:log_v}
	options,'0x07','ytitle','i+ GAIN'
	ylim,'0x07',-10.,270.,0
endif

; make structures for CDI command 0x08
ind = where(strpos(cc,'/ipcbrawhex 0x08') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,2))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,2))]
	store_data,'0x08',data={x:time,y:log_v}
	options,'0x08','ytitle','e- GAIN'
	ylim,'0x08',-10.,270.,0
endif

; make structures for CDI command 0x09
ind = where(strpos(cc,'/ipcbrawhex 0x09') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,1))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,1))]
	store_data,'0x09',data={x:time,y:log_v}
	options,'0x09','ytitle','HKP MUX'
	ylim,'0x09',-1.,16.,0
endif

; make structures for CDI command 0x0A
ind = where(strpos(cc,'/ipcbrawhex 0x0A') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,1))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,1))]
	store_data,'0x0A',data={x:time,y:log_v}
	options,'0x0A','ytitle','HV Enable'
	ylim,'0x0A',-1.,16.,0
endif

; make structures for CDI command 0x0B
ind = where(strpos(cc,'/ipcbrawhex 0x0B') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,2))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,2))]
	lin_v=fltarr(2+count*2)
	lin_v(ind1)=[0,hexval(strmid(cc(ind),40,2))]+.1
	lin_v(ind2)=[0,hexval(strmid(cc(ind),40,2))]+.1
	store_data,'0x0B',data={x:time,y:[[log_v],[lin_v]]}
	options,'0x0B','ytitle','MCP HV'
	ylim,'0x0B',-10.,270.,0
	options,'0x0B','labels',['i+','e-']
	options,'0x0B','labpos,[50,200]
	options,'0x0B','labflag',1
	options,'0x0B','colors',[cols.red,cols.green]
endif

; make structures for CDI command 0x0C
ind = where(strpos(cc,'/ipcbrawhex 0x0C') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,2))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,2))]
	lin_v=fltarr(2+count*2)
	lin_v(ind1)=[0,hexval(strmid(cc(ind),40,2))]+.1
	lin_v(ind2)=[0,hexval(strmid(cc(ind),40,2))]+.1
	store_data,'0x0C',data={x:time,y:[[log_v],[lin_v]]}
	options,'0x0C','ytitle','SWP HV'
	ylim,'0x0C',-10.,270.,0
	options,'0x0C','labels',['i+','e-']
	options,'0x0C','labpos,[50,200]
	options,'0x0C','labflag',1
	options,'0x0C','colors',[cols.red,cols.green]
endif

; make structures for CDI command 0x0E
ind = where(strpos(cc,'/ipcbrawhex 0x0E') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v1=fltarr(2+count*2)
	log_v1(ind1)=[0,hexval(strmid(cc(ind),38,1))]
	log_v1(ind2)=[0,hexval(strmid(cc(ind),38,1))]
	log_v2=fltarr(2+count*2)
	log_v2(ind1)=[0,hexval(strmid(cc(ind),39,1))]+.1
	log_v2(ind2)=[0,hexval(strmid(cc(ind),39,1))]+.1
	log_v3=fltarr(2+count*2)
	log_v3(ind1)=[0,hexval(strmid(cc(ind),40,1))]+.2
	log_v3(ind2)=[0,hexval(strmid(cc(ind),40,1))]+.2
	log_v4=fltarr(2+count*2)
	log_v4(ind1)=[0,hexval(strmid(cc(ind),41,1))]+.3
	log_v4(ind2)=[0,hexval(strmid(cc(ind),41,1))]+.3
	store_data,'0x0E',data={x:time,y:[[log_v1],[log_v2],[log_v3],[log_v4]]}
	options,'0x0E','ytitle','Hdwr Lock'
	ylim,'0x0E',-1.,16.,0
	options,'0x0E','labels',['Byte0','Byte1','Byte2','Byte3']
	options,'0x0E','labpos,[1,3,5,7]
	options,'0x0E','labflag',1
	options,'0x0E','colors',[cols.blue,cols.red,cols.green,cols.magenta]
endif

; make structures for CDI command 0x0F
ind = where(strpos(cc,'/ipcbrawhex 0x0F') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,1))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,1))]
	lin_v=fltarr(2+count*2)
	lin_v(ind1)=[0,hexval(strmid(cc(ind),39,1))]+.1
	lin_v(ind2)=[0,hexval(strmid(cc(ind),39,1))]+.1
	store_data,'0x0F',data={x:time,y:[[log_v],[lin_v]]}
	options,'0x0F','ytitle','TP Gen'
	ylim,'0x0F',-1.,16.,0
	options,'0x0F','labels',['Rate','SwpReset']
	options,'0x0F','labpos,[50,200]
	options,'0x0F','labflag',1
	options,'0x0F','colors',[cols.red,cols.green]
endif

; make structures for CDI command 0xE0
ind = where(strpos(cc,'/ipcbrawhex 0xE0') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,4))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,4))]
	store_data,'0xE0',data={x:time,y:log_v}
	options,'0xE0','ytitle','i+ Log Swp'
	ylim,'0xE0',.5,65536.,1
endif

; make structures for CDI command 0xE1
ind = where(strpos(cc,'/ipcbrawhex 0xE1') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,4))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,4))]
	store_data,'0xE1',data={x:time,y:log_v}
	options,'0xE1','ytitle','e- Log Swp'
	ylim,'0xE1',.5,65536.,1
endif

; make structures for CDI command 0xE2
ind = where(strpos(cc,'/ipcbrawhex 0xE2') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,2))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,2))]
	lin_v=fltarr(2+count*2)
	lin_v(ind1)=[0,hexval(strmid(cc(ind),40,2))]
	lin_v(ind2)=[0,hexval(strmid(cc(ind),40,2))]
	store_data,'0xE2',data={x:time,y:[[log_v],[lin_v]]}
	options,'0xE2','ytitle','i+ Grad'
	ylim,'0xE2',-10.,270.,0
	options,'0xE2','labels',['Log','Lin']
	options,'0xE2','labpos,[50,200]
	options,'0xE2','labflag',1
	options,'0xE2','colors',[cols.red,cols.green]
endif

; make structures for CDI command 0xE3
ind = where(strpos(cc,'/ipcbrawhex 0xE3') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,4))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,4))]
	store_data,'0xE3',data={x:time,y:log_v}
	options,'0xE3','ytitle','i+ Lin Swp'
	ylim,'0xE3',.5,65536.,1
endif

; make structures for CDI command 0xE4
ind = where(strpos(cc,'/ipcbrawhex 0xE4') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,4))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,4))]
	store_data,'0xE4',data={x:time,y:log_v}
	options,'0xE4','ytitle','e- Lin Swp'
	ylim,'0xE4',.5,65536.,1
endif

; make structures for CDI command 0xE5
ind = where(strpos(cc,'/ipcbrawhex 0xE5') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,2))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,2))]
	lin_v=fltarr(2+count*2)
	lin_v(ind1)=[0,hexval(strmid(cc(ind),40,2))]
	lin_v(ind2)=[0,hexval(strmid(cc(ind),40,2))]
	store_data,'0xE5',data={x:time,y:[[log_v],[lin_v]]}
	options,'0xE5','ytitle','e- Grad'
	ylim,'0xE5',-10.,270.,0
	options,'0xE5','labels',['Log','Lin']
	options,'0xE5','labpos,[50,200]
	options,'0xE5','labflag',1
	options,'0xE5','colors',[cols.red,cols.green]
endif

; make structures for CDI command 0xE6
ind = where(strpos(cc,'/ipcbrawhex 0xE6') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),40,1))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),40,1))]
	lin_v=fltarr(2+count*2)
	lin_v(ind1)=[0,hexval(strmid(cc(ind),41,1))]
	lin_v(ind2)=[0,hexval(strmid(cc(ind),41,1))]
	store_data,'0xE6',data={x:time,y:[[log_v],[lin_v]]}
	options,'0xE6','ytitle','Retrace'
	ylim,'0xE6',-1.,16.,0
	options,'0xE6','labels',['i+','e-']
	options,'0xE6','labpos,[50,200]
	options,'0xE6','labflag',1
	options,'0xE6','colors',[cols.red,cols.green]
endif

; make structures for CDI command 0xE7
ind = where(strpos(cc,'/ipcbrawhex 0xE7') ne -1,count)
if count ge 1 then begin
	yr=[strmid(cc(ind),8,2)]
	mo=[strmid(cc(ind),0,2)]
	da=[strmid(cc(ind),3,2)]
	ti=[strmid(cc(ind),11,8)]
	t_dat=dblarr(count)
	for i=0,count-1 do t_dat(i)=str_to_time(yr(i)+'-'+mo(i)+'-'+da(i)+'/'+ti(i)) + lt_to_ut
	time=dblarr(2+count*2)
	ind1=lindgen(count+1)*2
	ind2=ind1+1
	time(ind1)=[t0,t_dat]
	time(ind2)=[t_dat-.001,t1]
	log_v=fltarr(2+count*2)
	log_v(ind1)=[0,hexval(strmid(cc(ind),38,1))]
	log_v(ind2)=[0,hexval(strmid(cc(ind),38,1))]
	store_data,'0xE7',data={x:time,y:log_v}
	options,'0xE7','ytitle','# Steps'
	ylim,'0xE7',-1.,16.,0
endif

end
