;Read ESA MODE TABLE

function read_themis_esa_angle_mode
		  
; default modes 1,2,3

; Angle modes

;	Nominal ion angle distribution
		nbins0=88
		theta0=[replicate(78.75,4),replicate(-78.75,4),replicate(56.25,8),replicate(-56.25,8),$
		replicate(33.75,16),replicate(-33.75,16),replicate(11.25,16),replicate(-11.25,16)]
		theta0=replicate(1.,32)#theta0
		dtheta0=replicate(22.5,88)
		dtheta0=replicate(1.,32)#dtheta0
		phi=[45.+90.*findgen(4),45.+90.*findgen(4),22.5+45.*findgen(8),22.5+45.*findgen(8),$
		11.25+22.5*findgen(16),11.25+22.5*findgen(16),11.25+22.5*findgen(16),11.25+22.5*findgen(16)]
		phi_offset=0.
		phi0=replicate(1.,32)#phi-phi_offset+(11.25*findgen(32)/32.)#replicate(1.,88)
		dphi0=replicate(1.,32)#[replicate(90.,8),replicate(45.,16),replicate(22.5,64)]
		p0=theta0+dtheta0/2.
		p1=theta0-dtheta0/2.
		domega0=2*!pi*dphi0/360.*(sin(p0/!radeg)-sin(p1/!radeg))

; 	Test ion angle distribution - no iesa anode mixing
		nbins1=88
		theta1=[replicate(78.75,2),replicate(-78.75,2),replicate(56.25,2),replicate(-56.25,2),$
		replicate(39.375,4),replicate(28.125,4),replicate(-39.375,4),replicate(-28.125,4),$
		replicate(19.6875,8),replicate(14.0625,8),replicate(8.4375,8),replicate(2.8125,8),$
		replicate(-2.8125,8),replicate(-8.4375,8),replicate(-14.0625,8),replicate(-19.6875,8)]
		theta1=replicate(1.,32)#theta1
		dtheta1=[replicate(22.5,8),replicate(11.25,16),replicate(5.625,64)]	
		dtheta1=replicate(1.,32)#dtheta1
		phi=[90.+180.*findgen(2),90.+180.*findgen(2),90.+180.*findgen(2),90.+180.*findgen(2),$
		45.+90.*findgen(4),45.+90.*findgen(4),45.+90.*findgen(4),45.+90.*findgen(4),$
		22.5+45.*findgen(8),22.5+45.*findgen(8),22.5+45.*findgen(8),22.5+45.*findgen(8),$
		22.5+45.*findgen(8),22.5+45.*findgen(8),22.5+45.*findgen(8),22.5+45.*findgen(8)]
		phi_offset=0.
		phi1=replicate(1.,32)#phi
		dphi1=replicate(1.,32)#[replicate(180.,8),replicate(90.,16),replicate(45.,64)]
		p0=theta1+dtheta1/2.
		p1=theta1-dtheta1/2.
		domega1=2*!pi*dphi1/360.*(sin(p0/!radeg)-sin(p1/!radeg))

; 	Abiad's initial ion angle distribution
		nbins2=88
		theta2=[replicate(67.5,4),replicate(-67.5,4),replicate(33.75,8),replicate(-33.75,8),$
		replicate(16.875,16),replicate(5.625,16),replicate(-5.625,16),replicate(-16.875,16)]
		theta2=replicate(1.,32)#theta2
		dtheta2=[replicate(45.,8),replicate(22.5,16),replicate(11.25,64)]
		dtheta2=replicate(1.,32)#dtheta2
		phi=[45.+90.*findgen(4),45.+90.*findgen(4),22.5+45.*findgen(8),22.5+45.*findgen(8),$
		11.25+22.5*findgen(16),11.25+22.5*findgen(16),11.25+22.5*findgen(16),11.25+22.5*findgen(16)]
		phi_offset=0.
		phi2=replicate(1.,32)#phi-phi_offset+(11.25*findgen(32)/32.)#replicate(1.,88)
		dphi2=replicate(1.,32)#[replicate(90.,8),replicate(45.,16),replicate(22.5,64)]
		p0=theta2+dtheta2/2.
		p1=theta2-dtheta2/2.
		domega2=2*!pi*dphi2/360.*(sin(p0/!radeg)-sin(p1/!radeg))

;	Nominal electron
		nbins4=88
		theta4=[replicate(78.75,4),replicate(-78.75,4),replicate(56.25,8),replicate(-56.25,8),$
		replicate(33.75,16),replicate(11.25,16),replicate(-11.25,16),replicate(-33.75,16)]
		theta4=replicate(1.,32)#theta4
		dtheta4=replicate(22.5,88)
		dtheta4=replicate(1.,32)#dtheta4
		phi=[45.+90.*findgen(4),45.+90.*findgen(4),22.5+45.*findgen(8),22.5+45.*findgen(8),$
		11.25+22.5*findgen(16),11.25+22.5*findgen(16),11.25+22.5*findgen(16),11.25+22.5*findgen(16)]
		phi_offset=0.
		phi4=replicate(1.,32)#phi-phi_offset+(11.25*findgen(32)/32.)#replicate(1.,88)
		dphi4=replicate(1.,32)#[replicate(90.,8),replicate(45.,16),replicate(22.5,64)]
		p0=theta4+dtheta4/2.
		p1=theta4-dtheta4/2.
		domega4=2*!pi*dphi4/360.*(sin(p0/!radeg)-sin(p1/!radeg))
	
; Angle modes

	i_theta=reform([[theta0],[theta1],[theta2]],32,88,3)
	i_dtheta=reform([[dtheta0],[dtheta1],[dtheta2]],32,88,3)	
	i_phi=reform([[phi0],[phi1],[phi2]],32,88,3)
	i_dphi=reform([[dphi0],[dphi1],[dphi2]],32,88,3)
	i_domega=reform([[domega0],[domega1],[domega2]],32,88,3)	
	i_nbins=[nbins0,nbins1,nbins2]

	e_theta=reform([[theta4],[theta4],[theta4]],32,88,3)
	e_dtheta=reform([[dtheta4],[dtheta4],[dtheta4]],32,88,3)	
	e_phi=reform([[phi4],[phi4],[phi4]],32,88,3)
	e_dphi=reform([[dphi4],[dphi4],[dphi4]],32,88,3)
	e_domega=reform([[domega4],[domega4],[domega4]],32,88,3)	
	e_nbins=[nbins4,nbins4,nbins4]

mode={i_theta:i_theta,i_dtheta:i_dtheta,i_phi:i_phi,i_dphi:i_dphi,i_domega:i_domega,i_nbins:i_nbins,$
	e_theta:e_theta,e_dtheta:e_dtheta,e_phi:e_phi,e_dphi:e_dphi,e_domega:e_domega,e_nbins:e_nbins}

return,mode

end

