;Read ESA MODE TABLE

function read_themis_esa_sweep_mode
		  
; default modes 1,2,3

; Ion Energy modes

i_energy=fltarr(32,4)
i_denergy=fltarr(32,4)
i_nenergy=intarr(4)
i_cal=1.6

; Ion mode 0 - Abiad moments file
	dac=esa_energy_steps(xstart=16532,xslope=20,cstart=125,cslope=4,number=128,retrace=3,dblsweep=0)	
;	i_energy(*,0)=i_cal*dac(1,*)
	i_energy(*,0)=i_cal*dac(1,*)
	i_denergy(1:31,0)=i_cal*(dac(3,0:30)-dac(0,1:31))
	i_nenergy(0)=32

; Ion mode 1 - Bench Test sweep < 1 keV file
	dac=esa_energy_steps(xstart=4095,xslope=17,cstart=0,cslope=0,number=128,retrace=3,dblsweep=0)	
	i_energy(*,1)=i_cal*dac(1,*)
	i_denergy(1:31,1)=i_cal*(dac(3,0:30)-dac(0,1:31))
	i_nenergy(1)=32
	
; Ion mode 2 - Nominal sweep mode
	dac=esa_energy_steps(xstart=16383,xslope=17,cstart=0,cslope=0,number=128,retrace=3,dblsweep=0)	
	i_energy(*,2)=i_cal*dac(1,*)
	i_denergy(1:31,2)=i_cal*(dac(3,0:30)-dac(0,1:31))
	i_nenergy(2)=32

; Ion mode 3 - Solar wind double sweep mode
	dac=esa_energy_steps(xstart=4095,xslope=17,cstart=0,cslope=0,number=64,retrace=3,dblsweep=1)	
	i_energy(0:15,3)=i_cal*dac(1,*)
	i_denergy(1:15,3)=i_cal*(dac(3,0:14)-dac(0,1:15))
	i_nenergy(3)=16

; Electron Energy modes

e_energy=fltarr(32,4)
e_denergy=fltarr(32,4)
e_nenergy=intarr(4)
e_cal=2.

; Electron mode 0 - Abiad moments file
	dac=esa_energy_steps(xstart=16532,xslope=20,cstart=125,cslope=4,number=128,retrace=3,dblsweep=0)	
	e_energy(*,0)=e_cal*dac(1,*)
	e_denergy(1:31,0)=e_cal*(dac(3,0:30)-dac(0,1:31))
	e_nenergy(0)=32

; Electron mode 1 - Bench Test sweep < 1 keV file
	dac=esa_energy_steps(xstart=4095,xslope=17,cstart=0,cslope=0,number=128,retrace=3,dblsweep=0)	
	e_energy(*,1)=e_cal*dac(1,*)
	e_denergy(1:31,1)=e_cal*(dac(3,0:30)-dac(0,1:31))
	e_nenergy(1)=32
	
; Electron mode 2 - Nominal sweep mode
	dac=esa_energy_steps(xstart=16383,xslope=17,cstart=0,cslope=0,number=128,retrace=3,dblsweep=0)	
	e_energy(*,2)=e_cal*dac(1,*)
	e_denergy(1:31,2)=e_cal*(dac(3,0:30)-dac(0,1:31))
	e_nenergy(2)=32

; Electron mode 3 - Solar wind sweep mode
	dac=esa_energy_steps(xstart=4095,xslope=14,cstart=0,cslope=0,number=128,retrace=3,dblsweep=0)	
	e_energy(*,3)=e_cal*dac(1,*)
	e_denergy(1:31,3)=e_cal*(dac(3,0:30)-dac(0,1:31))
	e_nenergy(3)=32




mode={i_energy:i_energy,i_denergy:i_denergy,i_nenergy:i_nenergy,$
	e_energy:e_energy,e_denergy:e_denergy,e_nenergy:e_nenergy}

return,mode

end

