;***********************************************************************************
; Run the "Real Time" THEMIS ESA GSE

loadct2,25
cols=get_colors()
tplot_options,window=0
window,0,xpos=750,ypos=0,xsize=500,ysize=800
window,1,xpos=0,ypos=0,xsize=300,ysize=300
window,2,xpos=350,ypos=0,xsize=300,ysize=300
vc='2'
port='8090'
vc='3'
dir='themis_dat/simulators0_dir/' & name='pipevc3'
dir='themis_dat/moments/' & name='pipevc3'
dir='themis_dat/esa_cpt_20050413/' & name='pipevc2'
; z:='\\128.32.13.37\IDPU Testing'
dir='z:20050420/' & name='port8090vc3'
dir='themis_dat/20050420/' & name='port8090vc3'
dir='y:\'

;***********************************************************************************
; Read and plot log file

;file=dir+'20050913_0908CPT_PRE_EMC_4.log'
read_idpugse_log


;***********************************************************************************
; APID 453

file=dir+name+'_453.pkt'
read_esagse_apid453,file=file,/time_order

;ctime,t
;dat=get_th_453(t)
;for i=0,87 do print,dat.data(10,i),dat.dt_arr(10,i),dat.theta(10,i)
;spec3d,dat,units='counts'
;oplot,[1,1.e5],[1.,1.e5]

nsamples=200							; last 10 minutes of data
.r
while keyword_set(adat) do begin
read_esagse_apid453,file=file,nsamples=nsamples,adat=adat,/time_order
wait,5
endwhile
end

;***********************************************************************************
; APID 454

file=dir+name+'_454.pkt'
read_esagse_apid454,file=file,/time_order

ctime,t
dat=get_th_454(t)
for i=0,87 do print,dat.data(10,i),dat.dt_arr(10,i),dat.theta(10,i)
spec3d,dat,units='counts'
oplot,[1,1.e5],[1.,1.e5]

nsamples=200							; last 10 minutes of data
.r
while keyword_set(adat) do begin
read_esagse_apid454,file=file,nsamples=nsamples,adat=adat,/time_order
wset,4 
dat=get_th_454(t,/en) & show3,dat.data
wait,5
endwhile
end

;***********************************************************************************
; APID 455

file=dir+name+'_455.pkt'
read_esagse_apid455,file=file,/time_order,adat=adat

nsamples=6							; last 10 minutes of data
.r
while keyword_set(adat) do begin
wset,0 
read_esagse_apid455,file=file,nsamples=nsamples,adat=adat,/time_order
wset,1 
dat=get_th_455(t,/en) & show3,dat.data
wait,5
endwhile
end

;***********************************************************************************
; APID 456

file=dir+name+'_456.pkt'
read_esagse_apid456,file=file,/time_order

ctime,t
dat=get_th_456(t)
for i=0,87 do print,dat.data(10,i),dat.dt_arr(10,i),dat.theta(10,i)
spec3d,dat,units='counts'
oplot,[1,1.e5],[1.,1.e5]

nsamples=200							; last 10 minutes of data
.r
while keyword_set(adat) do begin
wset,0 
read_esagse_apid456,file=file,nsamples=nsamples,adat=adat,/time_order
wset,1 
dat=get_th_456(t,/en) & show3,dat.data
wait,5
endwhile
end

;***********************************************************************************
; APID 457

file=dir+name+'_457.pkt'
read_esagse_apid457,file=file,/time_order,adat=adat

ctime,t
dat=get_th_457(t)
for i=0,87 do print,dat.data(10,i),dat.dt_arr(10,i),dat.theta(10,i)
spec3d,dat,units='counts'
oplot,[5.,5.e5],[1.,1.e5]

nsamples=200							; last 10 minutes of data
.r
while keyword_set(adat) do begin
wset,0 
read_esagse_apid457,file=file,nsamples=nsamples,adat=adat,/time_order
wset,1 
dat=get_th_457(t,/en) & show3,dat.data
wait,5
endwhile
end

;***********************************************************************************
; APID 458

file=dir+name+'_458.pkt'
read_esagse_apid458,file=file,/time_order,adat=adat

nsamples=6							; last 10 minutes of data
.r
while keyword_set(adat) do begin
wset,0 
read_esagse_apid458,file=file,nsamples=nsamples,adat=adat,/time_order
wset,1 
dat=get_th_458(t,/en) & show3,dat.data
wait,5
endwhile
end

;***********************************************************************************
; APID 459

file=dir+name+'_459.pkt'
read_esagse_apid459,file=file,/time_order

nsamples=200							; last 10 minutes of data
.r
while keyword_set(adat) do begin
wset,0 
read_esagse_apid459,file=file,nsamples=nsamples,adat=adat,/time_order
wset,1 
dat=get_th_459(t,/en) & show3,dat.data
wait,5
endwhile
end

;*****************************************************
;*****************************************************
read_esagse_apid453,file=dir+name+'_453.pkt',/time_order
read_esagse_apid454,file=dir+name+'_454.pkt',/time_order
read_esagse_apid455,file=dir+name+'_455.pkt',/time_order
read_esagse_apid456,file=dir+name+'_456.pkt',/time_order
read_esagse_apid456,file=dir+name+'_457.pkt',/time_order
read_esagse_apid458,file=dir+name+'_458.pkt',/time_order
read_esagse_apid459,file=dir+name+'_459.pkt',/time_order

tplot_names
tplot,[1,2,10,12,13,16]
tplot,[1,6,19,21,22,25]

;*****************************************************
ctime,t
dat=get_th_454(t)
for i=0,87 do print,dat.data(10,i),dat.dt_arr(10,i),dat.theta(10,i)


ctime,t
dat=get_th_457(t)
for i=0,87 do print,dat.data(10,i),dat.dt_arr(10,i),dat.theta(10,i)
