

function thm_esa_steps,sweep=sweep,dac_cal=dac_cal,instrument=inst

if n_elements(inst) eq 0 then inst=dac_cal.inst
dacvals= thm_esa_dac_steps(sweep)

ion = inst gt 0
if not ion  then begin    ; electrons
  name = 'eesa'
  nnrg = 32
  nphi = 32
  nthe = 8
  mode = sweep.dblsweep ? 2 : 1
  mass = 511000.d/299792.d^2
  q = -1
  b4 = 5
  theta = (dindgen(nthe)+.5-nthe/2)*180d/nthe
  dtheta = 180d/nthe + dblarr(nthe)
  tgeom = dtheta / 360.
  tgeom *= 1.0175            ; account for double counting at anode boundaries
  preaccel = 450.       ; Preacceleration energy before hitting MCP
  gf = .0149  ; Geometric factor for PESAH ,  full 360 degree detector
  gf *= (1.5/1.9)^3  * (.7/.5)  ;  correction for different gap and  MCP efficiency
endif
if ion then begin  ;ions
  name = 'iesa'
  nnrg = 32
  nphi = 32
  nthe = 16
  mode = 2; sweep.dblsweep ? 2 : 1
  thetar = [-16,-12,-8,-6,-4,-3,-2,-1,0,1,2,3,4,6,8,12,16] *90d/16
  theta2 = thetar[indgen(16)+1]
  theta1 = thetar[indgen(16)]
  theta = (theta2+theta1)/2
  dtheta = (theta2-theta1)
  mass = 511000.d/299792.d^2*1836d
  q = 1
  b4 = 1
  tgeom = dtheta / 360.
  ; correction for over counting
  anode_type = [0,0,1,1,2,2,2,2,2,2,2,2,1,1,0,0]
  correction = [1.0175,1.035,1.07]
;  tgeom *= correction[anode_type]
  preaccel = 2000.              ; Preacceleration energy before hitting MCP
  gf = .0149  ; Geometric factor for PESAH
endif

if not keyword_set(dac_cal) then begin
   dac_cal={gain:30000./2l^14,  offset:0.}
endif
nrg1 = (dacvals - dac_cal.offset)* dac_cal.gain
dnrg1 = shift(nrg1,1)-nrg1
mnrg1 = (shift(nrg1,1)+nrg1)/2
mnrg2 = (shift(nrg1,-1) +nrg1)/2
dnrg = reform(mnrg1[0,*]-mnrg2[3,*])             ; change
;shft_nrg = shift(nrg1,0,1)
;dnrg = reform(shft_nrg[3,*] - nrg1[3,*])
nrg = average(nrg1, 1)
dnrg[0]=0          ;retrace
if sweep.dblsweep then dnrg[16] = 0              ; added by DL 2006-6-14
dnrg[nnrg-1]=dnrg[nnrg-2]

;if 0 then begin
;e = dgen(/log,nnrg+1,range=[30000.,2.])
;nrg = (e + shift(e,+1))/2
;dnrg = abs(e -shift(e,+1)) * 1.01
;nrg=nrg[1:*]
;dnrg=dnrg[1:*]
;dnrg[0] = 0              ;retrace
;endif


;phi = (dindgen(nphi)+.5)*360d/nphi
phi = reform(dindgen(mode,nphi)+.5)*360d/nphi/mode
dphi = 360d/nphi/mode + phi*0

;egeom = nrg *0 +1

egeom = mcp_efficiency(nrg+preaccel,ion = ion)
; I don't know were this number came from!!!! gf = 0.001176d*2   ; geometric factor for a 360 degree analyzer.
s={inst:"ESA",name:name,q:q, mass:mass, nrg:nrg, dnrg:dnrg, phi:phi, dphi:dphi, theta:theta, dtheta:dtheta, $
   tgeom:tgeom, egeom:egeom, gf:gf, dt:3./nnrg/nphi, $
   mom_shift:b4,  $
   mode:mode,  sweep:sweep, dacvals:dacvals, dac_cal:dac_cal}

return,s
end


