


function calc_moments_flt,counts,q,pot,i_e,WN,Omega,verbose=verbose

dim = size(/dimen,counts)
ntheta = dim[0]
nphi =  dim[2]
nnrg = dim[1]

if keyword_set(verbose) then help,counts,omega,wn,q,pot

;i_e = WN[*,4]

x =  pot * i_e

z =  (1+q*x)
z = 0 > z < 4   ; limit z to be greater than 0 and less than 4 (?)

z0 = z^(1/2d)
z1 = z^(1d)
z2 = z^(3/2d)
z3 = z^(2d)

WZ0 = WN[*,0]*Z0
WZ1 = WN[*,1]*Z1
WZ2 = WN[*,2]*Z2
WZ3 = WN[*,3]*Z3

WZ = [[WZ0],[WZ1],[WZ2],[WZ3]]
if keyword_set(verbose) then help,wz

zero = 0.d
Mom = replicate(zero,13)

dim_c = size(/dimen,counts)
ntheta = dim_c[0]
nphi   = dim_c[2]
nnrg   = dim_c[1]
nm = 13
dprint,dim_c,/phelp;,varn='dim_c (flt)'

;mode = weights.mode
dim_o = size(/dimen,omega)
nphi = dim_o[3]
mode  = dim_o[2]
ntheta = dim_o[1]
nesteps = nnrg / mode
dprint,dim_o,/phelp;,varn='dim_o (flt)'
dprint,nesteps,/phelp;,varn='nesteps (flt)'
dprint,mode,/phelp;,varn='mode (flt)'

Ni = [0,1,1,1,2,2,2,2,2,2,3,3,3]

for k=0,nphi-1 do begin    ; cycle through PHI
  for i=0,nnrg-1 do begin    ;cycle through energy
    for j=0,ntheta-1 do begin  ; cycle through theta
        c = counts[j,i,k]
        for m = 0,13-1 do begin   ; cycle through moments
            mom[m] = mom[m] + c * ( WZ[i,Ni[m]] * Omega[m,j,i/nesteps,k] )  ;bpif i/nesteps
        endfor
     endfor
  endfor
endfor

return,[pot,mom]
end

