

pro thm_eprom_print_toc_entry,eprom,ti

toci = eprom[ti*4:ti*4+3]
print,toci,format = '(4Z5.4)'
buf = eprom[ toci[2]/2 : (toci[2]+toci[0])/2 -1 ]
print,fix(buf) ,format= '(16i7)'  ;'(16Z5.4)'
end



pro thm_eeprom_read_file,file=file,buffer,nwrite=nwrite

if not keyword_set(file) then begin
    message,'Need a file name.'
    file = 'etc_tables_rev5_Probe1.raw'
;    printdat,file_info(file)
endif
dprint,'Reading raw file: ',file

openr,fp,file,/get_lun

if n_elements(buffer) ne 2ul^16 then begin
  buffer = bytarr(2ul^16)
  buffer[*] = 255
  nwrite = bytarr(2ul^16)
endif
if n_elements(nwrite) ne n_elements(buffer) then nwrite=bytarr(2ul^16)

s=''
line = 0L
while not eof(fp) do begin
  line++
  readf,fp,s
  if strmid(s,0,4) eq 'wait' then continue
  if not keyword_set(s) then begin
     dprint,'Blank line'
     continue
  endif
  dprint,s,dlevel=3
  ss = strsplit(s,' ',/extrac)
  val = byte(hexval(ss[1:*]))
  addr = val[ [11,10,9,8] ]
  addr = (((addr[0] *256ul +addr[1])*256ul+addr[2])*256ul+addr[3])

  if addr / 2ul^16 ne 3 then message,'Bad address'
  addr = addr mod 2ul^16
;  printdat,addr
  me = val[ [13,12] ]
  me = me[0]*256u + me[1]
  if me ne 0 then message,'ME Error'
  len = val[ 14 ]
  if (len+17) ne n_elements(val) then message,'len error'
  dat = val[ 15: 15+len-1 ]
  nval = n_elements(val)
  datsum = thm_etc_checksum( val[8:nval-3] )
  chksum = val[nval-1] + 256u *val[nval-2]            ;bpif datsum ne chksum
  if datsum ne chksum then message,'Checksum error'
  wrds = reform(dat,2,len/2)
  wrds = reform(wrds[1,*] * 256ul + wrds[0,*])
  buffer[addr:addr+len-1] = dat
  nwrite[addr:addr+len-1] += 1
  dprint,dlevel=4,addr,me,len,format='( Z5, " ",Z04," ",  Z02)'

;  printdat,val
;  dprint,val
endwhile
free_lun,fp

wi,1,wsize=[256,256]
sbuffer = reform(buffer,256,256)
sbuffer = bytescale(sbuffer)
;sbuffer = reform(nwrite,256,256)
tv,sbuffer


end





thm_eeprom_read_file,buffer

wbuff = reform(buffer,2,2u^15)
wbuff = reform( wbuff[0,*] + 256u *wbuff[1,*])

thm_etc_load_mem,etcmem,wbuff,0



;toc = wbuff[0:3*256-1]
;ieo0 = wbuff['0600'x/2:'0600'x/2+'400'x-1]
;ieo0 = reform(ieo0,16,64)
;toc = reform(toc,4,n_elements(toc)/4)
;print,toc,format='(4Z5.4)'
;
;thm_eprom_print_toc_entry,wbuff,1

end
