pro thm_eeprom_write_rawfile,file=file,eeprom,nwrite=nwrite

if not keyword_set(file) then file=time_string(tformat='etc_tables_YYYYMMDD_hhmm.raw',systime(1))
dprint,'Writing raw file: ',file

openw,lun,file,/get_lun

if n_elements(nwrite) ne n_elements(eeprom) then message,'Bad input'
bbuffer = byte(eeprom,0,2*n_elements(eeprom))        ; byte buffer
bnwrite = reform(transpose([[nwrite],[nwrite]]),n_elements(nwrite)*2)
nb= n_elements(bbuffer)
bbuffer = reform(bbuffer,128,nb/128)
bnwrite = reform(bnwrite,128,nb/128)
dim = size(/dimension, bbuffer )

count = 0
for i=0ul,dim[1] -1 do begin
    bi = bbuffer[*,i]
    ni = bnwrite[*,i] ne 0
    dn = [ni,0]
    dn = dn - shift(dn,1)
    hdr =  ['1C'xb, '01'xb, 'C0'xb, '00'xb, '00'xb, '0A'xb, '00'xb, '00'xb ]
    w1 = where(dn eq 1,nw)
    w2 = where(dn eq -1)
    for j=0,nw-1 do begin
;    if nw eq 0 then continue
       b = bi[w1[j]:w2[j]-1]
       len = byte(n_elements(b))
       address = ulong( '30000'x + i*dim[0] + w1[j] )
  if address ge '3F500'xu then message,'Memory overwrite!'
       byt_addr = byte(address,0,4)
       dat = [byt_addr,0b,0b,len,b]
       chksum = reverse(byte(thm_etc_checksum(dat),0,2))
       hdr[5] = '0A'xb + len
       printf,lun,[hdr,dat,chksum],format='("RAW",256Z3.2)'
       printf,lun,'wait 2'
       count++
    endfor
endfor
dprint,'Number of commands= ',count
free_lun,lun

end

