
function thm_etc_calc_weights_ion,steps,kv=kv,float=flt

name = steps.name
;if not keyword_set(kv) then kv = 100./2l^15 * 200/256
;if not keyword_set(kv) then kv = 100./2l^15 * 256/200   ; Changed 2007-05-31
if not keyword_set(kv) then kv = 105.2/2d^15 * 256./200.   ; Changed 2007-06-03

if steps.inst eq 'ESA' then begin
  th = outer_prod( steps.theta , steps.phi*0+1 )
  ph = outer_prod( steps.theta*0+1 , steps.phi )
  dth = outer_prod( steps.dtheta , steps.phi*0+1 )
  dph = outer_prod( steps.theta*0+1 , steps.dphi )
  tgeom = outer_prod( steps.tgeom, steps.phi*0+1 )
endif
if steps.inst eq 'SST' then begin
  th = steps.theta2
  ph = steps.phi2
  dth = steps.dtheta2
  dph = steps.dphi2
  tgeom = steps.tgeom2
endif

dprint,dlevel=4,/phelp,th
dprint,dlevel=4,/phelp,ph
dprint,dlevel=4,/phelp,dth
dprint,dlevel=4,/phelp,dph

omega = thm_etc_calc_omega_flt(th,ph,dth,dph, tgeom )


dprint,/phelp,omega
;omega = thm_etc_calc_omega_flt(steps.theta[*], steps.phi[*], steps.dtheta[*], steps.dphi[*], steps.tgeom[*])

mode = steps.mode
;dprint,/phelp,omega
;dim_o = size(/dimen,omega)
;nphi = dim_o[2]
;ntheta = dim_o[1]
;nm     = dim_o[0]

;omega = reform(omega,nm,ntheta,mode,nphi/mode)
;dprint,/phelp,omega

WN =  calc_energy_weights(steps.nrg[*], steps.dnrg[*], steps.egeom[*])
PN = 0
p1=512
p1=1024
;s1=2l^15
;s2=2l^15
;s3=2l^15
;s4=2
b1 = 13
b2=15
b3=15
b4=steps.mom_shift   ; typically 1 for ions ; 4 for electrons
;s1=2l^b1
;s2=2l^b2
;s3=2l^b3
;s4=2l^b4

if (steps.inst eq 'SST') then begin
;   p1=1024
;   b2=15
   p1=1
   b2=9
   b4 = steps.mom_shift
endif


;ke = kv * s1 * p1
ke = kv * 2l^b1 * p1
ie =  ke / steps.nrg
wn = wn[*,0:3]

omega_scale = max(omega,/absol) / (2.^15-1)
omega =  omega / omega_scale

scale = replicate(omega_scale,13)

Ni=[0,1,1,1,2,2,2,2,2,2,3,3,3]

dim  = size(/dimen,WN)
nnrg = dim[0]
;mx= max(WN,dimen=1)
dprint,'max(WN) = ',max(WN,/absol,dimen=1)
WN0=WN
dprint,dlevel=5,getdebug=dbg
WN_scale = max(WN,/absol,dimen=1) / (2.^15-1)
WN_scal0 = WN_scale

if steps.inst eq 'ESA' then begin
    WN_scale[0] = WN_scale[2]^3  / WN_scale[3]^2  *  2^7
    ;WN_scale[3] = WN_scale[2] * WN_scale[1] / WN_scale[0] * 32
endif
if steps.inst eq 'SST' then begin
    WN_scale[1]= sqrt(WN_scale[0] * WN_scale[2]) / 2
endif


dprint,wn_scal0,/phelp
dprint,wn_scale,/phelp

WN = WN / (replicate(1,nnrg) # WN_scale)
scale = scale * WN_scale[Ni]

dprint,'max(WN) = ',max(WN,absol,dimen=1)

if dbg gt 2 then begin
   wi,2
   xlog = 1
   if xlog then xvals= steps.nrg else xvals = indgen(nnrg)
   plot,minmax(xvals),[.01,100000.],/ylog,/nodata,xlog=xlog
;   for i=0,3 do oplot,xvals,WN0[*,i],color=i+1,psym=-1
   for i=0,3 do oplot,xvals,WN[*,i],color=i+1,psym=-4
   oplot,xvals,ie,color=6,psym=-4
   oplot,xvals,replicate(2l^15,nnrg)
;   stop
endif

if max(WN) gt 2l^15-.5 then begin
   beep
   dprint,['WN='],wn
   message,'Overflow error'
endif
if min(WN) lt 0 then begin
   beep
   dprint,['WN='],wn
   message,'Underflow error'
endif

if p1 gt 1 then begin
  ssize = 2048
  x = dindgen(2048)/P1
  PN = [[x^0.5],[x],[x^1.5],[x^2]]
  PN_scale = max(PN,dimen=1) / (2.^15-1)
  PN = PN / (replicate(1,2048) # PN_scale)
  scale = scale * PN_scale[Ni]
endif else begin
  PN = 0
  scale = scale / 2^b2
endelse
;stop

if not keyword_set(flt) then begin
  ie = fix(round( ie < (2ul^15-1) ))
  WN = fix(round( WN  ))
  omega = fix(round( omega ))
  PN = fix(round( PN ))
endif

if max(WN) gt 2l^15-1 then begin
   beep
   dprint,['WN='],wn
   message,'Overflow error'
endif
if min(WN) lt 0 then begin
   beep
   dprint,['WN='],wn
   message,'Underflow error'
endif

;scale = scale * s2 * s3 * s4
scale = scale * 2l^b2 * 2l^b3 * 2l^b4

;pot = steps.pot
q = steps.q
mass = steps.mass

rscale = (2/mass)^ ((findgen(4)-1)/2) /1e5 / steps.dt / steps.gf
rscale[2:3] =  mass * rscale[2:3]
rscale[3] = .5d * rscale[3]

weights = {name:name, q:q, mass:mass,  omega:omega, iE:ie,   WN:WN[*,0:3],  PN:PN,  $
     P1:p1, $
     b1:b1, b2:b2, b3:b3, b4:b4, $
     ; s1:s1, s2:s2, s3:s3, s4:s4, $
     wn_scale: wn_scale, $
     scale:[kv,scale] , rscale:[1,rscale[Ni]], kv:kv, mode:mode}
return,weights
end

