;pro  thm_etc_setup_crib



common global_mom_stuff,method,all_methods,glob_c

help,div2n(15,2)
; beginning of program
dist = eflux(param=dist)
dist.q=1
dist.pot = 20.
dist.photo = 1
dist.density=10
dist.vel = 30d*[1.,-.010,.010]
dist.ttens = 10000. * [ 1,1,1,0,0,0 ]
dist.mass = 511000.d/299792.d^2 * (dist.q eq 1 ? 1836 : 1)


steps = thm_esa_params(inst=dist.q)

;steps = thm_sst_steps(inst=dist.q)


dd=0

if not keyword_set(dd) then dd = dist

weights = calc_weights_flt(steps)

weights2= thm_mom_calc_weights_ion(steps,float=flt,kv=kv)
w2=weights2

counts =  simulated_counts(steps,param=dd,seed,testpulse=testpulse)
icounts = fix(round(counts))

if n_elements(dd) gt 1 then dist = total_dist(dd)

print,'total= ',total(counts)
plot,steps.nrg,total(total(counts,1),2),psym=-1,/xlog,/ylog ,yrange=[.1,1e7],/ystyle
d = size(/dimen,counts)
for i=0,d[0]-1 do for j=0,d[2]-1 do oplot,steps.nrg,counts[i,*,j] ,psym=-3


dpot = dd[0].pot
mom1 = calc_moments_flt(counts,dist.q,dpot,weights.ie,weights.WN,weights.Omega)
nmom1 = mom1 * weights.scale * weights.rscale

pot = fix(round( dpot / weights2.kv))
printdat,pot,'pot'
mom2 = calc_moments_ion(icounts,dist.q,pot,weights2,verbose=verbose,wp=wp)
nmom2 = mom2 * weights2.scale * weights2.rscale
s = weights2.scale * weights2.rscale

for i=0,3 do oplot,steps.nrg,wp[*,i],col=i+1,psym=-2
for i=0,3 do oplot,steps.nrg,weights2.wn[*,i],col=i+1,psym=-4

print

nmom = calc_dist_mom(dist)
err1 = (nmom1-nmom)/nmom*100
err2 =(nmom2-nmom1)/nmom1*100

names=strsplit(/extract,'Pot N NVx NVy NVz NVxVx NVyVy NVzVz NVxVy NVyVz NVxVz EFx EFy EFz',' ')
print,ptrace(),'Method: ',method
print, ' Name    0 (theory)     error1    1  (double)   2 (long)   error2      mom2      mom2(hex)  scale'
form1='(a6,f12.1, g12.4, g12.4, g12.4, g12.4, i, Z, e14.4, f16.4)'
for i=0,13 do print,names[i],nmom[i],err1[i],nmom1[i],nmom2[i],err2[i],mom2[i],mom2[i],s[i],s[i]*2.^31,format=form1

;print,transpose([[mom1],[mom2*weights2.scale],[nmom1]])

;printdat,dist,'dist',width=300
;printdat,calc_mom_dist(nmom1,dist=dist),width=300,'recomp1'
;printdat,calc_mom_dist(nmom2,dist=dist),width=300,'recomp2'
w2=weights2
w=weights


thm_print_counts,icounts,[mom2],file=w2.name+'-counts.txt',header='Method: '+method,sst = (w2.name eq 'foil') or (w2.name eq 'open')
thm_print_weights,w2,/file,steps=steps
;print_moments,[mom2],file=w2.name+'-mom.txt'

print





end