;pro thm_mom_cal_factors, dir = dir


thm_mom_cal_factors = fltarr(13,4)

ei_1 = thm_part_config(name='esa',scnum=scnum,sweep_num=1,inst=1)
;ei_steps = thm_esa_params(inst=1)  ; Esa Ions
;ei_w2= thm_etc_calc_weights_ion(ei_steps,kv=kv)
s = ei_1.weights.scale * ei_1.weights.rscale
thm_mom_cal_factors[*,0] = s[1:*]

ee_1 =  thm_part_config(name='esa',scnum=scnum,sweep_num=1,inst=-1)
;ee_steps = thm_esa_params(inst=-1)  ; Esa electrons
;ee_w2= thm_etc_calc_weights_ion(ee_steps,kv=kv)
s = ee_1.weights.scale * ee_1.weights.rscale
thm_mom_cal_factors[*,1] = s[1:*]

si_1 =  thm_part_config(name='sst',scnum=scnum,sweep_num=1,inst=1)
;si_steps = thm_sst_steps(inst=1)  ; SST Ions
;si_w2= thm_etc_calc_weights_ion(si_steps,kv=kv)
s = si_1.weights.scale * si_1.weights.rscale
thm_mom_cal_factors[*,2] = s[1:*]

se_1 =  thm_part_config(name='sst',scnum=scnum,sweep_num=1,inst=-1)
;se_steps = thm_sst_steps(inst=-1)  ; SST electrons
;se_w2= thm_etc_calc_weights_ion(se_steps,kv=kv)
s = se_1.weights.scale * se_1.weights.rscale
thm_mom_cal_factors[*,3] = s[1:*]


thm_mom_cal_factors[*,0]  *= 2   ;esa ions
thm_mom_cal_factors[*,1]  /= 8   ; esa electrons
;thm_mom_cal_factors[*,2]  *= 10    ; sst ions
;thm_mom_cal_factors[*,3]  *= 10    ; sst electrons
thm_mom_cal_factors[1:3,*] *= 1e5    ; change units for flux
;thm_mom_cal_factors[[1,2,8,9,10,11],0:1] *= -1   ; ESA fix x and y for rev7-draft4

thm_mom_cal_scpot = 105.2/(2.^15) *256./200.   ; SC potential

cal_data = thm_mom_cal_factors
cal_sc_pot = thm_mom_cal_scpot


probe='a'
thx = 'th'+probe
pathname = thx+'/l1/mom/0000/'+thx+'_l1_mom_cal_v01.sav'

thm_init
cal_file =  !themis.local_data_dir+ pathname

Comment='THEMIS moment calibration data (ver 3).  Created: '+systime()

caldata = {mom_scale:cal_data,scpot_scale:cal_sc_pot}

if probe eq 'x' then begin
   caldata.mom_scale=1.
   caldata.scpot_scale=1.
endif

;save,file=cal_file,thm_mom_cal_factors,thm_mom_cal_scpot,description=comment,/verbose
file_mkdir,file_dirname(cal_file)
save,file=cal_file,caldata,description=comment,/verbose
dprint,'Created: ',cal_file

end