


;pro test2,meth=m,dist=dist
;common global_mom_stuff,method,all_methods,glob_c
;method = all_methods[m]
;
;steps = (dist.q eq 1) ? iesa_steps() : eesa_steps()
;counts =  simulated_counts(steps,param=dist,seed)
;dpot = dist.pot
;icounts = fix(round(counts))
;weights = calc_weights_flt(steps)
;mom1 = calc_moments_flt(icounts,dist.q,dpot,weights.ie,weights.WN,weights.Omega)
;nmom1 = mom1 * weights.scale * weights.rscale
;
;weights2= calc_weights(steps)
;pot = fix(round( dpot / weights2.kv))
;mom2 = calc_moments(icounts,dist.q,pot,weights2,verbose=verbose,wp=wp)
;nmom2 = mom2 * weights2.scale * weights2.rscale
;
;nmom = calc_dist_mom(dist)
;err1 = (nmom1-nmom)/nmom*100
;err2 =(nmom2-nmom1)/nmom1*100
;names=strsplit(/extract,'Pot N NVx NVy NVz NVxVx NVyVy NVzVz NVxVy NVyVz NVxVz EFx EFy EFz',' ')
;print,'Method: ',method
;print, ' Name    0 (theory)     error1    1  (double)   2 (long)   error2      mom2      mom2(hex)
;form1='(a6,f12.1, g12.4, g12.4, g12.4, g12.4, i, Z)'
;for i=0,13 do print,names[i],nmom[i],err1[i],nmom1[i],nmom2[i],err2[i],mom2[i],mom2[i],format=form1
;
;w2=weights2
;w=weights
;
;if pot ne 0 then prefix = "P" else prefix= '0'
;prefix = prefix +strtrim(m,2)
;
;printdat,prefix
;
;print_counts,icounts,[mom2],file=w2.name+prefix+'-counts.txt',header='Method: '+method
;print_weights,w2,/file
;
;end




common global_mom_stuff,method,all_methods,glob_c
dprint,setdeb=2,print_trace=3,/print_dlevel


dprint,/phelp,div2n(15,2)
; beginning of program
dist = eflux(param=dist)
dist.q=1
dist.pot = 0.
dist.photo = 1
dist.density=100
dist.vel = 00d*[1.,-.010,.010]
dist.ttens = 1000. * [ 1,1,1,0,0,0 ]
dist.mass = 511000.d/299792.d^2 * (dist.q eq 1 ? 1836 : 1)
steps = thm_esa_steps(inst=dist.q)
dprint,phelp=3,steps
;steps = thm_sst_steps(inst=dist.q)
dd=0

if not keyword_set(dd) then dd = dist

weights = calc_weights_flt(steps)

weights2= calc_weights_ion(steps,float=flt)
w2=weights2
;printdat,weights2

counts =  simulated_counts(steps,param=dd,seed,testpulse=testpulse)
icounts = fix(round(counts))

if n_elements(dd) gt 1 then dist = total_dist(dd)

dprint,'total= ',total(counts)
plot,steps.nrg,total(total(counts,1),2),psym=-1,/xlog,/ylog ,yrange=[.1,1e7],/ystyle
d = size(/dimen,counts)
for i=0,d[0]-1 do for j=0,d[2]-1 do oplot,steps.nrg,counts[i,*,j] ,psym=-3 ,col=2


dpot = dd[0].pot
mom1 = calc_moments_flt(counts,dist.q,dpot,weights.ie,weights.WN,weights.Omega)
nmom1 = mom1 * weights.scale * weights.rscale

pot = fix(round( dpot / weights2.kv))
dprint,/phelp,pot
mom2 = calc_moments_ion(icounts,dist.q,pot,weights2,verbose=verbose,wp=wp)
nmom2 = mom2 * weights2.scale * weights2.rscale

for i=0,3 do oplot,steps.nrg,wp[*,i],col=i+1,psym=-2
for i=0,3 do oplot,steps.nrg,weights2.wn[*,i],col=i+1,psym=-4

dprint

nmom = calc_dist_mom(dist)
err1 = (nmom1-nmom)/nmom*100
err2 =(nmom2-nmom1)/nmom1*100

names=strsplit(/extract,'Pot N NVx NVy NVz NVxVx NVyVy NVzVz NVxVy NVyVz NVxVz EFx EFy EFz',' ')
dprint,'Method: ',method
dprint, ' Name    0 (theory)     error1    1  (double)   2 (long)   error2      mom2      mom2(hex)
form1='(a6,f12.1, g12.4, g12.4, g12.4, g12.4, i, Z)'
for i=0,13 do dprint,names[i],nmom[i],err1[i],nmom1[i],nmom2[i],err2[i],mom2[i],mom2[i],format=form1

;print,transpose([[mom1],[mom2*weights2.scale],[nmom1]])

;printdat,dist,'dist',width=300
;printdat,calc_mom_dist(nmom1,dist=dist),width=300,'recomp1'
;printdat,calc_mom_dist(nmom2,dist=dist),width=300,'recomp2'
w2=weights2
w=weights


thm_print_counts,icounts,[mom2],file=w2.name+'-counts.txt',header='Method: '+method,sst = (w2.name eq 'foil') or (w2.name eq 'open')
thm_print_weights,w2,/file,steps=steps
;print_moments,[mom2],file=w2.name+'-mom.txt'

dprint


if 0 then begin
test2,meth=0,dist=dist
test2,meth=1,dist=dist
test2,meth=2,dist=dist
test2,meth=3,dist=dist
test2,meth=4,dist=dist
test2,meth=5,dist=dist
test2,meth=6,dist=dist
test2,meth=7,dist=dist
dist.pot=4.
test2,meth=0,dist=dist
test2,meth=1,dist=dist
test2,meth=2,dist=dist
test2,meth=3,dist=dist
test2,meth=4,dist=dist
test2,meth=5,dist=dist
test2,meth=6,dist=dist
test2,meth=7,dist=dist
endif

dprint,'Done'

end

