
pro thm_print_weights,w,file=file,steps=steps

if keyword_set(file) then begin
   filename = w.name+'-omega.txt'
   openw,f,filename,/get_lun,width=300
endif else f=-1
dim = size(/dimen,w.omega)
nm = dim[0]
nthe = dim[1]
ni = dim[2]
nphi = dim[3]

printf,f,'; omega (angle) weights for:',w.name
;printf,f,w.omega

for m =0,nm-1 do begin
      printf,f,';   m=',m
        for i=0,ni-1 do begin
      for p=0,nphi-1 do begin
      ;printf,f,';   p=',p
      ; for t=0,dim[1]-1 do begin
          printf,f,reform(w.omega[m,*,i,p])             ;,format = '(16(i7.0)," ")'
      ; endfor
        endfor
   endfor
endfor
if f ne -1 then free_lun,f


dim = size(/dimen,w.wn)

if keyword_set(file) then begin
   filename = w.name+'-energy.txt'
   openw,f,filename,/get_lun,width=300
endif else f=-1
wn = w.wn
printf,f,';  Energy weights for: ',w.name
printf,f,wn    ;   ,format = '(4i7)'

printf,f,';  Inverse energy for: ',w.name
printf,f,w.ie

if keyword_set(steps) then begin
   if w.name eq 'eesa' then  print_sweep_params,file=f,eesa = steps.sweep,prefix=';  '
   if w.name eq 'iesa' then  print_sweep_params,file=f,iesa = steps.sweep,prefix=';  '
endif
if f ne -1 then free_lun,f


if keyword_set( w.pn ) then begin
  if keyword_set(file) then begin
     filename = w.name+'-sqrts.txt'
     openw,f,filename,/get_lun,width=300
  endif else f=-1
  col=16
  for i=0,3 do begin
     printf,f,';  SQRT tables PN',i
     a = w.pn[*,i]
     a = reform(a,col,2048/col)
     printf,f,a
  endfor
  if f ne -1 then free_lun,f
endif

end

