
function ioname, file

suffix=['45a','45b','45c','45d','45e','45f']
rfix=replicate(-1,6)
for sfix=0,5 do  rfix[sfix]=strpos(file,suffix[sfix])
nfix=where(rfix ne -1)
if nfix ge 0 then $
 tion = (nfix ge 3) ? 'foil' : 'open'  $
else  stop

return, tion
end





pro Cdac_plot, ch,thrname,sname,mapr,tr,th_rate
common share1, file
a = tsample(thrname[0],tr,times=tso)
print, ' '
print, time_string(tso)
ts = tso+18  ;tso+9
n=n_elements(ts)
ts=ts[0:n-2]
n=n-1   ; number of DAC threshold steps
dt=6   ;3
for ns=0,n-1 do  if ts[ns]+dt gt tso[ns+1] or ts[ns]-dt lt tso[ns] then stop
wset,0
timebar,ts-dt,col=2
timebar,ts+dt,col=6

nchs = n_elements(thrname)
th = fltarr(nchs,n)
s = fltarr(16,n)
si= fltarr(nchs,n)
for nch=0,nchs-1 do  begin
  nsp = nch/4 * 2
  for i=0,n-1 do begin
    s[*,i] = tsample(sname[nch],ts[i]+dt*[-1,1],/aver)   ;counts/3s
    th[nch,i]  = data_cut(thrname[nch]+'_',ts[i])
    dim=mapr(nsp+1)-mapr(nsp+0)
    si[nch,i] = (dim gt 0) ? total(s[mapr(nsp+0):mapr(nsp+1),i],1)/3. : s[mapr(nsp+0),i]/3. ;counts/s
  endfor
endfor

help,th,s,si

cols = get_colors('bgr')
psym = [1,2,4,5]    ; cross:1A  star:1B  diamond:2A  triangle:2B

wi,1
plot,/ylog,yrange=[.001,100000],xrange=[0,400],/nodat,[0,0],$
     xtitle='DAC Threshold setting',ytitle='Average Counts/s',$
     title=strjoin( strsplit(file, '45d', /EXTRACT, /REGEX), '45')
for nch=0,nchs-1 do begin
  oplot,th[nch,*],si[nch,*],col=cols[nch/4],psym=-psym[nch mod 4]
  wait, .5
endfor

dacset = intarr(nchs)
for nch=0,nchs-1 do begin
  ;dacset[nch] = round(interp(th[nch,*],alog(si[nch,*] > th_rate/10),alog(th_rate)))
  dacset[nch] = round(interp(th[nch,*],si[nch,*],th_rate))
  ;stop
endfor
print,round(dacset)
stitle = string('REM th_rate=',th_rate)
print,th_rate,format='("REM th_rate=",f)'
soutput = strarr(nchs)
ch=ch-1
for nch=0,nchs-1 do begin
  chs = (nch mod 3) *4 + nch/3
  soutput[nch] = string(/print,nch ,dacset[chs],dacset[chs] ,format='(i2,"   0x",Z3,"   ",i3)')
  print, nch/4, nch mod 4,dacset[chs],dacset[chs] ,format='("/isstdacset ",i1," ",i1," ",z3,"  ; ",i3)'
endfor

string_out,[stitle,soutput],.7,.9

filepng = strjoin( strsplit(file, '45d', /EXTRACT, /REGEX), '45')+'thresh_'+time_string(format=2,ts[0],prec=-1)
makepng,filepng

end





pro Cdac,  tr,th_rate=th_rate
common share1, file
if not keyword_set(tr) then ctime,tr,npoints=2   ;2 element vector giving start and end time
if not keyword_set(th_rate) then th_rate=10.     ;counts/s

ch =   [[1,4,7,10],[2,5,8,11],[3,6,9,12]]   ; O,T,F channels
mapr = [[0,9],[13,15],[0,9]]   ; O,T,F bins from map
flag = strmatch( file, '*45a*' ) ? 'ion' : 'e'
thrname = 'thr'+string(ch,FORMAT='(i2.2)')
sname   = ['sE'+['1A','1B','2A','2B']+'_ion', $
       'sE'+['1A','1B','2A','2B']+'_ion', $
       'sE'+['1A','1B','2A','2B']+'_e']

tplot_options, 'windows', 0
Cdac_plot, ch,thrname,sname,mapr,tr,th_rate
end





function uc16, dat
;decompressed 8bits to 16bits
 ;tab16 = lonarr(256)
 tab16 =[ 0l,     1,     2,     3,     4,     5,     6,     7,     8,     9,    $    ;[0]
         10,    11,    12,    13,    14,    15,    16,    18,    20,    22,    $    ;[10]
         24,    26,    28,    30,    32,    36,    40,    44,    48,    52,    $    ;[20]
         56,    60,    64,    68,    72,    76,    80,    84,    88,    92,    $    ;[30]
         96,    100,   104,   108,   112,   116,   120,   124,   128,   136,   $    ;[40]
         144,   152,   160,   168,   176,   184,   192,   200,   208,   216,   $    ;[50]
         224,   232,   240,   248,   256,   272,   288,   304,   320,   336,   $    ;[60]
         352,   368,   384,   400,   416,   432,   448,   464,   480,   496,   $    ;[70]
         512,   544,   576,   608,   640,   672,   704,   736,   768,   800,   $    ;[80]
         832,   864,   896,   928,   960,   992,   1024,  1088,  1152,  1216,  $    ;[90]
         1280,  1344,  1408,  1472,  1536,  1600,  1664,  1728,  1792,  1856,  $    ;[100]
         1920,  1984,  2048,  2176,  2304,  2432,  2560,  2688,  2816,  2944,  $    ;[110]
         3072,  3200,  3328,  3456,  3584,  3712,  3840,  3968,  4096,  4224,  $    ;[120]
         4352,  4480,  4608,  4736,  4864,  4992,  5120,  5248,  5376,  5504,  $    ;[130]
         5632,  5760,  5888,  6016,  6144,  6272,  6400,  6528,  6656,  6784,  $    ;[140]
         6912,  7040,  7168,  7296,  7424,  7552,  7680,  7808,  7936,  8064,  $    ;[150]
         8192,  8448,  8704,  8960,  9216,  9472,  9728,  9984,  10240, 10496, $    ;[160]
         10752, 11008, 11264, 11520, 11776, 12032, 12288, 12544, 12800, 13056, $    ;[170]
         13312, 13568, 13824, 14080, 14336, 14592, 14848, 15104, 15360, 15616, $    ;[180]
         15872, 16128, 16384, 16896, 17408, 17920, 18432, 18944, 19456, 19968, $    ;[190]
         20480, 20992, 21504, 22016, 22528, 23040, 23552, 24064, 24576, 25088, $    ;[200]
         25600, 26112, 26624, 27136, 27648, 28160, 28672, 29184, 29696, 30208, $    ;[210]
         30720, 31232, 31744, 32256, 32768, 33792, 34816, 35840, 36864, 37888, $    ;[220]
         38912, 39936, 40960, 41984, 43008, 44032, 45056, 46080, 47104, 48128, $    ;[230]
         49152, 50176, 51200, 52224, 53248, 54272, 55296, 56320, 57344, 58368, $    ;[240]
         59392, 60416, 61440, 62464, 63488, 64512 ]                                 ;[250]
 datuc = tab16[dat]
return, datuc
end





pro read_thm_pkt_file,file,range=range,pktlength=pktlength,a_dsp=a_dsp,a_div=a_div,npkti=npkti,npktf=npktf,daytime=daytime
common share1, filen
;KEYWORDS::
;   file:   string name of the data file
;   pktlength:  length of a packet (in byte)
;   a_dsp:  structure contains data as defined by the packet format
;   a_div:  structure which combines the 3 full distributions
;   npkti:  if set, packet number less than this value will be omitted
;   npktf:  if set, packet number more than this value will be omitted
;-
if not keyword_set(pktlength) then pktlength=2836
filen=file
openr, fp, file, /get_lun
fs = fstat(fp)
;printdat,fs
if keyword_set(range) then begin
  ptr = round(double(range)*fs.size/pktlength) * pktlength
  point_lun,fp,ptr[0]
  npkt = (ptr[1]-ptr[0])/ pktlength
endif else npkt = fs.size / pktlength
if keyword_set(daytime) then dt=3600. else dt=0.     ;Daylight Saving Time

if not keyword_set(npkti) then npkti=0
if not keyword_set(npktf) then npktf=npkt

dat = {tm:bytarr(6),    $
       t:bytarr(6),     $
       etc:bytarr(4),   $
       conf1:bytarr(2), $
       door1:bytarr(1), $
       spin1:bytarr(1), $
       n1:bytarr(1024), $
       conf2:bytarr(2), $
       door2:bytarr(1), $
       spin2:bytarr(1), $
       n2:bytarr(1024), $
       conf3:bytarr(2), $
       door3:bytarr(1), $
       spin3:bytarr(1), $
       n3:bytarr(1024-(3100-pktlength))}

dsp = {time:0d, dat_len:0l, door1:bytarr(1), spin1:bytarr(1), n1:lonarr(1024), $
       door2:bytarr(1), spin2:bytarr(1), n2:lonarr(1024), door3:bytarr(1), $
       spin3:bytarr(1), n3:lonarr(1024-(3100-pktlength))}   ;, n3:lonarr(1024)}
div = {time:0d, door:bytarr(1), spin:bytarr(1), n:lonarr(1024)}

a_dat = replicate(dat,1)
a_dsp = replicate(dsp,npktf-npkti)
a_div = replicate(div,3*(npktf-npkti))
timo  = 0.d
ntpkt = 0l
ndiv  = 0l

for i=0,npktf-1 do begin
  readu,fp,a_dat

  dat_len=a_dat.tm[4]*256l+a_dat.tm[5]
;  print, 'dat_len:',dat_len

  if (i ge npkti) and (i le npktf) then begin
    ;s = average(double(((a_dat.t[0]*256ul+a_dat.t[1])*256ul+a_dat.t[2])*256ul+a_dat.t[3]))
    ;ssub = a_dat.t[4]*256ul+a_dat.t[5]
    ;time = s + ssub/2.^16 + time_double('1900') -8*3600. ;Referenced at the 1970-01-01
    time = thm_tlm_time(a_dat.t,/local)
 ;   time=time+7*3600. ;to change to UTC time

;    if  strpos(file,'EMC') gt 0 or strpos(file,'040405') gt 0 or strpos(file,'040505') gt 0  or strpos(file,'041205') gt 0 then $
      time = time + dt       ;Daylight Saving Time
      ;daylight saving applied for the 040405 data packets

    if time le timo then begin
      ;time  = timo +9. -1.
      print, 'ERROR:', time_string(time)
    endif
    if time gt timo then begin
      timo = time + 1.      ;1s delay

      ;a_dsp(ntpkt) = {time:time, dat_len:dat_len, door1:a_dat.door1, spin1:a_dat.spin1, $
      ;   n1:a_dat.n1, door2:a_dat.door2, spin2:a_dat.spin2, n2:a_dat.n2, door3:a_dat.door3, $
      ;   spin3:a_dat.spin3, n3:a_dat.n3}
      a_dsp(ntpkt) = {time:time, dat_len:dat_len, door1:a_dat.door1, spin1:a_dat.spin1, $
         n1:uc16(a_dat.n1), door2:a_dat.door2, spin2:a_dat.spin2, n2:uc16(a_dat.n2), door3:a_dat.door3, $
         spin3:a_dat.spin3, n3:uc16(a_dat.n3)}  ;, n3:lonarr(1024)
      ;a_dsp(ntpkt).n3=uc16(a_dat.n3)

      ntpkt = ntpkt + 1
    endif
  endif
endfor

for ndiv=0l,ntpkt-1l do begin
  if ndiv ne ntpkt-1 then  dtime = a_dsp(ndiv+1).time - a_dsp(ndiv).time
  fract = dtime/3.

  a_div(3*ndiv)     = {time:a_dsp(ndiv).time,         door:a_dsp(ndiv).door1, spin:a_dsp(ndiv).spin1, n:a_dsp(ndiv).n1}
  a_div(3*ndiv+1)   = {time:a_dsp(ndiv).time+fract,   door:a_dsp(ndiv).door2, spin:a_dsp(ndiv).spin2, n:a_dsp(ndiv).n2}
  a_div(3*ndiv+2)   = {time:a_dsp(ndiv).time+2*fract, door:a_dsp(ndiv).door3, spin:a_dsp(ndiv).spin3, n:lonarr(1024)} ;n:a_dsp(ndiv).n3}
  a_div(3*ndiv+2).n = a_dsp(ndiv).n3
endfor

print, npktf-npkti, format='("NB PKTS READ: ",i4)'
print, ntpkt, format='("NB PKTS USED: ",i4)'

make_plot_data,file,a_dsp=a_dsp,a_div=a_div,pktlength=pktlength,ntpkt=ntpkt

free_lun,fp
end







function get_log_message,fp
 b = 0
 b0 = 0b
 point_lun,-fp,pos
 while b0 ne 'a'x do begin
  readu,fp,b0
  append_array,b,b0
 endwhile

 year = fix(string(b[6:9]))
 month= fix(string(b[0:1]))
 date = fix(string(b[3:4]))
 hour = fix(string(b[11:12]))
 min  = fix(string(b[14:15]))
 sec  = fix(string(b[17:18]))
 times= {year:year, month:month, date:date, hour:hour, min:min, sec:sec, fsec:0}

 mess_len = size(b,/N_ELEMENTS)
 message = {pos:pos,len:mess_len, time:time_double(times), buf:b}

 return,message
end





pro log_message,m,log_dat,spb,val,dltime,dt
time=double(m.time)+dltime+dt
;time=time+7*3600.    ;to change to UTC time

mess = strsplit(string(m.buf[22:m.len-3]),' ',/extract)
if string(m.buf[22]) eq ' ' then begin
  return
endif
if string(m.buf[22:26]) eq 'START'  then begin
  append_array,log_dat,{time:time,y:string(m.buf[25:m.len-3])}
;  print, 'Time:', time_string(time), '  START:', string(m.buf[25:m.len-3])
endif
if (string(m.buf[22:24]) eq 'REM'  AND  m.buf[25] ne 'd'x) then begin
  append_array,log_dat,{time:time,y:string(m.buf[25:m.len-3])}
;  print, 'Time:', time_string(time), '  REM:', string(m.buf[25:m.len-3])
endif
if (string(m.buf[22:24]) eq 'REM'  AND  m.buf[25] eq 'd'x) then begin
  return
endif
if string(m.buf[22:m.len-3]) eq '/idpurawhex b400'  then begin
  append_array,log_dat,{time:time,y:string(m.buf[22:m.len-3])}
;  print, 'Time:', time_string(time), '  ', string(m.buf[22:m.len-3])
endif
if mess[0] eq '/isstspb' then begin
  ind = fix(mess[1])
  val[ind] = where(mess[3] ne 0)+1
  y = val[0] + (2*val[1])^1 + (2*val[2])^2 + (2*val[3])^3
  append_array,spb,{time:time,y:y}
endif
end





pro read_log_message,lgfile,pos=pos,reset=reset,nmessages=nmessages,log_dat=log_dat,dltime=dltime,daytime=daytime
;KEYWORDS:
;      dltime    Added time to the PC clock (log file) to adjust it with the NIOS clock (packets)
;
openr, fp, lgfile, /get_lun
fs = fstat(fp)
;prindat, fs
if keyword_set(daytime) then dt=3600. else dt=0.     ;Daylight Saving Time
if not keyword_set(dltime) then dltime=0.d
if keyword_set(reset) then begin
   log_dat = 0
   spb = 0
   dac_dat = 0
   time = 0d
endif
val = replicate(0,4)
if n_elements(pos) ne 0 then point_lun,fp,pos
nm = keyword_set(nmessages) ? nmessages : -1l
while nm ne 0 and not eof(fp) do begin
   m = get_log_message(fp)
   log_message,m,log_dat,spb,val,dltime,dt
   nm = nm-1
endwhile


if keyword_set(log_dat) then $
store_data,'log',data={x:log_dat.time,y:log_dat.y},dlim={tplot_routine:'strplot'}
if keyword_set(spb) then $
store_data,'spb',data={x:spb.time,y:spb.y mod 16}, $
    dlim={tplot_routine:'bitplot',numbits:4,colors:'mcyd',labels:['grp0','grp1','grp2','grp3'],yrange:[-1,4]}

message,/info,"Unable to run load_log_data"
;load_log_data,lgfile,log=log,stime=dltime+dt

free_lun,fp
end








pro make_plot_data,file,a_dsp=a_dsp,a_div=a_div,pktlength=pktlength,ntpkt=ntpkt
  flag = strmatch( file, '*45a*' ) ? 'ion' : 'e'

  if keyword_set(a_div) then begin
    tdat = transpose(a_div(0:3*(ntpkt-1l)).n)
    store_data, 'spec'+'_'+flag, $
        data={x:a_div(0:3*(ntpkt-1l)).time,y:float(tdat),v:findgen(1024)}, $
        dlim={spec:1,no_inter:1}

 ; ETC mapping:      16  phi sectors
 ;     x   4  look-directions - teta polar angle  (1A, 1B, 2A, 2B)
 ;     x  16  energy bins

    step = lindgen(16)
    bin  = replicate(0,256)
    tetname = ['1A','2B','1B','2A']
    tdato   = replicate(0.,n_elements(a_div(0:3*(ntpkt-1l)).time),16)
    maxspecE=0.
    maxspec=0.

   for i=0,3 do begin             ;indice of 4 look-directions (two SST units)
       name = string(tetname[i],format='("s",A2)')+'_'+flag

   ;16 phi sectors x 16 energy bins selected by each look-direction (teta angle)
      for j=0,15 do  bin[16*j] = 4*16*j+16*i+step
      store_data,name,data={x:a_div(0:3*(ntpkt-1l)).time,y:float(tdat[*,bin]),v:lindgen(256)},dlim={spec:1,no_inter:1}
      get_data,name,data=tdatu
      maxspec = max([maxspec,max(tdatu.y)])

   ;energy spectra (sum over 16 phi sectors for each look-direction)
      for j=0,15 do  tdato[*,j] = total(tdatu.y[*,step+16*j],2)
;      for j=0,15 do  tdato[*,j] = average(tdatu.y[*,step+16*j],2,/nan)
      nami = string(tetname[i],format='("sE",A2)')+'_'+flag
      store_data,nami,data={x:a_div(0:3*(ntpkt-1l)).time,y:tdato,v:0}
;      store_data,nami,data={x:a_div(0:3*(ntpkt-1l)).time,y:tdato,v:lindgen(16)},dlim={spec:1,no_interp:1}
      maxspecE = max([maxspecE,max(tdato)])

      nchan = 3
      ind   = indgen(nchan)
      if (ioname(file) eq 'open') then  begin
        lab=['O','OT','T']   ;look at the map SST-MAP-ETC-10
        npart=[10,3,3]
        cols=['b','c','g']
      endif else begin
        lab=['F','FT','FTO']
        npart=[10,5,1]
        cols=['r','m','y']
      endelse
      nparto=0
      cdat = {cnt:replicate(!values.f_nan,n_elements(a_div(0:3*(ntpkt-1l))))}
      dat  = {ch:replicate(cdat,nchan)}
      for c=0,nchan-1 do begin
        dim=(npart[c]-1+nparto)-nparto
        dat.ch[c].cnt= (dim gt 0) ? total(tdato[*,nparto:npart[c]-1+nparto],2) : tdato[*,nparto]
        nparto=npart[c]+nparto
        nam = tetname[i]+lab[c]
        store_data,nam,data={x:a_div(0:3*(ntpkt-1l)).time,y:dat.ch[c].cnt}, $
       dlim={colors:cols[c]}
      endfor
      namC = string(tetname[i],format='("C",A2)')+'_'+flag
      store_data,namC,data={x:a_div(0:3*(ntpkt-1l)).time,y:dat.ch[ind].cnt}, $
                  dlim={ylog:1,labels:lab,labflag:-1,colors:cols}
   endfor
   options,'1* 2*', yrange=[0.8,1.e6], ylog=1,ystyle=1
   options,'s??_*', zrange=[0.8,maxspec], zstyle=1,zlog=1,no_interp=1
   options,'sE??_*',yrange=[0.8,maxspecE],ystyle=1,ylog=1
   store_data,'door',data={x:a_div(0:3*(ntpkt-1l)).time,y:transpose(a_div(0:3*(ntpkt-1l)).door)}
   store_data,'spin',data={x:a_div(0:3*(ntpkt-1l)).time,y:transpose(a_div(0:3*(ntpkt-1l)).spin)}
   options, 'door', tplot_routine='bitplot',yrange=[0,5],yticks=5, $
                labels=['close1','open1','close2','open2'],panel_size=2
  endif

;  if keyword_set(a_dsp) then begin
;    store_data,'dat_len',data={x:a_dsp(0:ntpkt-1).time,y:a_dsp(0:ntpkt-1).dat_len}
;    tdat1 = transpose(a_dsp(0:ntpkt-1).n1)
;    store_data,'spec1'+'_'+flag,data={x:a_dsp(0:ntpkt-1).time,y:float(tdat1),v:findgen(1024)},dlim={spec:1,no_inter:1}
;    tdat2 = transpose(a_dsp(0:ntpkt-1).n2)
;    store_data,'spec2'+'_'+flag,data={x:a_dsp(0:ntpkt-1).time,y:float(tdat2),v:findgen(1024)},dlim={spec:1,no_inter:1}
;    tdat3 = transpose(a_dsp(0:ntpkt-1).n3)
;    store_data,'spec3'+'_'+flag,data={x:a_dsp(0:ntpkt-1).time,y:float(tdat3),v:findgen(1024-(3100-pktlength))},dlim={spec:1,no_inter:1}
;
; ETC mapping:
;    step = lindgen(16)
;    bin = replicate(0,256)
;    tetname = ['1A','2B','1B','2A']
;    tda1o = replicate(0.,n_elements(a_dsp(0:ntpkt-1).time),16)
;    tda2o = replicate(0.,n_elements(a_dsp(0:ntpkt-1).time),16)
;    tda3o = replicate(0.,n_elements(a_dsp(0:ntpkt-1).time),16)
;
;    for i=0,3 do begin             ;indice of 4 look-directions (two SST units)
;      name1 = string(tetname[i],format='("spec1_",A2)')+'_'+flag
;      name2 = string(tetname[i],format='("spec2_",A2)')+'_'+flag
;      name3 = string(tetname[i],format='("spec3_",A2)')+'_'+flag
;
;    ;16 phi sectors x 16 energy bins selected by each look-direction (teta angle)
;      for j=0,15 do  bin[16*j] = 4*16*j+16*i+step
;      store_data,name1,data={x:a_dsp(0:ntpkt-1).time,y:float(tdat1[*,bin]),v:lindgen(256)},dlim={spec:1,no_inter:1}
;      store_data,name2,data={x:a_dsp(0:ntpkt-1).time,y:float(tdat2[*,bin]),v:lindgen(256)},dlim={spec:1,no_inter:1}
;      store_data,name3,data={x:a_dsp(0:ntpkt-1).time,y:float(tdat3[*,bin]),v:lindgen(256)},dlim={spec:1,no_inter:1};
;
;      get_data,name1,data=tda1
;      get_data,name2,data=tda2
;      get_data,name3,data=tda3
;
;    ;energy spectra (sum over 16 phi sectors for each look-direction)
;      for j=0,15 do begin
;        tda1o[*,j] = total(tda1.y[*,step+16*j],2)
;        tda2o[*,j] = total(tda2.y[*,step+16*j],2)
;        tda3o[*,j] = total(tda3.y[*,step+16*j],2)
;      endfor

;      nami1 = string(tetname[i],format='("s1E_",A2)')+'_'+flag
;      nami2 = string(tetname[i],format='("s2E_",A2)')+'_'+flag
;      nami3 = string(tetname[i],format='("s3E_",A2)')+'_'+flag
;
;      store_data,nami1,data={x:a_dsp(0:ntpkt-1).time,y:tda1o,v:0}
;      store_data,nami2,data={x:a_dsp(0:ntpkt-1).time,y:tda2o,v:0}
;      store_data,nami3,data={x:a_dsp(0:ntpkt-1).time,y:tda3o,v:0}
;    endfor

;    store_data,'door1',data={x:a_dsp(0:ntpkt-1).time,y:transpose(a_dsp(0:ntpkt-1).door1)}
;    store_data,'door2',data={x:a_dsp(0:ntpkt-1).time,y:transpose(a_dsp(0:ntpkt-1).door2)}
;    store_data,'door3',data={x:a_dsp(0:ntpkt-1).time,y:transpose(a_dsp(0:ntpkt-1).door3)}
;    options, 'door?', tplot_routine='bitplot',yrange=[0,5],yticks=5,labels=['close1','open1','close2','open2']

;    store_data,'spin1',data={x:a_dsp(0:ntpkt-1).time,y:transpose(a_dsp(0:ntpkt-1).spin1)}
;    store_data,'spin2',data={x:a_dsp(0:ntpkt-1).time,y:transpose(a_dsp(0:ntpkt-1).spin2)}
;    store_data,'spin3',data={x:a_dsp(0:ntpkt-1).time,y:transpose(a_dsp(0:ntpkt-1).spin3)}

;  endif
end






;path = 'E:\THEMIS\SST\Testing\IDPU Testing\'
;path = 'Z:\Data'
; Select files 45a for ions (45d will be automatically selected for electrons)
if keyword_set(reset) then begin
   file='' & lgfile='' & tvfile='' & hskfile=''
   path=''
   print, "files erased"
   reset=0
endif
;if  keyword_set(reset) then begin
   path = dialog_pickfile(/direc,path=path)
;endif
file_45a = file_search(path+'*45a.pkt')
file_45d = file_search(path+'*45d.pkt')
file_45b = file_search(path+'*45b.pkt')
file_45c = file_search(path+'*45c.pkt')
lgfile = file_search(path+'gse.log')
pfile_404 = file_search(path+'*0_404.pkt')
pfile_406 = file_search(path+'*0_406.pkt')
tvfiles =  file_search(path+'*.Xls')
;if not keyword_set(file) then file = dialog_pickfile(filter='*45a.pkt',path=path,get_path=path)
;if not keyword_set(lgfile) then lgfile = dialog_pickfile(filter=['*log', '*LOG'],path=path,get_path=path)
;if not keyword_set(tvfile) then tvfile = dialog_pickfile(filter=['*xls', '*XLS'],path=path,get_path=path)
;if not keyword_set(hskfile) then hskfile = dialog_pickfile(filter='*404.pkt',path=path,get_path=path)

if file_45a ne '' then begin
; READ IONS DATA
;  file_ion = file_45a[0]
;;  print, 'Reading...',file_ion
  read_thm_pkt_file,file_45a[0],pktlength=3100,npkti=0        ;,npktf=745
endif

if file_45d ne '' then begin
; READ ELECTRONS DATA
 ; file_e = strjoin( strsplit(file, '45a', /EXTRACT, /REGEX), '45d')
 ;file_e = file_45d[0]
 ; print, 'Reading...',file_e
  read_thm_pkt_file,file_45d[0],pktlength=3100,npkti=0 ;,npktf=745
endif

if file_45b ne '' then begin
; READ IONS DATA
;  file_ion = file_45a[0]
;;  print, 'Reading...',file_ion
  read_thm_pkt_file,file_45b[0],pktlength=3100,npkti=0        ;,npktf=745
endif

if file_45c ne '' then begin
; READ ELECTRONS DATA
 ; file_e = strjoin( strsplit(file, '45a', /EXTRACT, /REGEX), '45d')
 ;file_e = file_45d[0]
 ; print, 'Reading...',file_e
  read_thm_pkt_file,file_45c[0],pktlength=3100,npkti=0 ;,npktf=745
endif

; READ LOG FILE
if lgfile ne '' then begin
;  print, 'Reading...' ;,lgfile
  read_log_message,lgfile[0],pos=0    ;,dltime=110.;,dltime=-3600.
endif

; READ TEMPERATURE DATA
if tvfiles ne '' then begin
;  print, 'Reading:',tvfile
  load_tvfile,file=tvfiles
endif

; READ 404 AND 406 PKT
if keyword_set(pfile_404)  then begin
;  pfile_404 = hskfile
  def_pkt_dir = 'E:\THEMIS\SST\Testing\IDPU Testing\*'
  pick_pkt_file=0
  frac = 0
  print, 'Reading...',pfile_404
  thm_load_pkt_2, apid='apid_404', pfile=pfile_404, pick_pkt_file=pick_pkt_file, $
    pkt_struct=pkt_struct, /tplot_store, frac=frac,       $
    def_pkt_dir=def_pkt_dir , pkt_data=pkt_data  ; , daytime=daytime
;  sst_load_hsk, pkt_struct=pkt_struct, pkt_data=pkt_data

  ;pfile_406 = strjoin( strsplit(hskfile, '404', /EXTRACT, /REGEX), '406')
  def_pkt_dir = 'E:\THEMIS\SST\Testing\IDPU Testing\*'
  pick_pkt_file=0
  frac = 0
  print, 'Reading...',pfile_406
  thm_load_pkt_2, apid='apid_406', pfile=pfile_406, pick_pkt_file=pick_pkt_file, $
    pkt_struct=pkt_struct, /tplot_store, frac=frac,       $
    def_pkt_dir=def_pkt_dir ;, pkt_data=pkt_data ; , daytime=daytime
endif

;device,decomp=0
;loadct2,34
;@b_on_w     !fond blanc
;@w_on_b    !fond noir


tplot_options,window=0
wi
tplot_options,title='SST with IDPU: ';, $
;    subtitle=strjoin( strsplit(file, '45a', /EXTRACT, /REGEX), '45')
!p.charsize=.7

tetname = ['1A','1B','2A','2B']
;tplot, 'spin'

lab=['O','OT','T','F','FT','FTO']
cols=['b','c','g','r','m','y']
store_data, 'C1A', data='1AO 1AOT 1AT 1AF 1AFT 1AFTO', dlim={ystyle:1,ytitle:'1A'}
store_data, 'C1B', data='1BO 1BOT 1BT 1BF 1BFT 1BFTO', dlim={ystyle:1,ytitle:'1B'}
store_data, 'C2A', data='2AO 2AOT 2AT 2AF 2AFT 2AFTO', dlim={ystyle:1,ytitle:'2A'}
store_data, 'C2B', data='2BO 2BOT 2BT 2BF 2BFT 2BFTO', dlim={ystyle:1,ytitle:'2B'};,labels:lab,labflag:-1,colors:cols}
options, 'C??', panel_size=2,ylog=1,yrange=[0.8,1.e6]

tit=''
for i=0,3,1 do tit = tit + string(tetname[i],format='(" s",A2)')+'_ion'   + $
            string(tetname[i],format='(" s",A2)')+'_e'     + $
                           string(tetname[i],format='(" C",A2)')

get_data, 'spec_ion', data=sp_ion
get_data, 'spec_e'  , data=sp_e
t0=sp_e.x[0]
t1=sp_e.x[n_elements(sp_e.x)-1]
;tlimit, t0, t1
;tlimit, '2004-11-05/02:04', '2004-11-05/03:01'
maxs=max([sp_ion.y,sp_e.y])

ylim,'spec_*',0,1023,0
ylim,'s??_*',0,255,0

zlim,'spec_* s??_*',0.8,maxs,1
zlim,'sE*',0.8,1000,1

options, 'spec* s*',  no_interp=1
options, 'spec_*', panel_size=5
options, 'sE*', panel_size=2
options, 'log',    panel_size=3

get_data, 's1A_e', data=sp1a
get_data, 's2A_e', data=sp2a
sp1={x:sp1a.x, y:total(sp1a.y[*,145:165],2)}
store_data, 'sp1', data=sp1
sp2={x:sp2a.x, y:total(sp2a.y[*,145:165],2)}
store_data, 'sp2', data=sp2
;tplot, 'sp1 sp2', /add

;get_data, 'TV-Temps', data=tv
;store_data, 'SST-Temp', data={x:tv.x,y:tv.y[*,26]}

zlim, 'noise', 0,0,1

;tplot, 'SST-Temp SST-Temp door dacvals_ log' + tit +' spec_*',trange=[t0,t1]
tplot, 'SOH_404_IMON_P5VA hsk_door hsk_np hsk_ndt  hsk_den dacvals_ log C?? spec_* noise', trange=[t0,t1]

;tplot, tsum
;wset, 0
;makepng, filename
;options, 'name', colors='mbcgyr'

end

