
pro nspec,noshow=noshow,np=np,t,varname,ncuts=ncuts
;used for noise histograms [12 detectors  x  10 bins]

@tplot_com.pro

; setup tplot_vars....
title_old=tplot_vars.options.title

if n_elements(np) eq 0 then np=2
if n_elements(ncuts) eq 0 then ncuts=10000

for i=0,ncuts-1  do begin
 ctime,t,np=np,vnam=varname,noshow=i
 varnames=varname
 n = 0
 repeat begin
  if not keyword_set(t) then return
  get_data,varnames[n],data=d

  lim = 0
  str_element,lim,'window',-1,/add
  str_element,lim,'wshow',0,/add
  str_element,lim,'title',varname[0]+'  '+trange_str(t),/add
  str_element,lim,'xtitle','Detectors',/add
  str_element,lim,'ytitle','Counts',/add

  ;Create a X-axis with a title:
  !x.tickname=' '
  str_element,/add,lim,'xticklen',.05
  str_element,/add,lim,'xticks',12
  str_element,/add,lim,'xtickv',[lindgen(12)*10]

  xtags=replicate(' ',13)
  xtags[0:11]=Strcompress(lindgen(12),/REMOVE_ALL)
  str_element,/add,lim,'xtickname',xtags

  if not keyword_set(d) then return

  if n_elements(t) eq 2 then w = where(d.x ge t(0) and d.x lt t(1),c)
  if n_elements(t) eq 1 then dummy = min(abs(d.x - t[0]),w)
  z = d.y(w,*)
  z = average(z,1,/nan)
  x = d.x(w)
  yy = z
  str_element,lim,'xrange',[0,120],/add
  str_element,lim,'yrange',[0,max(yy)],/add

  if (!d.flags and 256) ne 0  then begin    ; windowing devices
   current_window= !d.window > 0
   if lim.window gt 0 then w = lim.window $
   else w = current_window
   if !d.window eq 0 and lim.window eq 0  then begin
      w = 1
      window, w
   endif
   wset,w
   if lim.wshow ne 0 then wshow,icon=0
  endif

  col = bindgen(7)+1b
  append_array, col,bindgen(5)+1b
  for i=0,11 do   append_array, cols,replicate(col[i],10)

  plot, x,yy,  /nodata,xtitle=lim.xtitle,ytitle=lim.ytitle,title=lim.title, $
               xrange=lim.xrange,yrange=lim.yrange,xticklen=lim.xticklen,   $
               xticks=lim.xticks,xtickv=lim.xtickv,xtickname=lim.xtickname
  barfill, yy, colors=cols,/overplot,/outline

  str_element,tplot_vars,'options.title',title_old,/add_replace
  !x.tickname=''

 endrep until 1
endfor

end






function bitarray, dat,p=p
; dat is the decimal value
; p is the number of bits
ndim=n_elements(dat)
if not keyword_set(p) then begin
   p=1
   while (max(dat) ge 2l^p) do   p=p+1
endif
bits = bytarr(ndim,p)
for i=0l,ndim-1l do begin
   for kp=p-1,0,-1 do  bits[i,kp]= (dat[i] and 2l^kp) / 2l^kp
endfor
return, bits     ; LSB->MSB
end







pro make_plot_hsk_sst,hsk_dat=hsk_dat,noise_dats=noise_dats
 if keyword_set(hsk_dat) then begin
   store_data,'hsk_nen',data={x:hsk_dat.time,y:hsk_dat.hsk_nen}
   store_data,'hsk_nres',data={x:hsk_dat.time,y:hsk_dat.hsk_nres}
   for i=1,12 do  hsk_dat.hsk_den[*,i-1]=hsk_dat.hsk_den[*,i-1]*i-1
   den_dat = hsk_dat.hsk_den
   store_data,'hsk_den',data={x:hsk_dat.time,y:den_dat}
   store_data,'hsk_cmd',data={x:hsk_dat.time,y:hsk_dat.hsk_cmd}
   store_data,'hsk_pen',data={x:hsk_dat.time,y:hsk_dat.hsk_pen}
   for i=1,3 do  hsk_dat.hsk_pFTO[*,i-1]=hsk_dat.hsk_pFTO[*,i-1]*i-1
   pFTO_dat = hsk_dat.hsk_pFTO
   store_data,'hsk_pFTO',data={x:hsk_dat.time,y:pFTO_dat}
   for i=1,4 do  hsk_dat.hsk_door[*,i-1]=hsk_dat.hsk_door[*,i-1]*i-1
   door_dat = hsk_dat.hsk_door
   store_data,'hsk_door',data={x:hsk_dat.time,y:door_dat}
   for i=1,4 do  hsk_dat.hsk_spb[*,i-1]=hsk_dat.hsk_spb[*,i-1]*i-1
   spb_dat = hsk_dat.hsk_spb
   store_data,'hsk_spb',data={x:hsk_dat.time,y:spb_dat}
   store_data,'hsk_mft',data={x:hsk_dat.time,y:hsk_dat.hsk_mft}
   store_data,'hsk_tpt',data={x:hsk_dat.time,y:hsk_dat.hsk_tpt}
   store_data,'hsk_ept',data={x:hsk_dat.time,y:hsk_dat.hsk_ept}
   store_data,'hsk_ndt',data={x:hsk_dat.time,y:hsk_dat.hsk_ndt}
   store_data,'hsk_nmt',data={x:hsk_dat.time,y:hsk_dat.hsk_nmt}
   store_data,'hsk_blrd',data={x:hsk_dat.time,y:hsk_dat.hsk_blrd}
   store_data,'hsk_sect',data={x:hsk_dat.time,y:hsk_dat.hsk_sect}
   store_data,'hsk_np',data={x:hsk_dat.time,y:hsk_dat.hsk_np}
   store_data,'hsk_evc',data={x:hsk_dat.time,y:hsk_dat.hsk_evc}
   options,'hsk_nen hsk_pen hsk_blrd',yrange=[-.5,1.5],ysize=1,yticks=2,$
           ytickv=[0,1],yticklen=0.01,nocolor=1,psym=3
   options,'hsk_door hsk_spb',yrange=[-.5,3.5],ystyle=1,ysize=1,yticks=4, $
           ytickv=[0,1,2,3],yticklen=0.01,min_value=0,max_value=3,nocolor=1,psym=3
   options,'hsk_pFTO',yrange=[-.5,2.5],ystyle=1,ysize=1,yticks=3,ytickv=[0,1,2],$
           yticklen=0.01,min_value=0,max_value=2,nocolor=1,psym=3
   options,'hsk_den',yrange=[-.5,11.5],ystyle=1,ysize=1,yticks=12,ytickv=indgen(12),$
           yticklen=0.01,min_value=0,max_value=11,nocolor=1,psym=3
 endif

 if keyword_set(noise_dats) then begin
  ;help, noise_dats, /str
  ndat = transpose(noise_dats.dat)
  store_data,'noise',data={x:noise_dats.time,y:float(ndat),v:indgen(8*12)},      $
       dlim={spec:1,no_interp:1,zlog:1,zrange:[.8,max(noise_dats.dat)],zstyle:1, $
             panel_size:2,yrange:[0,95],ystyle:1,ysize:1,yticks:12,              $
             ytickname:[string(indgen(12)),' '],yticklen:1.}
 endif

return
end







pro sst_load_hsk, pkt_struct=pkt_struct, pkt_data=pkt_data

time = pkt_struct.t_hdr
d = {dump_adr:pkt_data.IDPU_DUMPADR, b:pkt_data.IMEMDUMP}
w = replicate(0l,N_ELEMENTS(time),8)
for i=0,7 do  w[*,i] = d.b[*,2*i+1] + 256l * d.b[*,2*i]      ; word (2 bytes)

;Housekeeping Data
 c_hsk = where(d.dump_adr eq '7400'x)
 time_hsk = time[c_hsk]
 hsk_nen  = (w[c_hsk,0] and 32768) / 2l^15    ; NOISE_EN, Noise analysis enable         [1]
 hsk_nres = (w[c_hsk,0] and 28672) / 2l^12    ; NOISE_RES, Noise data resolution        [3]
 det_enb  = (w[c_hsk,0] and  4095) / 2l^0
 hsk_den  = bitarray(det_enb,p=12)  ; SENSOR_EN[12:1], the 12 sensor enable bit map [12]
 hsk_cmd  = (w[c_hsk,1] and 65280) / 2l^8 ; CMD_CNT[7:0], Number commands received    [8]
 hsk_pen  = (w[c_hsk,1] and   128) / 2l^7 ; Test Pulser Enable          [1]
 pFTO     = (w[c_hsk,1] and   112) / 2l^4
 hsk_pFTO = bitarray(pFTO,p=3)   ; Test Pulse FTO Pattern [2:0]       [3]
 door     = (w[c_hsk,1] and    15) / 2l^0
 hsk_door = bitarray(door,p=4)      ; Door Monitor [3:0]          [4]
 mux      = (w[c_hsk,2] and 57344) / 2l^13    ; Analog Mux Address[2:0]       [3]
 dump_adr = (w[c_hsk,2] and  8176) / 2l^4 ; Memory Dump Address[16:8]        [9]
 spb      = (w[c_hsk,2] and    15) / 2l^0
 hsk_spb  = bitarray(spb,p=4)     ; SPB[4:1] On/Off Status        [3]
 mapID    = (w[c_hsk,5] and 65280) / 2l^8 ; Map ID[7:0]             [8]
 fpga     = (w[c_hsk,5] and   255) / 2l^0 ; FPGA Revision Number[7:0]        [8]
 hsk_np   = (w[c_hsk,7] and 65535) / 2l^0 ; No-Peaks count          [16]

;if fpga[0] gt 20 then begin
; print, 'ERROR FPGA version', fpga
; return
;endif
if fpga[0] lt 20 then begin
 hsk_evc  = 0l
 hsk_mft  = (w[c_hsk,3] and 61440) / 2l^12    ; Bus timeout counter[3:0] caused by Memory Fill command [4]
 hsk_tpt  = (w[c_hsk,3] and  3840) / 2l^8 ; Bus timeout counter[3:0] caused by telemetry process [4]
 hsk_ept  = (w[c_hsk,3] and   255) / 2l^0 ; Bus timeout counter[7:0] caused by event process [4]
 hsk_ndt  = (w[c_hsk,4] and   255) / 2l^0 ; Number of detectors timeout      [8]
 hsk_nmt  = (w[c_hsk,6] and 65280) / 2l^8 ; Number of Noise Measurement timeout     [8]
 hsk_blrd = (w[c_hsk,6] and    32) / 2l^5 ; BLRD Operation Mode          [1]
 hsk_sect = (w[c_hsk,6] and    31) / 2l^0 ; Sector counter, rotate 0 ~ 31        [5]
endif else begin
 hsk_mft  = (w[c_hsk,3] and 61440) / 2l^12    ; Bus timeout counter[3:0] caused by Memory Fill command [4]
 hsk_tpt  = (w[c_hsk,3] and  3840) / 2l^8 ; Bus timeout counter[3:0] caused by telemetry process [4]
 hsk_ept  = (w[c_hsk,3] and   240) / 2l^4 ; Bus timeout counter[3:0] caused by event process [4]
 hsk_nmt  = (w[c_hsk,3] and    15) / 2l^0 ; Noise Measurement Timeout Count     [4]
 hsk_evc  = (w[c_hsk,4] and 65535) / 2l^0 ; Event Count – The number of events processed over the last sector period [16]
 hsk_ndt  = (w[c_hsk,6] and 65280) / 2l^8 ; Number of detectors timeout      [8]
 hsk_blrd = (w[c_hsk,6] and    32) / 2l^5 ; BLRD Operation Mode          [1]
 hsk_sect = (w[c_hsk,6] and    31) / 2l^0 ; Sector counter, rotate 0 ~ 31        [5]
endelse


;Noise histogram: 10 bins 1 word wide
 noise_adr = ['7409'x,'7413'x,'741D'x,'7427'x,'7431'x,'743B'x, $
	      '7445'x,'744F'x,'7459'x,'7463'x,'746D'x,'7477'x]
 c_noise = where(d.dump_adr ge '7409'x and d.dump_adr le '7477'x)
 if size(c_noise,/n_elements) ne 1 then $
     for i=0,n_elements(c_noise)-1l do begin
         array = replicate(0l,12*8)
         chn = where( d.dump_adr(c_noise[i]) eq noise_adr )
	 for j=0,7 do array[chn*8+j] = w(c_noise[i],j)
	 noise_dat = {time:time(c_noise[i]), dat:array}
	 append_array, noise_dats, noise_dat
     endfor
 
 ;help, mux
 ;help, dump_adr
 ;help, mapID
 print, 'fpga vers: ',fpga(n_elements(fpga)-10)

 hsk_dat = {time:time_hsk,hsk_nen:hsk_nen,hsk_nres:hsk_nres,   $
        hsk_den:hsk_den,hsk_cmd:hsk_cmd,hsk_pen:hsk_pen,hsk_pFTO:hsk_pFTO, $
        hsk_door:hsk_door,hsk_spb:hsk_spb,hsk_mft:hsk_mft,hsk_tpt:hsk_tpt, $
        hsk_ept:hsk_ept,hsk_ndt:hsk_ndt,hsk_nmt:hsk_nmt,hsk_blrd:hsk_blrd, $
        hsk_sect:hsk_sect,hsk_np:hsk_np,hsk_evc:hsk_evc}

 make_plot_hsk_sst, hsk_dat=hsk_dat,noise_dats=noise_dats

return
end




