
function calib_cutspec, xd,yd
info={center:0,r:0,l:0,fwhm:0}
xmin=20
xmax=100
ypeak=max(yd[xmin:xmax])
info.center=where(yd eq ypeak)
i=info.center
j=info.center
while( yd[i] gt ypeak/2. ) do  i=i+1
while( yd[j] gt ypeak/2. ) do  j=j-1
if (ypeak/2-yd[i]) lt (yd[i-1]-ypeak/2) then $
  info.r=i  else  info.r=(i-1)
if (ypeak/2-yd[j]) lt (yd[j+1]-ypeak/2) then $
  info.l=j  else  info.l=(j+1)
info.fwhm=info.r-info.l

return, info
end






pro tcutspec,noshow=noshow,limits=l,np=np,t,varname,ncuts=ncuts,calib=calib,average=average

if n_elements(np) eq 0 then np=2
if n_elements(ncuts) eq 0 then ncuts=10000

for i=0,ncuts-1  do begin
 wait, .3
 wi,0
 ctime,t,np=np,vnam=varname,noshow=i
 wi,1
 varnames=varname
 n = 0
 repeat begin
  if not keyword_set(t) then return
  ld = 0
  get_data,varnames[n],data=d,alimit=ld
  if data_type(d) eq 7 then begin
     varnames=tnames(d)
     get_data,varnames[0],data=d,alimit=lim
     extract_tags,lim,ld
     ld = lim
  endif

  lim = 0
  tgs = ['title','range','log','style']
  spec = 0
  str_element,ld,'spec',spec
  if keyword_set(spec) then begin
    extract_tags,lim,ld, tags='z'+tgs, ntags='y'+tgs
    extract_tags,lim,ld, tags='y'+tgs, ntags='x'+tgs
  endif else begin
    extract_tags,lim,ld, tags= 'y'+tgs
  endelse
  str_element,/add,lim,'title',varname[0]+'  '+trange_str(t)
;help,v,y,lim,/st


;help,varname,d,ld,/st
  if not keyword_set(d) then return

  if n_elements(t) eq 2 then w = where(d.x ge t(0) and d.x lt t(1),c)
  if n_elements(t) eq 1 then dummy = min(abs(d.x - t[0]),w)

  y = d.y(w,*)
  x = d.x(w)
  if ndimen(d.v) eq 2 then v = d.v(w,*) else v =d.v

  if keyword_set(average) then begin
     if ndimen(y) eq 2 then y = average(y,1,/nan)
     if ndimen(v) eq 2 then v = average(v,1,/nan)
  endif else begin
     if ndimen(y) eq 2 then y = total(y,1,/nan)
     if ndimen(v) eq 2 then v = total(v,1,/nan)
  endelse  

  print, 'total=',total(y)
  ymax=max(y)
  str_element,/add_replace,lim,'yrange',[.8, ymax]

  extract_tags,lim,l

  extract_tags,opt,lim,/oplot

  if i eq 0 then  box,lim,v,y
  oplot,v,y,_extra=opt,col=i mod 8

  if keyword_set(calib) then begin
     info=calib_cutspec(v,y)
     print, 'center=',info.center,' fwhm=',info.fwhm
     print, 'peak=',y[info.center],' half-max=',y[info.r],y[info.l]
  endif

 endrep until 1
endfor
wi,0

end
