


d= read_GPIB(file,filt='*light*.log')



options,lim,title='File: '+strmid(file,42,43,/revers)
options,lim,ytitle='Sensor leakage Current (nA)'
;options,lim,xtitle=''
xlim,lim,0,0,0
ylim,lim,.1,10000,1
ylim,lim,.1,10000000.,1

lim1 = lim
options,lim1,xtitle='LED & R Voltage'
xlim,lim1,0,10,0

lim2 = lim
options,lim2,xtitle='LED Current (A)'
xlim,lim2,10e-9,1,1

lim3 = lim
options,lim3,xtitle='LED & R Voltage'
options,lim3,ytitle='LED Current (A)'
xlim,lim3,0,10,0
ylim,lim3,1e-9,1,1


;box,lim
col = [2,6]
V_ledr = d.ps1.p25v.v
I_led = d.mm1.v/50.   ; voltage across 50 Ohm resistor
V_led = v_ledr - d.mm1.v
I_leak = average(d.pa1.i,1,nan=nan)
V_bias = d.ps1.n25v.v
v_gate = d.ps1.p6v.v
wi,1 & plot,v_led,i_leak*1e9,psym=-1,_extra=lim1
wi,3 & plot,v_led,i_led,psym=-1,_extra=lim3  & oplot,v_led,i_led,psym=-1,/col
wi,2
plot,i_led ,i_leak*1e9,_extra=lim2;,psym=-1

psyms = [1,4,4,4,2,2,2]
pcols = [5,1,2,3,1,2,3]

pp=0
names='ileak p.k'

for i=1,6 do begin
   w = where(d.trace eq i,nw)
   if nw gt 1 then oplot,i_led[w] ,i_leak[w]*1e9 $
     ,col=pcols[i],psym=-psyms[i];,_extra=lim2

   if 1 then begin
      x = i_led[w]
      y = i_leak[w]*1e9
      w2 = where(finite(y) and x gt 0)
      x=x[w2]
      y=y[w2]
      p = lightcurve3()
    ;  p.x0 = interp(x,y,100)
    ;  print,p.x0
      p.ileak = min(y)
      p.p.k = max(y)/func(param=p,max(x)) * p.p.k
      pf,p,linestyle=4,col=5
      fit,x,y, /logfit,param=p,names=names
      pf,p,linestyle=3
stop
      append_array,pp,p


   endif

endfor

;plots,i_led, i_leak*1e9,psym =psyms[d.trace],color=pcols[d.trace]

;oplot,dgen(),dgen()
;oplot,i_led, i_led * v_led
;oplot,i_led, -v_bias - i_leak  * 15.3e6/4 , ps=-2

save,d,pp,file,file=file+'.sav'
makepng,file




end
