pro tz
  ctime,t,y,vname=vname
  if vname[0] eq vname[1] then ylim,vname[0],y
  tplot,trange=t,vname[0]

end

pro update,trange=trange,rawfile=rawfile,range=range
if keyword_set(rawfile) then read_sstgse_dat,rawfile,range=range
if not keyword_set(trange) then trange=10.
tmax = systime(1)-8*3600d
get_data,'Ctot',data=d
tmax = max(d.x)
tlimit,tmax + [-trange,0.0]*60.
end



pro plot_tshift,ta
wi,1
n=n_elements(ta)
ta1=reform(ta,2,n/2)
t0=reform(ta1[0,*])
t1=reform(ta1[1,*])
plot,t0-min(t0),t1-t0,/ps
wset,0
timebar,t0,var='AO0'
timebar,t1,var='C'
end



pro calc_stats,var
if not keyword_set(var) then var='C'
get_data,var,data=d
d.y[*,0] = 0
st=get_stats(d.y,d.v)
store_data,var+'_tot' ,data={x:d.x,y:st[*,0]}
store_data,var+'_ctr' ,data={x:d.x,y:st[*,1]}
store_data,var+'_sig' ,data={x:d.x,y:st[*,2]}
end



pro I_vs_T_plot
plot,[-100,60],[0,30],/nodat,xtitle='Internal Themistor Temp',ytitle='Current (mA)
ctime,tr
ip1 = tsample('I_Preg1',tr,time=t)
temp1 = data_cut('Tint1',t)
ip2 = tsample('I_Preg2',tr,time=t)
temp2 = data_cut('Tint2',t)
in1 = tsample('I_Nreg1',tr,time=t)
temp1 = data_cut('Tint1',t)
in2 = tsample('I_Nreg2',tr,time=t)
temp2 = data_cut('Tint2',t)

oplot,temp2,ip2,col=6,psym=3
oplot,temp1,ip1,col=2,psym=3
oplot,temp2,in2,col=6,psym=3
oplot,temp1,in1,col=2,psym=3
end


pro noise_vs_T_plot,tr
if not keyword_set(tr) then ctime,tr
temp1 = tsample('Tint1',tr,time=t1)
ns = data_cut('Nse_sig_sm',t1)

temp2 = tsample('Tint2',tr,time=t2)
na = data_cut('Nse_avg_sm',t2)

!p.multi = [0,2,2]
col = get_colors('bgr')
str=strcompress(/rem,indgen(4))
for g=0,3 do begin
plot,[-80,60],[-2,4],/nodat,xtitle='Internal Themistor Temp',ytitle='Noise (bins) group '+str[g],/xstyle,/ystyle
oplot,g le 1 ? temp1 : temp2,ns[*,0+g*3],col = col[0],psym=3
oplot,g le 1 ? temp1 : temp2,ns[*,1+g*3],col = col[1],psym=3
oplot,g le 1 ? temp1 : temp2,ns[*,2+g*3],col = col[2],psym=3
oplot,g le 1 ? temp1 : temp2,na[*,0+g*3],col = col[0],psym=3
oplot,g le 1 ? temp1 : temp2,na[*,1+g*3],col = col[1],psym=3
oplot,g le 1 ? temp1 : temp2,na[*,2+g*3],col = col[2],psym=3
endfor
!p.multi=0
end


pro test_poisson,tr
wi,0
s = tsample('Clow',tr,/silent)
p = poisson()
p.avg = average(s)
n = n_elements(s)
p.h = n
wi,2
h = histbins(s,xb,bins=1)
plot,xb,h,psym=10;,col=6
pois = poisson(xb,para=p)
;oplot,xb,pois,ps=1
plotxyerr,xb,pois,xb*0+.5,sqrt(pois),col=6,/overpl
printdat,p
w = where(s le p.avg+4*sqrt(p.avg),nw)
print,total(s[w])/nw,'+/-',sqrt(total(s[w]))/nw
if nw ne n then print,"WARNING",strtrim(n-nw),' POINTS removed'
stop
end


pro cp_spectra,t
if not keyword_set(t) then ctime,t
n= n_elements(t)/2
t = reform(t,2,n)
xlim,lim,0,50
ylim,lim,0,1
colors = [1,2,3,4,5,6,1,2,3,4,5,6]
plot,/nodata,_extra=lim,[0,1]
for i=0,n-1 do begin
    d= tsample('C',t[*,i],/average)
    oplot,d,color=colors[i mod n_elements(colors)]
endfor
end





pro load_TV_temps


   t = read_asc(/tags,/double,filter='*.prn')
   if keyword_set(t) then begin
   time  =t.time *3600d * 24d + time_double('2005-1-1')

   store_data,'T-C',data={x:time, y:[[t.T01],[t.T02],[t.T03]]},dlim={colors:'ygd'}
   store_data,'T-B',data={x:time,y:[[t.T08],[t.T10]]},dlim={colors:'cm'}
   store_data,'T-S',data={x:time,y:[[t.T09],[t.T11]]},dlim={colors:'br'}

   store_data,'Tse',data={x:time, y:[t.T01]},dlim={colors:'y'}
   store_data,'Tsm',data={x:time, y:[t.T02]},dlim={colors:'g'}
   store_data,'Tbp',data={x:time, y:[t.T03]},dlim={colors:'d'}
   store_data,'TB1',data={x:time, y:[t.T08]},dlim={colors:'b'}
   store_data,'TB2',data={x:time, y:[t.T10]},dlim={colors:'r'}
   store_data,'TS1',data={x:time, y:[t.T09]},dlim={colors:'b'}
   store_data,'TS2',data={x:time, y:[t.T11]},dlim={colors:'r'}

   endif
if 0 then begin
   tplot,'T_all I_Vreg I_Heater'

endif
end






;  begiin main
;
;tplot_options,'ygap',.5
;
;load_dap,dapfile
;load_tv_temps
;read_sstgse_dat,rawfile
;
;end