pro cal_am241,t,nplots=nplots


if n_elements(t) ne 2 then ctime,t,/silent,npoints=2

am241 = tsample('Am241',t,times=t241)
d1    = tsample('Door1',t,times=t1)
d2    = tsample('Door2',t,times=t2)


w1=where(am241 eq 1)
tstart = t241[w1]+3

w2=where(am241 eq 0)
tstop = t241[w2]-3

w2=where(d1 eq 0)
tstop = t1[w2] -3
tr = transpose([[tstart],[tstop]])

wset,0

cols = ([2,4,6])[[0,1,2,0,1,2,0,1,2,0,1,2]]
timebar,tstart,color=2
timebar,tstop,color=6
psize = [1000,1000]

if !d.window ne 1 then  wset,1
if !d.x_size ne psize[0] and !d.y_size ne psize[1] then window,1,xsize=psize[0],ysize=psize[1]

if not keyword_set(nplots) then nplots=4

nspec  = 12/nplots
if nplots eq 4 then  !p.multi = [0,2,2]
if nplots eq 12 then !p.multi = [0,3,4]


ns = n_elements(tstart)

pk = igauss()
pk.a=5
pk.x0=38
pk.s=3
pks = replicate(pk,ns)
b=indgen(128)
for i=0,ns-1 do begin
   tri = tr[*,i]
   s= tsample('C',tri,/aver)
   spc = i mod nspec
   if spc eq 0 then plot,[0,60],[0,1],/nodata   ,title='Am 241  '+time_string(tri[0])
   oplot,b,s,color=cols[i],ps=-1
   w= where (b gt 25 and b lt 45)
   fit,b[w],s[w],param=pk,/silen
   sfit = func(b,param=pk)
   oplot,b,sfit,color=cols[i],ps=10
   pos = convert_coord(!x.crange[1],!y.crange[1],/data,/to_device)
   pos = pos - [!d.x_ch_size,!d.y_ch_size] * [2,2+spc*1.5]
   pks[i]=pk
   gain = 59.5/pk.x0
   width = 59.5/pk.x0 * pk.s *2.35
   str = string(pk.a,pk.x0,pk.s,gain,width,format='(f6.2,f7.2,f6.2,f6.3,f6.2)')
   xyouts,pos[0],pos[1],/device,str,color=cols[i],align=1
   print,str
endfor

!p.multi=0

name = time_string(format=2,tr[0])+'_Am241'
makepng,name+string(nplots,format='("_",i02)')
save,pks,file=name+'.sav'

end
