pro cal_threshold3,tr,det=det,th_rate=th_rate,time_error=time_error

;@thmsst_common.pro

if not keyword_set(tr) then ctime,tr,npoints=2
if not keyword_set(th_rate) then th_rate=1

if !d.window ne 1 then  wset,1
if !d.x_size ne 700 and !d.y_size ne 700 then window,1,xsize=700,ysize=700

dt=3.

wi,1
bins = indgen(16)*8
bins = bins[[0,1,2,4,5,6,8,9,10,12,13,14]]
print,bins
cols = [2,4,6,2,4,6,2,4,6,2,4,6]
psym = [1,1,1,2,2,2,4,4,4,5,5,5]

tavg = average(tr)
title = time_string(tavg,prec=-1)
plot,/ylog,yrange=[.001,100000],xrange=[0,400],/nodat,[0,0] $
  ,xtitle='Threshold setting',ytitle='Average Counts/frame',title=title


plotednames=tnames(/tplot)

varnames = string(indgen(12)/3,format='("Cgrp",i1)')
if not keyword_set(time_error) then time_error=0d

print,'REM th_rate=',th_rate
dacset = intarr(12)
for det=0,11 do begin
  name = string(/print,det+1,format='("thr",i02)')
  print,name
  a = tsample(name,tr,times=ts2)
  printdat,a
  if n_elements(a) gt 3 then begin
    ts1 = shift(ts2,1)
    ts1 = ts1[1:*]+dt
    ts2 = ts2[1:*]-dt
    ts = (ts1+ts2)/2
    dts = ts2-ts1
    n = n_elements(ts1)
    th = fltarr(n)
    si = fltarr(n)
    wset,0
    for i=0,n-1 do begin
      append_array,smp,sstgse_sample([ts1[i],ts2[i]]+time_error)
      wset,0
      timebar,ts1[i]+time_error,varname=varnames[det],color=2
      timebar,ts2[i]+time_error,varname=varnames[det],color=6
      wset,1
    endfor
    wset,1
    for i=0,n-1 do begin
;  stop,s
      b1=bins[det]
      si[i] = s[b1] + s[b1+1]
      th[i] = data_cut(name+'_',ts[i])
      wait,.1
    endfor
      wait,1
    oplot,th,si,col=cols[det],psym=-psym[det]
    dacset[det] = round(interp(th,si,th_rate))
    print,det /4,det mod 4,dacset[det],dacset[det] ,format='("/isstdacset ",i1," ",i1," ",z3,"  ; ",i3)'
  endif
endfor
print
stitle = string('REM th_rate=',th_rate)
print,stitle
;print,'REM th_rate=',th_rate
soutput = strarr(12)
for det=0,11 do begin
  if dacset[det] ne 0 then begin
    soutput[det] = string(/print,det ,dacset[det],dacset[det] ,format='(i2,"   0x",Z3,"   ",i3)')
    print,det /4,det mod 4,dacset[det],dacset[det] ,format='("/isstdacset ",i1," ",i1," ",Z3,"  ; ",i3)'
;    print,soutput[det]
  endif
endfor

string_out,[stitle,soutput],.68,.91

kstring = 'hkp-door Tint? Text? dN_avg dN_sig pico?_i
tsrange = [ts[0], average(ts) ]
sdat = tsamples(kstring,tsrange)

fname=time_string(format=2,ts[0],prec=-1)+'_thresh'
makepng,fname


tdat = {ts:ts,tshift:time_error,th_rate:th_rate,dacset:dacset,sdat:sdat}
save,tdat,file=fname+'.sav'

end


