
function  find_moments,x,f
nan = !values.d_nan
peak = {tot:nan, avg:nan, sdev:nan, skew:nan, kurt:nan}
if n_params() eq 0 then return,peak

if not keyword_set(f) then f = replicate(1d,n_elements(x))
if n_elements(x) ne n_elements(f) then x = findgen(n_elements(f))

t = total(f)
avg = total(f * x)/t
residual = x-avg
sdev = sqrt(total(f*residual^2)/t)
skew = total(f*(residual/sdev)^3)/t
kurt = total(f*(residual/sdev)^4)/t-3

peak.tot=t
peak.avg=avg
peak.sdev=sdev
peak.skew=skew
peak.kurt=kurt
return,peak
end
