

pro sstsum,pnum,filename=filename

if n_elements(pnum) eq 0 then pnum=0
case strtrim(strlowcase(pnum),2) of
'noise' : panels = 'hkp-nse dN dN_tot dN_avg? dN_sig? C'
'hkp' : panels = 'hkp-* r-* C'
'sum' : panels = 'C Csum dN_avg dN_sig ncmds dcmd
'press': panels = 'Press ig ig_rate cg2_rate T_all'
'egun': panels = 'C Cs dacvals_ bias-ctrl_ b50k_v b50k_i ig ig_rate dN_avg dN_sig dcmd hkp-door T_all
'dap' : panels = 'C aout0_ Csum hkp-nse dN_avg dN_sig dacvals_ hkp-map dcmd
'door': panels = 'C *door* Am241_ Door?_'
'0': panels = 'C Csum dN_avg dN_sig aout0_ dacvals_ hkp-door hkp-map T_all'
'1': panels = 'C Csum dN_avg dN_sig AO0 dacvals_ I_Vreg V_mux hkp-mux hkp-door hkp-map T_all'
else: panels = 'C dN_avg dN_sig AO0 dacvals_ hkp-door hkp-map T_all'

endcase

wset,0
tplot,panels ;,trange=[0d,0]
wshow,0
if keyword_set(filename) then makepng,filename

end


pro multi_files_summary
@themis_sst_common.pro

if not keyword_set(files) then begin
   path=dialog_pickfile(filter='*.raw',/multi,get_path=lastpath,path=lastpath)
   bname = file_basename(path,'.raw')
   dname = file_dirname(path,/mark)
   files = dname+bname
   files = files[sort(files)]
   printdat,bname,/val,'bname'
endif
for i =0,n_elements(files)-1 do begin
   load_sstdat,files[i]
   plot_summary,filename=files[i]
endfor


end





pro load_sstdat,files,range=range,log=log,last=last,noraw=noraw,raw_only=raw_only $
   ,auto=auto,tail=tail,trange=trange,etu=etu,directory=directory,cwd=cwd,tshift=tshift
@themis_sst_common.pro

if keyword_set(cwd) then cd,current=directory
if keyword_set(directory) then lastpath=directory


if not keyword_set(files) then files = pick_sstgse_filename('.raw',last=last)

if not keyword_set(files) then return

;   path=dialog_pickfile(filter='*.raw',/multi,get_path=lastpath,path=lastpath)
;   bname = file_basename(path,'.raw')
;   dname = file_dirname(path,/mark)
;   files = dname+bname
;   files = files[sort(files)]
;   printdat,bname,/val,'bname'
;endif

nf = n_elements(files)
tplot_options,title=nf gt 1 ? strjoin(file_basename(files[[0,nf-1]]),' ... ') : files[0]
tplot_options,'ygap',.5
tplot_options,window=0
filenames = files
basenames = file_basename(filenames)

if not keyword_set(raw_only) then begin
  load_sstgse_log,files  ;,log=log
  load_sstgse_dap,files,therm1 =  keyword_set(etu),therm2=  keyword_set(etu)
  load_sstgse_ionfile,files
  load_sstgse_manip,files
  load_sstgse_gpib,files
endif
if not keyword_set(noraw) then begin
  load_sstgse_raw,files+'.raw',trange=trange,tshift=tshift   ;,tail=tail
  sstgse_tdiff
  average_counts
endif
deriv_data,'Text3',nsmooth=59
deriv_data,'Tint1',nsmooth=59
if keyword_set(tail)  then begin
  tt = systime(1)+tzdiff()*3600d + 60d*[-tail,tail/20.0]
  tlimit,tt
endif

end





;if not keyword_set(twait) then twait = 60.
;if not keyword_set(tail) then tail = 15.

while keyword_set(tail)  do begin
  message,/info,'Loading Data'
  load_sstdat,last=last,tail=tail ,noraw=noraw  ;,tail=tail,last=last
  print,'Waiting... ',twait

  if twait eq 0 then break else  wait,twait
  print,'Loading... ',twait
  wait,1
endwhile

end