
pro load_sstgse_dap,basename,data=dap,therm1=therm1,therm2=therm2

therm3=1

if not keyword_set(basename) then basename=pick_sstgse_filename('.dap')
bn = file_basename(basename[0])

f = !values.f_nan
dapf1 ={ dap_flag:0, I_Preg1:f, I_Preg2:f, I_Nreg1:f, I_Nreg2:f, V_rint1:f, V_rint2:f, I_Heater1:f, I_Heater2:f, V_rext1:f, V_rext2:f, V_rext3:f, V_mux:f, AO0:f, AO1:f }
dapf2 ={ I_Preg1:f, I_Preg2:f, I_Nreg1:f, I_Nreg2:f, V_rint1:f, V_rint2:f, I_Heater1:f, I_Heater2:f, V_rext1:f, V_rext2:f, V_rext3:f, V_mux:f, zero:[f,f,f,f], AO0:f, AO1:f }
pwr = {pwr_flag:0,  pwr_outp:0, pwr_p6V:f, pwr_p6i:f, pwr_p25v:f, pwr_p25i:f, pwr_n25v:f, pwr_n25i:f }

case 1 of
bn gt '20050926' : fm = create_struct(dapf1,pwr)
bn gt '20050809_0000' : fm = dapf1
else:              fm = dapf2
endcase

;printdat,fm

dap = read_sstgsedatafile(basename,exten='.dap',format=fm,gaptime=10)

if not keyword_set(dap) then begin
   message,/info,'No DAP data available for :'+basename
   return
endif

if bn gt '20050809_0000' then begin
   w = where(dap.dap_flag eq 0,nw)
   if nw ne 0 then begin
      dap[w].I_preg1 =f
      dap[w].I_preg2 = f
      dap[w].I_Nreg1 = f
      dap[w].V_rint1 = f
      dap[w].V_rint2 = f
      dap[w].I_heater1 = f
      dap[w].I_heater2 = f
      dap[w].V_rext1=f
      dap[w].V_rext2=f
      dap[w].V_rext3=f
      dap[w].V_mux=f
      dap[w].AO0=f
      dap[w].AO1=f
   endif
endif

if bn gt '20050926' then begin
  w = where(dap.pwr_flag eq 0,nw)
  if nw ne 0 then begin
      dap[w].pwr_p6V=f
      dap[w].pwr_p6i=f
      dap[w].pwr_p25v=f
      dap[w].pwr_p25i=f
      dap[w].pwr_n25v=f
      dap[w].pwr_n25i=f
  endif
endif


   ;printdat,dap
   store_data,'I_Preg1',data={x:dap.time,y:  dap.I_Preg1/.0003}, dlim={colors:'b'}
   store_data,'I_Preg2',data={x:dap.time,y:  dap.I_Preg2/.0003}, dlim={colors:'r'}
   store_data,'I_Nreg1',data={x:dap.time,y: -dap.I_Nreg1/.0006}, dlim={colors:'b'}
   store_data,'I_Nreg2',data={x:dap.time,y: -dap.I_Nreg2/.0006}, dlim={colors:'r'}
   store_data,'I_Vreg',data='I_Preg2 I_Preg1 I_Nreg2 I_Nreg1',dlim={yrange:[0,30.],ystyle:1,ytitle:'Sensor Current (mA)'}


   V_rint1 = dap.V_rint1
   V_rint2 = dap.V_rint2
   V_rext1 = dap.V_rext1
   V_rext2 = dap.v_rext2
   V_rext3 = dap.v_rext3


   store_data,'V_Rext1',data={x:dap.time,y: V_rext1}, dlim={colors:'b'}
   store_data,'V_Rext2',data={x:dap.time,y: V_rext2}, dlim={colors:'r'}
   store_data,'V_Rext3',data={x:dap.time,y: V_rext3}, dlim={colors:'g'}
   store_data,'V_Rext',data='V_Rext1 V_Rext2 V_Rext3'
   store_data,'V_Rint1',data={x:dap.time,y: V_rint1}, dlim={colors:'b'}
   store_data,'V_Rint2',data={x:dap.time,y: V_rint2}, dlim={colors:'r'}
   store_data,'V_R',data='V_Rint1 V_Rint2 V_Rext1 V_Rext2 V_Rext3',dlim={yrange:[0,5],ystyle:1}


   if not keyword_set(pti1) then begin
      pti1 = therm_temp2()
      pti1.r1=50000.
      pti1.xmax=2.5
   endif
   if not keyword_set(pti2) then begin
      pti2 = therm_temp2()
      pti2.r1=50000.
      pti2.xmax=2.5
   endif

   Tint1 = therm_temp2(V_rint1,param=pti1)
   w = where(Tint1 gt 200,nw)
   if nw gt 0 then Tint1[w]=!values.f_nan
   Tint2 = therm_temp2(V_rint2,param=pti2)
   w = where(Tint2 gt 200,nw)
   if nw gt 0 then Tint2[w]=!values.f_nan
   store_data,'Tint1',data={x:dap.time,y: Tint1}, dlim={colors:'b'}
   store_data,'Tint2',data={x:dap.time,y: Tint2}, dlim={colors:'r'}
   store_data,'Tint',data='Tint1 Tint2'


   store_data,'I_Heater1',data={x:dap.time,y: dap.i_heater1}, dlim={colors:'b',yrange:[-.05,.35],ystyle:1}
   store_data,'I_Heater2',data={x:dap.time,y: dap.i_heater2}, dlim={colors:'r',yrange:[-.05,.35],ystyle:1}
   store_data,'I_Heater',data='I_Heater2 I_Heater1'        ,dlim={yrange:[-.05,.5],ystyle:1,panel_size:.3}

 ;  printdat,not keyword_set(therm1)
   pt1 = therm_temp2(B225 = (keyword_set(therm1) eq 0))  & pt1.r1=52400.   & pt1.xmax=1.0
   pt2 = therm_temp2(B225 = (keyword_set(therm2) eq 0))  & pt2.r1=52400.   & pt2.xmax=1.0
   pt3 = therm_temp2(B225 = (keyword_set(therm3) eq 0))  & pt3.r1=49800.   & pt3.xmax=1.0
    ;printdat,pt1
    V_bias = 4.99756
   Text1 = therm_temp2(V_rext1/V_bias,param=pt1)
   w = where(Text1 lt -85,nw)
   if nw gt 0 then Text1[w]=!values.f_nan

   Text2 = therm_temp2(V_rext2/v_bias,param=pt2)
   w = where(Text2 lt -85,nw)
   if nw gt 0 then Text2[w]=!values.f_nan
   Text3 = therm_temp2(V_rext3/v_bias,param=pt3)
   w = where(Text3 lt -85,nw)
   if nw gt 0 then Text3[w]=!values.f_nan
   store_data,'Text1',data={x:dap.time,y: Text1}, dlim={colors:'b'}
   store_data,'Text2',data={x:dap.time,y: Text2}, dlim={colors:'r'}
   store_data,'Text3',data={x:dap.time,y: Text3}, dlim={colors:'g'}
   store_data,'Text',data='Text1 Text2 Text3'

   store_data,'V_mux',  data={x:dap.time,y: dap.v_mux},dlim={tplot_routine:'pmplot',yrange:[0,2.5],ystyle:1}

   store_data,'T_all',data='Text3 Tint2 Tint1 Text2 Text1',dlim={ystyle:2,ytitle:'Temp (C)',panel_size:2}

;   tplot_names
  ; tplot,'I_Vreg V_R T_all I_Heater V_max V_atten V_mux'


   store_data,'AO0',data={x:dap.time,y:dap.AO0}
   store_data,'AO1',data={x:dap.time,y:dap.AO1}

end
