pro load_sstgse_gpib,basename


if not keyword_set(basename) then basename=pick_sstgse_filename('.gpb')
;bn = file_basename(basename[0])


if not keyword_set(fm) then begin
  f = !values.f_nan
  d = !values.d_nan
  pwr = {pwr_flag:0,  pwr_outp:0, pwr_p6V:f, pwr_p6i:f, pwr_p25v:f, pwr_p25i:f, pwr_n25v:f, pwr_n25i:f }
  IGdat = {ig_flag:0, IG:f, CG1:f,  CG2:f, degas:0}
  pico1 = {pico1_flag:0,  pico1_i:f }
  pico2 = {pico2_flag:0,  pico2_i:f }
  B5k=  {B5k_flag:0,  B5k_v:f,   B5k_i:f}
  B30k= {B30k_flag:0, B30k_v:f, B30k_i:f}
  B50k= {B50k_flag:0, B50k_v:f, B50k_i:f}


  fm = create_struct(pwr,igdat,pico1,pico2,b5k,b30k,b50k)

endif

dat = read_sstgsedatafile(basename+'.gpb',format=fm,gaptime=10)

if not keyword_set(dat) then return

  dat.b50k_v /= 1000

  if not keyword_set(prefix) then prefix=''
  tagnames = strlowcase(tag_names(dat))
  ntags = n_elements(tagnames)
  time = dat.time
  dlim = {psym:10}
  bad = where(dat.ig gt 1e4 or dat.ig_flag eq 0,nbad)
  if nbad gt 0 then dat[bad].ig = !values.f_nan
  ;help,nbad,bad
  bad = where(dat.ig_flag eq 0,nbad)
  if nbad gt 0 then dat[bad].cg1 = !values.f_nan
  if nbad gt 0 then dat[bad].cg2 = !values.f_nan
  bad = where(dat.pwr_flag eq 0,nbad)
  if nbad gt 0 then dat[bad].pwr_p6v = !values.f_nan
  if nbad gt 0 then dat[bad].pwr_p25v = !values.f_nan
  if nbad gt 0 then dat[bad].pwr_n25v = !values.f_nan
  if nbad gt 0 then dat[bad].pwr_p6i = !values.f_nan
  if nbad gt 0 then dat[bad].pwr_p25i = !values.f_nan
  if nbad gt 0 then dat[bad].pwr_n25i = !values.f_nan

  dat.pico1_i *= 1e9
  bad = where(dat.pico1_flag eq 0,nbad)
  if nbad gt 0 then dat[bad].pico1_i = !values.f_nan
  dat.pico2_i *= 1e9
  bad = where(dat.pico2_flag eq 0,nbad)
  if nbad gt 0 then dat[bad].pico2_i = !values.f_nan



  for i=1,ntags-1 do   store_data,prefix+tagnames[i],data={x:time,y:dat.(i)}  ;,dlim=dlim

  store_data,'pwr_v',data={x:dat.time,y:[[dat.pwr_p6v],[dat.pwr_p25v],[-dat.pwr_n25v]]},dlim={colors:'grb'}
  store_data,'pwr_i',data={x:dat.time,y:[[dat.pwr_p6i],[dat.pwr_p25i],[dat.pwr_n25i]]},dlim={colors:'grb'}
  options,'pico?_i',tplot_routine='pmplot',/ylog,/default

  nsmooth = 11
  cg2_sm = smooth(dat.cg2,nsmooth < n_elements(dat.cg2),/nan)
  cg2_rate = deriv((dat.time-dat[0].time)/60.,cg2_sm)
  ;cg2_rate = 60*(shift(cg2_sm,nsmooth/2) - shift(cg2_sm,-nsmooth/2))/(shift(time,nsmooth/2) - shift(time,-nsmooth/2))
  store_data,'cg2_rate',data={x:dat.time,y:cg2_rate}
  options,'cg2_rate',tplot_routine='pmplot'
  ylim,'cg2_rate',.0001,1000,1

  ig_sm = smooth(dat.ig,nsmooth < n_elements(dat.ig),/nan)
  ig_rate = deriv((dat.time-dat[0].time)/60.,ig_sm)
  ;ig_rate = 60*(shift(ig_sm,nsmooth/2) - shift(ig_sm,-nsmooth/2))/(shift(time,nsmooth/2) - shift(time,-nsmooth/2))
  store_data,'ig_rate',data={x:dat.time,y:ig_rate}
  options,'ig_rate',tplot_routine='pmplot'
  ylim,'ig_rate',1e-8,1e-2,1

  store_data,'Press',data='cg1 cg2 ig'
  options,'Press',panel_size=1.5,/default,constant=[.05,1e-6]
  ylim,'Press',1e-7,1000,1,/default
  options,'cg2',colors='m',/default
  options,'cg1',colors='c',/default
  ylim,'degas',-.1,1.1,/default
  options,'degas',panel_size=.3,/default




end


