

pro load_sstgse_ionfile,basenames,dat=dat,prefix=prefix

w = where(file_test(basenames),nw)
if nw eq 0 then return
basename = basenames[w]


if not keyword_set(fm) then begin
  f = !values.f_nan
  d = !values.d_nan
  cdat = {cflag:0, gunv:f, guni:f, steer:f, EXB:f, lens:f, vdef:f, hdef:f}
  mdat = {mflag:0, mgunv:f, mguni:f, msteer:f, mEXB:f, mlens:f, mvdef:f, mhdef:f}
  chtron = {chrate:f}
  flags= {fday:0, IG:0, UV:0}
  Gdat = {igflag:0, Iongauge:f, CG1:f,  CG2:f, degas:f}
  P1dat= {p1flag:0, P1_cur:f}
  P2dat= {p2flag:0, P2_cur:f}
  B50k= {eg50k_flag:0, eg50k_v:f, eg50k_i:f}

  fname = (file_basename(basename))[0]
  case 1 of

  fname lt '20050512_1024' : begin
      message,/info,'unsure of file format'
      return
      end
  fname lt '20050729_1434':  fm = create_struct(cdat,mdat,flags,gdat,p1dat,p2dat,b50k)
  else :  fm = create_struct(cdat,mdat,chtron,flags,gdat,p1dat,p2dat,b50k)
  endcase
endif

dat = read_sstgsedatafile(basename,extension='.ion',format=fm)

if keyword_set(dat) then begin
    f= !values.f_nan
    w = where(dat.cflag eq 0,nw)
    if nw gt 0 then begin
       print,nw ,' control voltages erased'
       dat[w].gunv = f
       dat[w].guni = f
       dat[w].steer= f
       dat[w].EXB = f
       dat[w].lens=f
       dat[w].vdef=f
       dat[w].hdef=f
     endif
    w = where(dat.mflag eq 0,nw)
    if nw gt 0 then begin
       print,nw ,' monitor voltages erased'
       dat[w].mgunv = f
       dat[w].mguni = f
       dat[w].msteer= f
       dat[w].mEXB = f
       dat[w].mlens=f
       dat[w].mvdef=f
       dat[w].mhdef=f
     endif
    w = where(dat.igflag eq 0,nw)
    if nw gt 0 then begin
       print,nw ,' Ion gauge values erased'
       dat[w].cg1 = f
       dat[w].cg2 = f
       dat[w].iongauge= f
       dat[w].degas = f
    endif

    dat.p1_cur = dat.p1_cur *1e9
    w = where(dat.p1flag eq 0,nw)
    if nw gt 0 then begin
       print,nw ,' Picoammeter 1 values erased'
       dat[w].p1_cur = f
    endif

    dat.p2_cur = dat.p2_cur *1e9
    w = where(dat.p2flag eq 0,nw)
    if nw gt 0 then begin
       print,nw ,' Picoammeter 2 values erased'
       dat[w].p2_cur = f
    endif

    dat.eg50k_v=dat.eg50k_v/1000
    w = where(dat.eg50k_flag eq 0,nw)
    if nw gt 0 then begin
       print,nw ,' Egun values erased'
       dat[w].eg50k_V = f
       dat[w].eg50k_I = f
    endif

endif



if not keyword_set(prefix) then prefix=''
tagnames = strlowcase(tag_names(dat))
ntags = n_elements(tagnames)
time = dat.time
dlim = {psym:10}
for i=1,ntags-1 do   store_data,prefix+tagnames[i],data={x:time,y:dat.(i)},dlim=dlim

options,'p?_cur',/default,tplot_routine='pmplot',yrange=[.01,50],ylog=1,ystyle=2
options,'uv',ystyle=1,panel_size=.5,yrange=[-.2,1.2]

end



