pro double_data,x,y   ,lasttime=lasttime
n = n_elements(x)
x = reform(transpose( [[x],[shift(x-.001,-1)]] ),2*n)
x[2*n-1] = x[2*n-2] +5
y = reform([1,1] # y, 2*n)
if keyword_set(lasttime) then begin
   x[2*n-1] = lasttime
endif
end



pro store_sample_data,name,data=data,lim=lim,dlim=dlim,lasttime=lasttime
store_data,name,data=data,lim=lim,dlim=dlim
x = data.x
y = data.y
double_data,x,y,lasttime=lasttime
options,lim,psym=0
store_data,name+'_',data={x:x,y:y},lim=lim,dlim=dlim
end




function hexval,s
val=0l
reads,s,val,format='(z)'
return,val
end






function read_sstgse_log,filename,path=path,debug=debug

if not keyword_set(filename) then filename = pick_sstgse_filename('.log')

nf = n_elements(filename)
;filename= filename[sort(filename)]


s=''
f = !values.f_nan
st = {v:f,i:f}
ps ={p6v:st,p25v:st,n25v:st}
;isample = {x:0d,y:0}
dacsamp = {dacsamp,t:0d,dac:0,val:0}
mm = {v:f}
pa = {i:[f,f,f]}
d_nan = {t:0d,trace:0,index:0, ps1:ps, ps2:ps, mm1:mm, pa1:pa}
d= d_nan
n=0
index = 0

aout0=0
aout1=0
dapmonpulse0=0
dapmondout4=-1
dapmonpulse1=0
dapmondout5=-1
dapmonpulse2=0
dapmondout6=-1
mago=0
magt=0
magf=0
cmds=0  &  cmds_index=0
cmdcount=0  & cmdcount_index=0
rem = 0
start = 0
rawhex=0
biasctrl=0
dv = intarr(12)
dacvals = 0
gpibdata = 0
sample1 = 0
sample2=0
relayctrl = 0u
relayctrls = 0
niossync = 0
gpib5_p6v_i=0
gpib5_p6v_v=0
gpib5_p25v_i=0
gpib5_p25v_v=0
gpib5_n25v_i=0
gpib5_n25v_v=0
gpib6_p6v_i=0
gpib6_p6v_v=0
gpib6_p25v_i=0
gpib6_p25v_v=0
gpib6_n25v_i=0
gpib6_n25v_v=0
gpib14_i=0
gpib15_i=0
gpib19_offs=0
gpib19_ampl=0
gpib19_freq=0
gpib22_v=0
gpib4_b50k=0
dapn=0
sens1=0
sens2=0
acode=0
radwheel=0
ignorestring = '/isstmemfilldat'
;ignorestring = 'null'

for i=0,nf-1 do begin
  fn = filename[i]+'.log'
  openr,lun,fn,/get_lun
  print,fn
  subs=strupcase(strsplit(file_basename(fn),'-',/extract))
  if n_elements(subs) ge 4 then begin
    dtime = time_double(strjoin(strmid(subs[0],[0,4,6,9,11],[4,2,2,2,2]),'-'))
    dapn = fix(strmid(subs[1],1))
    if strmid(subs[1],0,1) ne 'F' then dapn= -dapn
    sens1 = fix(strmid(subs[2],1))
    if strmid(subs[2],0,1) ne 'S' then sens1= -sens1
    sens2 = fix(strmid(subs[3],1))
    if strmid(subs[3],0,1) ne 'S' then sens2= -sens2
    dapn= {t:dtime,y:dapn}
    sens1 = {t:dtime,y:sens1}
    sens2 = {t:dtime,y:sens2}
  endif

  while not eof(lun) do begin
    readf,lun,s
    datetime = strmid(s,0,22)
    dtime = time_double(datetime,/MMDDYYYY)
    ss = strmid(s,22,280)
    mess = strsplit(ss,' ',/extract)
    nmess = n_elements(mess)
    if 0 and strmid(mess[0],0,1) eq '/' and mess[0] ne ignorestring then begin
      append_array,cmds,{t:dtime,str:ss},index=cmds_index
    endif
    if strmid(mess[0],0,5) eq '/isst' then begin
       c = 1
       if mess[0] eq '/isstzeroall' then c=232
       if mess[0] eq '/issthires' then c=128
       if mess[0] eq '/isstlowres' then c=128
       if mess[0] eq '/isstmemtest' then c=479
       if mess[0] eq '/isstcmdecho' then c=0
       if mess[0] eq '/isstacqena' then c=0
       if mess[0] eq '/isstmemramp' then c=fix(mess[4])
       append_array,cmdcount,{t:dtime,y:c},index=cmdcount_index
    endif
    if mess[0] eq '/dapmonaout' then begin
       if fix(mess[1]) eq 0 then append_array,aout0,{t:dtime,y:float(mess[2])}
       if fix(mess[1]) eq 1 then append_array,aout1,{t:dtime,y:float(mess[2])}
    endif
    if mess[0] eq '/dapmondout' then begin
       if fix(mess[1]) eq 6 then dapmondout6= fix(mess[2]) eq 0
       if fix(mess[1]) eq 5 then dapmondout5= fix(mess[2])
       if fix(mess[1]) eq 4 then dapmondout4= fix(mess[2])
    endif
    if mess[0] eq '/dapmonpulse' then begin
       if fix(mess[1]) eq 2 then append_array,dapmonpulse2,{t:dtime,y:dapmondout6}
       if fix(mess[1]) eq 1 then append_array,dapmonpulse1,{t:dtime,y:dapmondout5}
       if fix(mess[1]) eq 0 then append_array,dapmonpulse0,{t:dtime,y:dapmondout4}
    endif
    if mess[0] eq '/relayctrl' then begin
       bit = ishft(1u, fix(mess[1]))
       relayctrl = fix(mess[2]) ? (relayctrl or bit) : (relayctrl and not bit)
       append_array,relayctrls,{t:dtime,y:relayctrl}
    endif
    if mess[0] eq '/isstrawhex' then append_array,rawhex,{t:dtime,y:hexval(mess[1])}
  ;  if mess[0] eq '/isstmemfilldat' then track_dap_memory,number=hexval(mess[1]),value=hexval(mess[2])
  ;  if mess[0] eq '/isstmemfilladdr' then track_dap_memory,addr=hexval(mess[1])
    if mess[0] eq '/isstpulsermago' then append_array,mago,{t:dtime,y:hexval(mess[1])}
    if mess[0] eq '/isstpulsermagf' then append_array,magf,{t:dtime,y:hexval(mess[1])}
    if mess[0] eq '/isstpulsermagt' then append_array,magt,{t:dtime,y:hexval(mess[1])}
    if mess[0] eq '/niossync' then append_array,niossync,{t:dtime,y:.5}
    if mess[0] eq '/isstdacset' then begin
       dacnum = fix(mess[1])*4+fix(mess[2])
       dacv =  hexval(mess[3])
       if dacnum eq 15 then append_array,biasctrl,{t:dtime,y:dacv}
       if dacnum lt 12 then begin
;           dv[dacnum] = dacv
;           append_array,dacvals,{t:dtime,dv:dv}
            append_array,dacvals,{dacsamp,dtime,dacnum,dacv}
       endif
    endif
    if nmess ge 2 ? mess[1] eq 'sample-begin' : 0 then append_array,sample1,{t:dtime,y:fix(mess[2])}
    if nmess ge 2 ? mess[1] eq 'sample-end'   : 0 then append_array,sample2,{t:dtime}
    if strlowcase(mess[0]) eq 'start' then append_array,start,{t:dtime,y:strmid(ss,6,280)}
    if strlowcase(mess[0]) eq 'rem' then begin
       if nmess ge 2 ? strlowcase(mess[1]) eq 'note' : 0 then  append_array,rem,{t:dtime,y:strmid(ss,4,280)}
       if nmess eq 4 ? strlowcase(mess[1]) eq 'set' : 0 then begin
           case strlowcase(mess[2]) of
              'dap':    append_array,dapn,{t:dtime,y:fix(mess[3])  }
              'sens1':  append_array,sens1,{t:dtime,y:fix(mess[3])  }
              'sens2':  append_array,sens2,{t:dtime,y:fix(mess[3])  }
              'acode':  append_array,acode,{t:dtime,y:fix(mess[3])  }
              'radwheel':  append_array,radwheel,{t:dtime,y:fix(mess[3])  }
              'uvlight':  append_array,uvlight,{t:dtime,y:fix(mess[3])  }
              'pulserref':  append_array,pulserref,{t:dtime,y:fix(mess[3])  }
               else:  print,s
           endcase
       endif
    endif
    if nmess ge 2 ? mess[1] eq 'GPIB-retrace' : 0 then begin
         d_nan.trace = d_nan.trace+1
         d_nan.index = 0
         d= d_nan
         append_array,gpibdata,d
    endif
    if strmid(ss,0,4) eq 'GPIB' then begin
       if  mess[1] eq '/gpibquery' and nmess ge 5 then begin
         ch = fix(mess[2])
         val = nmess ge 6 ? float(mess[5]) : f
         tval = {t:dtime,y:val}
         if ch eq  5 and mess[3] eq 'meas:current?' and mess[4] eq 'p6v'  then append_array,gpib5_p6v_i,tval
         if ch eq  5 and mess[3] eq 'meas:voltage?' and mess[4] eq 'p6v'  then append_array,gpib5_p6v_v,tval
         if ch eq  5 and mess[3] eq 'meas:current?' and mess[4] eq 'p25v' then append_array,gpib5_p25v_i,tval
         if ch eq  5 and mess[3] eq 'meas:voltage?' and mess[4] eq 'p25v' then append_array,gpib5_p25v_v,tval
         if ch eq  5 and mess[3] eq 'meas:current?' and mess[4] eq 'n25v' then append_array,gpib5_n25v_i,tval
         if ch eq  5 and mess[3] eq 'meas:voltage?' and mess[4] eq 'n25v' then append_array,gpib5_n25v_v,tval
         if ch eq  6 and mess[3] eq 'meas:current?' and mess[4] eq 'p6v'  then append_array,gpib6_p6v_i,tval
         if ch eq  6 and mess[3] eq 'meas:voltage?' and mess[4] eq 'p6v'  then append_array,gpib6_p6v_v,tval
         if ch eq  6 and mess[3] eq 'meas:current?' and mess[4] eq 'p25v' then append_array,gpib6_p25v_i,tval
         if ch eq  6 and mess[3] eq 'meas:voltage?' and mess[4] eq 'p25v' then append_array,gpib6_p25v_v,tval
         if ch eq  6 and mess[3] eq 'meas:current?' and mess[4] eq 'n25v' then append_array,gpib6_n25v_i,tval
         if ch eq  6 and mess[3] eq 'meas:voltage?' and mess[4] eq 'n25v' then append_array,gpib6_n25v_v,tval
         if ch eq 22 and mess[3] eq 'read?' then append_array,gpib22_v, {t:dtime,y:float(mess[4])}
         if ch eq 14 and mess[3] eq 'read?' then begin
             v = strsplit(/extract,mess[4],',')
             append_array,gpib14_i,{t:dtime,y:float(v[0]) }
         endif
         if ch eq 15 and mess[3] eq 'read?' then begin
             v = strsplit(/extract,mess[4],',')
             append_array,gpib15_i,{t:dtime,y:float(strmid(mess[4],4,30))  }
;             help,mess[4],  strmid(mess[4],3,30)
         endif

       endif
    endif

    if mess[0] eq '/gpibwrite' and nmess ge 3 then begin
      ch = fix(mess[1])

      if ch eq 19 then begin        ; wave generator
        val = nmess ge 4 ? float(mess[3]) : f
        tval = {t:dtime,y:val}
        if  mess[2] eq 'offs' then append_array,gpib19_offs,tval
        if  mess[2] eq 'ampl' then append_array,gpib19_ampl,tval
        if  mess[2] eq 'freq' then append_array,gpib19_freq,tval
      endif                         ; end wave generator

      if ch eq 4 then begin      ; bertan 50k
        if strmid(mess[2],0,1) eq 'P' then begin
            val=float(strmid(mess[2],1))
            tval = {t:dtime,y:val}
            append_array,gpib4_b50k,tval
        endif
      endif


    endif

    if strmid(ss,0,4) eq 'GPIB' then begin
       if  mess[1] eq '/gpibquery' and nmess ge 5 then begin
         ch = fix(mess[2])
         val = nmess ge 6 ? float(mess[5]) : f
         if ch eq  5 and mess[3] eq 'meas:current?' and mess[4] eq 'p6v'  then d.ps1.p6v.i  = val
         if ch eq  5 and mess[3] eq 'meas:voltage?' and mess[4] eq 'p6v'  then d.ps1.p6v.v  = val
         if ch eq  5 and mess[3] eq 'meas:current?' and mess[4] eq 'p25v' then d.ps1.p25v.i = val
         if ch eq  5 and mess[3] eq 'meas:voltage?' and mess[4] eq 'p25v' then d.ps1.p25v.v = val
         if ch eq  5 and mess[3] eq 'meas:current?' and mess[4] eq 'n25v' then d.ps1.n25v.i = val
         if ch eq  5 and mess[3] eq 'meas:voltage?' and mess[4] eq 'n25v' then d.ps1.n25v.v = val
         if ch eq  6 and mess[3] eq 'meas:current?' and mess[4] eq 'p6v'  then d.ps2.p6v.i  = val
         if ch eq  6 and mess[3] eq 'meas:voltage?' and mess[4] eq 'p6v'  then d.ps2.p6v.v  = val
         if ch eq  6 and mess[3] eq 'meas:current?' and mess[4] eq 'p25v' then d.ps2.p25v.i = val
         if ch eq  6 and mess[3] eq 'meas:voltage?' and mess[4] eq 'p25v' then d.ps2.p25v.v = val
         if ch eq  6 and mess[3] eq 'meas:current?' and mess[4] eq 'n25v' then d.ps2.n25v.i = val
         if ch eq  6 and mess[3] eq 'meas:voltage?' and mess[4] eq 'n25v' then d.ps2.n25v.v = val
         if ch eq 22 and mess[3] eq 'read?' then d.mm1.v = float(mess[4])
         if ch eq 14 and mess[3] eq 'read?' then begin
            v = strsplit(/extract,mess[4],',')
            d.pa1.i[n++ mod 3]= float(v[0])
            ;if n eq 3 then append_array,data,d
         endif

       endif
    endif
    if nmess ge 2 ? mess[1] eq 'GPIB-sample' : 0 then begin
       d.t=dtime
       append_array,gpibdata,d
       d_nan.index = d_nan.index+1
       d = d_nan
       n=0
    endif
    if keyword_set(debug) then stop,datetime,mess

  endwhile
;printdat,mago

  free_lun,lun
endfor

append_array,/done,cmds,index=cmds_index
append_array,/done,cmdcount,index=cmdcount_index

logdat = {filename:filename,cmds:cmds,GPIB:gpibdata, $
 mago:mago, magt:magt, magf:magf, dacvals:dacvals, $
 sample1:sample1, sample2:sample2, aout0:aout0, aout1:aout1, $
 dapmonpulse0:dapmonpulse0,dapmonpulse1:dapmonpulse1,dapmonpulse2:dapmonpulse2, $
 rawhex:rawhex, $
 biasctrl:biasctrl,   $
 relayctrls:relayctrls,  $
 rem: rem, start:start, $
 niossync:niossync, $
 cmdcount:cmdcount, $
 gpib5_p6v_i:gpib5_p6v_i,$
 gpib5_p6v_v:gpib5_p6v_v,$
 gpib5_p25v_i:gpib5_p25v_i,$
 gpib5_p25v_v:gpib5_p25v_v,$
 gpib5_n25v_i:gpib5_n25v_i,$
 gpib5_n25v_v:gpib5_n25v_v,$
 gpib6_p6v_i:gpib6_p6v_i,$
 gpib6_p6v_v:gpib6_p6v_v,$
 gpib6_p25v_i:gpib6_p25v_i,$
 gpib6_p25v_v:gpib6_p25v_v,$
 gpib6_n25v_i:gpib6_n25v_i,$
 gpib6_n25v_v:gpib6_n25v_v ,$
 gpib14_i:gpib14_i,  gpib15_i:gpib15_i,$
 gpib19_offs:gpib19_offs,gpib19_ampl:gpib19_ampl,gpib19_freq:gpib19_freq, $
 gpib22_v:gpib22_v, $
 gpib4_b50k:gpib4_b50k, $
 dapn:dapn, $
 sens1:sens1, $
 sens2:sens2, $
 acode:acode, $
 radwheel:radwheel, $
 lasttime:dtime   }

return,logdat

end






pro load_sstgse_log,files,log=log, stime=stime

cols = [1,2,3] # [1,1,1,1]
psym = [1,1,1] # [1,2,4,5]

if keyword_set(stime) then dt=stime  else dt=0.
log = read_sstgse_log(files)
if keyword_set(log.dacvals) then begin
   for i=0,11 do begin
       w  = where(log.dacvals.dac eq i,nw)
       if nw ne 0 then store_sample_data,string(/print,format='("thr",i02)',i+1), $
         data={x:log.dacvals[w].t+dt,y:log.dacvals[w].val}, $
         dlim={colors:cols[i],psym:psym[i]},lasttime=log.lasttime
   endfor

   store_data,'dacvals',data=string(/print,indgen(12)+1,format='(12("thr",i02," "))')
   store_data,'dacvals_',data=string(/print,indgen(12)+1,format='(12("thr",i02,"_ "))')

endif
if keyword_set(log.biasctrl) then store_sample_data,'bias-ctrl',data={x:log.biasctrl.t+dt,y:log.biasctrl.y},dlim={psym:-1}
if keyword_set(log.cmds) then store_data,'cmds',data={x:log.cmds.t+dt,y:log.cmds.str},dlim={tplot_routine:'strplot'}
;if keyword_set(log.cmds) then begin
;    w = where(strmid(log.cmds.str,0,5) eq '/isst',nw)
;    if nw gt 0 then begin
; ;   printdat,log.cmds
;       h = histbins(log.cmds[w].t-log.cmds[0].t,xb,binsize=1)
; ;      w2 = where(strmid(log.cmds.str,0,5) eq '/isstzeroall',nw2)
; ;      if nw2 gt 0 then xb[log.cmds.t - log.cmds[0].t] += 231
;       store_data,'NCMDS',data={x:xb+log.cmds[0].t,y:float(h)},dlim={psym:10,ystyle:2,colors:'g'}
;       store_data,'ncmds',data='NCMDS r-cmd N-CMDS'
;    endif
;endif
if keyword_set(log.cmdcount) then begin
   t = [0,round(log.cmdcount.t)]
   t[0]= t[1]-10
   c = [0,log.cmdcount.y]
   mm = minmax(t)
   n = mm[1]-mm[0]+1
   h = intarr( n )
   for i = 0l,n_elements(t)-1 do h[t[i]-mm[0]] += c[i]
   t= mm[0]+dindgen(n)

   for i=0,4 do begin
      w=where(h gt 110 and lindgen(n) lt (n-2),nw)
      if nw gt 0 then begin
          h[w+1] += h[w]-110
          h[w] = 110
      endif
   endfor
   store_data,'N-CMDS',data={x:t,y:h},dlim={psym:10,colors:'b'}
   store_data,'ncmds',data='r-cmd N-CMDS'
endif
if keyword_set(log.rem) then store_data,'rem',data={x:log.rem.t+dt,y:log.rem.y},dlim={tplot_routine:'strplot'}
if keyword_set(log.start) then store_data,'start',data={x:log.start.t+dt,y:log.start.y},dlim={tplot_routine:'strplot'}
if keyword_set(log.aout0) then store_sample_data,'aout0',data={x:log.aout0.t+dt,y:log.aout0.y},dlim={psym:1},lasttime=log.lasttime
if keyword_set(log.dapmonpulse2) then store_sample_data,'Am241',data={x:log.dapmonpulse2.t+dt,y:log.dapmonpulse2.y},dlim={psym:1,panel_size:.3,yrange:[-.1,1.1],ystyle:1},lasttime=log.lasttime
if keyword_set(log.dapmonpulse0) then store_sample_data,'Door1',data={x:log.dapmonpulse0.t+dt,y:log.dapmonpulse0.y},dlim={psym:1,panel_size:.3,yrange:[-.1,1.1],ystyle:1},lasttime=log.lasttime
if keyword_set(log.dapmonpulse1) then store_sample_data,'Door2',data={x:log.dapmonpulse1.t+dt,y:log.dapmonpulse1.y},dlim={psym:1,panel_size:.3,yrange:[-.1,1.1],ystyle:1},lasttime=log.lasttime
if keyword_set(log.mago) then store_sample_data,'mago',data={x:log.mago.t+dt,y:log.mago.y},dlim={psym:1},lasttime=log.lasttime
if keyword_set(log.magf) then store_sample_data,'magf',data={x:log.magf.t+dt,y:log.magf.y},dlim={psym:1},lasttime=log.lasttime
if keyword_set(log.magt) then store_sample_data,'magt',data={x:log.magt.t+dt,y:log.magt.y},dlim={psym:1},lasttime=log.lasttime
if keyword_set(log.rawhex) then store_data,'rawhex',data={x:log.rawhex.t+dt,y:log.rawhex.y},dlim={tplot_routine:'bitplot'}
if keyword_set(log.gpib14_i) then store_data,'PA1',data={x:log.gpib14_i.t+dt,y:-log.gpib14_i.y*1e9},dlim={psym:-1,ylog:1,yrange:[1,1e4]}
if keyword_set(log.gpib15_i) then store_data,'PA2',data={x:log.gpib15_i.t+dt,y:-log.gpib15_i.y*1e9},dlim={psym:-1,ylog:1,yrange:[1,1e4]}
if keyword_set(log.gpib19_offs) then store_sample_data,'wg_offs',data={x:log.gpib19_offs.t+dt,y:log.gpib19_offs.y},dlim={psym:-1},lasttime=log.lasttime
if keyword_set(log.gpib19_ampl) then store_sample_data,'wg_ampl',data={x:log.gpib19_ampl.t+dt,y:log.gpib19_ampl.y},dlim={psym:-1},lasttime=log.lasttime
if keyword_set(log.gpib19_freq) then store_sample_data,'wg_freq',data={x:log.gpib19_freq.t+dt,y:log.gpib19_freq.y},dlim={psym:-1},lasttime=log.lasttime
if keyword_set(log.gpib4_b50k) then store_sample_data,'b50k_c',data={x:log.gpib4_b50k.t+dt,y:log.gpib4_b50k.y},dlim={psym:-1},lasttime=log.lasttime
if keyword_set(log.gpib22_v) then store_sample_data,'MMV',data={x:log.gpib22_v.t+dt,y:log.gpib22_v.y},dlim={psym:-1},lasttime=log.lasttime
if keyword_set(log.relayctrls) then store_sample_data,'Relay',data={x:log.relayctrls.t+dt,y:log.relayctrls.y},dlim={psym:-1,ylog:1,yrange:2.^[-.1,16.]},lasttime=log.lasttime
if keyword_set(log.niossync) then store_data,'Niossync',data={x:log.niossync.t,y:log.niossync.y}, dlim={panel_size:.2}
if keyword_set(log.dapn) then store_sample_data,'DAP',data={x:log.dapn.t,y:log.dapn.y}, dlim={panel_size:.2,ystyle:2},lasttime=log.lasttime
if keyword_set(log.sens1) then store_sample_data,'Sens1',data={x:log.sens1.t,y:log.sens1.y}, dlim={panel_size:.2,ystyle:2},lasttime=log.lasttime
if keyword_set(log.sens2) then store_sample_data,'Sens2',data={x:log.sens2.t,y:log.sens2.y}, dlim={panel_size:.2,ystyle:2},lasttime=log.lasttime
if keyword_set(log.acode) then store_sample_data,'Acode',data={x:log.acode.t,y:log.acode.y}, dlim={panel_size:.2,ystyle:2},lasttime=log.lasttime
if keyword_set(log.radwheel) then store_sample_data,'RadWheel',data={x:log.radwheel.t,y:log.radwheel.y}, dlim={ystyle:2,yrange:[0,7]},lasttime=log.lasttime
end
