pro load_sstgse_manip,basenames

w = where(file_test(basenames),nw)
if nw eq 0 then return
basename = basenames[w]


if not keyword_set(fm) then begin
  f = !values.f_nan
  d = !values.d_nan
  adc = {adcflag:0, adc0:f, adc1:f, adc2:f, adc3:f }
  lin = {linpos:f, lincnts:0l, linrun:f, linerr:f, linstat:0l }
  yaw = {yawpos:f, yawcnts:0l, yawrun:f, yawerr:f, yawstat:0l }
  rot = {rotpos:f, rotcnts:0l, rotrun:f, roterr:f, rotstat:0l }
  aux = {auxpos:f, auxcnts:0l, auxrun:f, auxerr:f, auxstat:0l }
  b5k= {bert5kflag:0, bert5krun:0,  bert5kV:f, bert5kI:f }
  b30k= {bert30kflag:0, bert30krun:0,  bert30kV:f, bert30kI:f }
  b50k= {bert50kflag:0, bert50krun:0,  bert50kV:f, bert50kI:f }
  Press= {Pflag:0, Prun:0, Pig:f, Pcg1:f, Pcg2:f, degas:0}

  fname = (file_basename(basename))[0]
    case 1 of
      fname lt '20050701' :  fm = create_struct({adc:[f,f,f,f]})
      else :  fm =   create_struct(adc,lin,yaw,rot,aux,b5k,b30k,b50k,press)
    endcase

endif

exten ='.mnp'
dat = read_sstgsedatafile(basename,exten=exten,format=fm)

if not keyword_set(dat) then begin
   message,/info,'Unable to obtain data from file: '+basename+exten
   return
endif

if not keyword_set(prefix) then prefix=''
tagnames = strlowcase(tag_names(dat))
ntags = n_elements(tagnames)
time = dat.time
dlim = {psym:10}
for i=1,ntags-1 do   store_data,prefix+tagnames[i],data={x:time,y:dat.(i)},dlim=dlim

end


