
function get_stats,c,bins,n
n=2
dim=dimen(c)
if ndimen(bins) ne ndimen(c) then begin
 colmns = replicate(1,dim[0])
  b = colmns # bins
endif else b=bins
nb = dimen2(b)
;help,c,b
t = total(c,n,/double)
;help,t
a = total(c*b,n,/double)/t
;help,a
s = sqrt(total(c*(b-(a # replicate(1,nb)  ) )^2,n,/double)/t)
;help,s
return,[[t],[a],[s]]
end

pro average_counts,nsample=nsample
get_data,'C',data=d,alim=lim
if not keyword_set(d) then return
if not keyword_set(nsample) then nsample=32
n = n_elements(d.x)
n2 = (n/nsample)
x = average(reform(d.x[0:n2*nsample-1],nsample,n2),1)
y = average(reform(d.y[0:n2*nsample-1,*],nsample,n2,128),1)
v=d.v
help,d,x,y,v,/st
store_data,'C_sm',data={x:x,y:y,v:v},dlim=lim
end


pro noise_stats,time,noise,nsamples=nsamples,prefix=prefix

if n_params() eq 0 then begin
  get_data,'dnoise',data=d
  noise_stats,d.x,d.y,nsamples=nsamples,prefix=prefix
  return
endif

if not keyword_set(prefix) then prefix='dN'
nt = n_elements(time)
if keyword_set(nsamples) then ns=nsamples else ns=1
nt = (nt / ns)
tot = fltarr(nt,12)
b = fltarr(nt,12)
db= fltarr(nt,12)

tt = average(reform(time[0:ns*nt-1],ns,nt),1)
nse = average(reform(noise[0:ns*nt-1,*],ns,nt,120), 1)
;help,nse
store_data,prefix,data={x:tt,y:nse,v:findgen(120)}, $
   dlim={no_interp:1,spec:1,panel_size:3,zrange:[.8,30],zlog:1}
nse = reform(nse,nt,10,12)

bins = replicate(1,nt) # (findgen(10)-5)
for i=0,11 do begin
  gs = get_stats(nse[*,*,i],bins)
  tot[*,i]  = gs[*,0]
  b[*,i]  = gs[*,1]
  db[*,i] = gs[*,2]
endfor

labels = string(indgen(12)+1,format='("Ch",i02)')
store_data,prefix+'_tot',dlim={colors:'bgr',labels:labels,labflag:1},data={x:tt,y:tot}
store_data,prefix+'_avg',dlim={colors:'bgr',labels:labels,labflag:1,yrange:[-2,2.],ystyle:1},data={x:tt,y:b}
store_data,prefix+'_sig',dlim={colors:'bgr',labels:labels,labflag:1,yrange:[0,3],ystyle:1},data={x:tt,y:db}

end


function delta_counter,d,nbits
dd = long(d) - shift(long(d),1)
dd = dd + (2ul^nbits) * (dd lt 0)
dd[0]=dd[1]
return,dd
end


pro store_hkp_counter,name,time,d,nbits
store_data,'c-'+name,data={x:time,y:d}
if keyword_set(nbits) then store_data,'r-'+name,data={x:time,y:delta_counter(d,nbits) }
end




function treat_as_bytes,mem
;n= n_elements(mem)
d = size(/dimen,mem)
bmem = bytarr([2,d])
;printdat,bmem
;help,bmem,bmem[0,*],bmem[0,*,*],mem
bmem[1,*,*] = mem/256
bmem[0,*,*] = mem mod 256
d[0] = d[0]*2
return,reform(bmem,d)
end


pro set_dap_memory,mem,addr,offset
common dap_mem_com,dap_memory
help,mem,addr,offset
if not keyword_set(dap_memory) then dap_memory = replicate(-1,4096,32)
if not keyword_set(offset) then offset =0
index= indgen(240)
for i = 0l , n_elements(addr)-1 do begin
   m = mem[*,i]
   dap_memory[index+addr[i]*256l+offset]= m[index]
if addr[i] ne 8 then print,i,addr[i]
endfor

end


function read_raw_data_rec,fp,nrecs,times = time,nsum = nsum

dat = {t:bytarr(6), $
       s:uintarr(128), $
       hkp:bytarr(16), $
       n:uintarr(120)}

tdat = {t:bytarr(6), $
       s:fltarr(128), $
       hkp:bytarr(16), $
       n:uintarr(120)}


if keyword_set(nsum) then begin
  nsteps = nrecs / nsum
  temp = replicate(dat,nsum)
  for i =0l,nsteps-1 do begin
      readu,fp,temp
      tdat.s = total(temp.s,2)/nsum   ;  average in floating point
      tdat.t = temp[nsum/2].t
      tdat.hkp= temp[nsum-1].hkp
      tdat.n  = temp[nsum-1].n
      append_array,adat,tdat,index=index
  endfor
  append_array,adat,/done,index=index
endif else begin
  adat = replicate(dat,nrecs)
  readu,fp,adat
endelse

time = ((adat.t[0]*256ul+adat.t[1])*256ul+adat.t[2])*256ul+adat.t[3]
time = time - 2208988800 ;  time_double('1900-1-1')    ; seconds since 1970
tzonediff=tzdiff(time)
time = time + tzonediff *3600l   ; local time
time = time +((adat.t[4]*256u+adat.t[5]) / 64) / 1024d

return,adat
end


function sstgse_raw_file_stats,files,noclose=noclose
if not keyword_set(files) then files = dialog_pickfile(filter='*.raw',/multi)
nfiles = n_elements(files)
reclength = 518
nt = 2
fs = fstat(0)
tps = {t:0d,rec:0l}
str_element,/add,fs,'fpga',0
str_element,/add,fs,'nrecs',0l
str_element,/add,fs,'tps',replicate(tps,nt)
afs = replicate(fs,nfiles)
for i=0,nfiles-1 do begin
   openr,unit,files[i],/get_lun,/swap_if_little_endian
   struct_assign, fstat(unit), fs
   fs.rec_len = reclength
   fs.nrecs = fs.size / reclength
   for j=0,nt-1 do begin
      rec = j * (fs.nrecs/(nt-1)-1)
      point_lun,unit,rec * reclength
      dat = read_raw_data_rec(unit,1,times=times)
      fs.tps[j].t = times
      fs.tps[j].rec = rec
   endfor
   if not keyword_set(noclose) then free_lun,unit
   afs[i] = fs
endfor
s = sort(afs.tps[0].t)

return,afs[s]

end



function read_sstgse_raw2,file,trange=trange, $
   time=time,tzonediff=tzonediff,tail=tail,nsum=nsum

fs = sstgse_raw_file_stats(file)
if keyword_set(debug) then printdat,fs,/nstr

nf = n_elements(fs)

ptrs = replicate(0l,nf)
nrec = replicate(0l,nf)

if keyword_set(tail) then begin
   frac = tail*60d*32/3/(fs.size/fs.rec_len)
   range = [1-frac,1.] > 0.
   printdat,range,'range'
endif

dat=0
time=0

if not keyword_set(trange) then trange= minmax(fs.tps.t)
for i=0,nf-1 do begin
   f = fs[i]
   rec = round(interp(f.tps.rec,f.tps.t,trange))
   rec = 0 > rec < (f.nrecs)
   if rec[0] ne rec[1]  then begin
     print,f.name
     openr, fp,f.name, /get_lun,/swap_if_little_endian
     point_lun,fp,rec[0]*f.rec_len
     append_array, dat, read_raw_data_rec(fp,rec[1]-rec[0],time=t,nsum=nsum)
     append_array, time,t
     free_lun,fp
   endif
endfor

return,dat
;load_sstgse_raw,adat

end


pro sstgse_tdiff,tshift=tshift
  get_data,'N-CMDS',data=d1
  get_data,'r-cmd',data=d2
  c1 = total(d1.y,/cum,/pres)
  t1 = d1.x
  c2 = total(d2.y,/cum,/pres)
  if n_elements(tshift) eq 0 then tshift=0
  t2 = d2.x+tshift
  ;stop
  double_data,t1,c1
  c1b = interp(c1,t1,t2)
  dc = (c1b-c2)  ; mod 512
  store_data,'dcmd',data={x:d2.x+tshift,y:dc},dlim={ynozero:1,ystyle:2,psym:10}
end


function tshift,t
if n_elements(t) ne 2 then ctime,t,/silent
s = tsample('dcmd',t)
c = tsample('r-cmd',t)
s=s-s[0]
nc = total(c)
;plot,total(/cum,s)
n=n_elements(s)
;print,total(s),nc,n
return,total(s)/nc*.09375
end



function correct_tshift,t,old=old
if not keyword_set(t) then ctime,t,/silent
n = n_elements(t)/2
t=reform(t,2,n)
ts = fltarr(n)
for i=0,n-1 do  ts[i] = tshift(t[*,i])

tm = average(t,1)
if keyword_set(old) then ts_old = data_cut(/ext,'tshift',tm) else ts_old=0
shiftpar = splfunc(tm,ts+ts_old,/lin)
store_data,'tshift',data=shiftpar,dlim={psym:-1}
return,shiftpar
end


;
;function tshift2,t,range=range,plot=plot
;   if not keyword_set(range) then range=[-30,30.]
;   if n_elements(t) ne 2 then ctime,t,/silent
;   if n_elements(t) eq 1 then t = t+[-15,15]
;   print,time_string(t)
;   c1 = float(tsample('r-cmd',t+range+[-1,1],time=t1))
;  ; c1 = float(tsample('r-cmd',t,time=t1))
;   c2=  tsample('NCMDS',t,time=t2)
;
;   col=0
;   ;plot,c2
;
;   delta = dgen(range=range,res=.025)
;   dc = fltarr(n_elements(delta))
;   for i=0,n_elements(delta)-1 do begin
;     cc = interp(c1,t1,t2+delta[i],/no_extrap)
;     ;cc = interp(c1,t1,t2+delta[i])
;     dc[i] = sqrt(total((c2-cc)^2))
;     ;oplot,cc,color =col++ mod 6 + 1
;     ;print,delta,dc
;   endfor
;
;   w=min(dc,mbin)
;   if keyword_set(plot) then begin
;      plot,delta,dc,/ylog
;   endif
;   print,'tshift=',delta[mbin],'   err=',dc[mbin],mbin
;   return,delta[mbin]
;end



pro load_sstgse_raw,files,adat=adat,time=time,nsum=nsum $
  ,trange=trange,prefix=prefix,tshift=tshift

if not keyword_set(adat) then $
   adat = read_sstgse_raw2(files,nsum=nsum,trange=trange,time=time,tzonedif=tzonedif)

if keyword_set(tshift) then begin
   if size(/type,tshift) eq 8 then time = time-func(time,par=tshift) $
   else   time=time+tshift
endif

;time = ptr_new(time)

if not keyword_set(adat) then return

if keyword_set(nsum) and not keyword_set(prefix) then prefix='S-'

if not keyword_set(prefix) then  prefix=''


noise = transpose(adat.n)
;store_data,'noise',data={x:time,y:noise,v:findgen(120)},dlim={no_interp:1,spec:1,panel_size:3}
dnoise = noise-shift(noise,1,0)
;if keyword_set(nsum) then dnoise = float(dnoise)/nsum
store_data,prefix+'dnoise',data={x:time,y:dnoise,v:findgen(120)},dlim={no_interp:1,spec:1,panel_size:3,zrange:[.8,30],zlog:1}
noise_stats,time,dnoise,nsampl=keyword_set(nsum) ? 1 : 32*1,prefix=prefix+'dN'

d = transpose(adat.s)
;if keyword_set(nsum) then d = float(d)/nsum
bins = findgen(128)
store_data,prefix+'C', data={x:time,y:d,v:bins},dlim={no_interp:1,spec:1,panel_size:2,zrange:[.8,30],zlog:1,yrange:[-2,130],ystyle:1}

store_data,prefix+'Ctot',data={x:time,y:total(d,2)}
store_data,prefix+'Cn0',data={x:time,y:total(d[*,1:*],2)},dlim={colors:'b'}
store_data,prefix+'Clow',data={x:time,y:total(d[*,1:63],2)},dlim={colors:'g'}
store_data,prefix+'Chi',data={x:time,y:total(d[*,64:*],2)},dlim={colors:'r'}
store_data,prefix+'C0',data={x:time,y:d[*,0]},dlim={colors:'c'}
store_data,prefix+'Csum',data=prefix+strsplit('Ctot C0 Cn0 Clow Chi',' ',/ext),dlim={panel_size:2,yrange:[.5,5000],ylog:1,ystyle:1}

nd = dimen1(d)
clabels = strsplit('0o 0t 0f 0m 1o 1t 1f 1m 2o 2t 2f 2m 3o 3t 3f 3m',' ',/extract)
store_data,prefix+'Cmap4',data={x:time,y:total( reform(d,nd,8,16), 2 )}, $
   dlim={colors:'bgry',labels:clabels,labflag:1,yrange:[.5,5000],ylog:1,ystyle:1}

store_data,prefix+'Cgrp3',data=prefix+'Cmap4',dlim={bins:indgen(16) / 4 eq 3 and indgen(16) mod 4 ne 3,colors:'bgry',spec:0}
store_data,prefix+'Cgrp2',data=prefix+'Cmap4',dlim={bins:indgen(16) / 4 eq 2 and indgen(16) mod 4 ne 3,colors:'bgry',spec:0}
store_data,prefix+'Cgrp1',data=prefix+'Cmap4',dlim={bins:indgen(16) / 4 eq 1 and indgen(16) mod 4 ne 3,colors:'bgry',spec:0}
store_data,prefix+'Cgrp0',data=prefix+'Cmap4',dlim={bins:indgen(16) / 4 eq 0 and indgen(16) mod 4 ne 3,colors:'bgry',spec:0}
ylim,'Cgrp?',/default,.8,5000,1


nsmooth = 32
mondat = smooth(1.*d[*,104:127],[nsmooth,0])
;help,mondat
store_data,prefix+'Cmon',data={x:time,y:mondat},dlim={colors:'bgrmcy'}
store_data,prefix+'Ct',data={x:time,y:total(d[*,0:103],2)}
store_data,prefix+'Cs',data='Cmon Ct'

colors = 'bgrmcy'
store_data,prefix+'Cm0',data=prefix+'Cmon',dlim={bins:indgen(24) / 6 eq  0,colors:colors,spec:0,panel_size:2}
store_data,prefix+'Cm1',data=prefix+'Cmon',dlim={bins:indgen(24) / 6 eq  1,colors:colors,spec:0,panel_size:2}
store_data,prefix+'Cm2',data=prefix+'Cmon',dlim={bins:indgen(24) / 6 eq  2,colors:colors,spec:0,panel_size:2}
store_data,prefix+'Cm3',data=prefix+'Cmon',dlim={bins:indgen(24) / 6 eq  3,colors:colors,spec:0,panel_size:2}


store_data,prefix+'dN_avg3',data=prefix+'dN_avg',dlim={bins:indgen(12) / 3 eq 3 }
store_data,prefix+'dN_avg2',data=prefix+'dN_avg',dlim={bins:indgen(12) / 3 eq 2 }
store_data,prefix+'dN_avg1',data=prefix+'dN_avg',dlim={bins:indgen(12) / 3 eq 1 }
store_data,prefix+'dN_avg0',data=prefix+'dN_avg',dlim={bins:indgen(12) / 3 eq 0 }

store_data,prefix+'dN_sig3',data=prefix+'dN_sig',dlim={bins:indgen(12) / 3 eq 3 }
store_data,prefix+'dN_sig2',data=prefix+'dN_sig',dlim={bins:indgen(12) / 3 eq 2 }
store_data,prefix+'dN_sig1',data=prefix+'dN_sig',dlim={bins:indgen(12) / 3 eq 1 }
store_data,prefix+'dN_sig0',data=prefix+'dN_sig',dlim={bins:indgen(12) / 3 eq 0 }


colors = 'mbcdgyry'
if 1 then begin
store_data,prefix+'C01',data=prefix+'C',dlim={bins:indgen(128) / 8 eq  0,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C02',data=prefix+'C',dlim={bins:indgen(128) / 8 eq  1,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C03',data=prefix+'C',dlim={bins:indgen(128) / 8 eq  2,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C04',data=prefix+'C',dlim={bins:indgen(128) / 8 eq  4,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C05',data=prefix+'C',dlim={bins:indgen(128) / 8 eq  5,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C06',data=prefix+'C',dlim={bins:indgen(128) / 8 eq  6,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C07',data=prefix+'C',dlim={bins:indgen(128) / 8 eq  8,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C08',data=prefix+'C',dlim={bins:indgen(128) / 8 eq  9,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C09',data=prefix+'C',dlim={bins:indgen(128) / 8 eq 10,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C10',data=prefix+'C',dlim={bins:indgen(128) / 8 eq 12,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C11',data=prefix+'C',dlim={bins:indgen(128) / 8 eq 13,colors:colors,spec:0,panel_size:2}
store_data,prefix+'C12',data=prefix+'C',dlim={bins:indgen(128) / 8 eq 14,colors:colors,spec:0,panel_size:2}
ylim,prefix+'C??',.001,1200,1,/defa
;options,prefix+'C??',colors=colors
endif


nse = adat.hkp[0] / 16b
store_data,prefix+'hkp-nse',data={x:time,y:(nse and 7)} ,dlim={yrange:[0,7]}   ;,dlim={tplot_routine:'bitplot',numbits:4}
sensorena = (adat.hkp[0] mod 16) *256 + adat.hkp[1]
store_data,prefix+'hkp-sena',data={x:time,y:sensorena}, $
    dlim={tplot_routine:'bitplot',numbits:12,labels:strsplit(/ext,'O T F O T F O T F O T F'),colors:'bgr'}
plsr = adat.hkp[3] / 16
store_data,prefix+'hkp-plsr',data={x:time,y:plsr}, $
    dlim={tplot_routine:'bitplot',numbits:4,labels:strsplit(/ext,'O T F Ena'),colors:'bgrd'}
door = adat.hkp[3] and 15
door1 = door and 3
door2 = door and 12
door1_err = (door1 eq 0) or (door1 eq 3)
door2_err = (door2 eq 0) or (door2 eq 12)
door_err = door1_err * 32 + door2_err*64
store_data,prefix+'hkp-door',data={x:time,y:door or door_err},dlim={tplot_routine:'bitplot',numbits:8,labels:['1 Closed','1 Open','2 Closed','2 Open','','1 Err','2 Err'],colors:'rgrgbbbb'}
door1_err = smooth(float(door1_err),99) * 99
door2_err = smooth(float(door2_err),99) * 99
store_data,prefix+'hkp-door1-err',data={x:time,y:door1_err}
store_data,prefix+'hkp-door2-err',data={x:time,y:door2_err}
store_data,prefix+'hkp-mux',data={x:time,y:adat.hkp[4] / 32},dlim ={yrange:[-1,8]}

store_data,prefix+'hkp-FPGA',data={x:time,y:adat.hkp[11]},dlim={tplot_routine:'bitplot',numbits:8}

map = adat.hkp[10]
store_data,prefix+'hkp-map',data={x:time,y:map}, $
    dlim={tplot_routine:'bitplot',numbits:8,colors:'bgrcmddd'}
store_data,prefix+'hkp-blrd',data={x:time,y:adat.hkp[13]}, dlim={tplot_routine:'bitplot',numbits:8}

fpga_version = adat[20].hkp[11]
help,fpga_version

if fpga_version ge 20 then begin

store_data,prefix+'hkp-spb',data={x:time,y:adat.hkp[5] mod 16}, $
    dlim={tplot_routine:'bitplot',numbits:4,colors:'mcyd',labels:['grp0','grp1','grp2','grp3']} ;yrange:[-1,4],

w3 = adat.hkp[4] * 256u + adat.hkp[5]
memad = (w3 / 16) mod 512
store_hkp_counter,prefix+'memadd',time, memad   ,9

store_hkp_counter,prefix+'gse-sc',time, adat.t[5] mod 64   ,6
store_hkp_counter,prefix+'mf',time, adat.hkp[6] / 16   ,4
store_hkp_counter,prefix+'tp',time, adat.hkp[6] mod 16 ,4
store_hkp_counter,prefix+'ep',time, adat.hkp[7] / 16   ,4
store_hkp_counter,prefix+'nm',time, adat.hkp[7] mod 16 ,4
store_hkp_counter,prefix+'np',time, adat.hkp[14]*256u + adat.hkp[15] ,16
store_hkp_counter,prefix+'ec',time, adat.hkp[8]*256u + adat.hkp[9] ,0
store_hkp_counter,prefix+'sc',time, adat.hkp[13] mod 32 ,5
store_hkp_counter,prefix+'dt',time, adat.hkp[12]  ,8
store_hkp_counter,prefix+'cmd',time, adat.hkp[2]  ,8

endif else begin


;store_data,'hkp-dapid',data={x:time,y:adat.hkp[5] mod 16} , dlim={yrange:[0,16]}
store_data,'hkp-W4',data={x:time,y:adat.hkp[6]*256u+adat.hkp[7]}
store_data,'hkp-MT',data={x:time,y:adat.hkp[6]}
store_data,'hkp-EPT',data={x:time,y:adat.hkp[7]}
d = fix(adat.hkp[8])
dd = d - shift(d,1)
dd = dd + 256 * (dd lt 0)
store_data,'hkp-NP',data={x:time,y:d}
store_data,'r-NP',data={x:time,y:dd}
;store_data,'hkp-MFT',data={x:time,y:adat.hkp[8] / 16}
;store_data,'hkp-TT',data={x:time,y:adat.hkp[8] mod 16}
store_data,'hkp-DT',data={x:time,y:adat.hkp[9]}
d = fix(adat.hkp[9])
dd = d - shift(d,1)
dd = dd + 256 * (dd lt 0)
store_data,'r-DT',data={x:time,y:dd}
;store_data,'hkp-eerr',data={x:time,y:adat.hkp[9]}
map = adat.hkp[10]
store_data,'hkp-map',data={x:time,y:map}, dlim={tplot_routine:'bitplot',numbits:8}
;store_data,'hkp-FPGA',data={x:time,y:adat.hkp[11]},dlim={tplot_routine:'bitplot',numbits:8}
;store_data,'hkp-W7',data={x:time,y:adat.hkp[12]*256u+adat.hkp[13]}
store_data,'hkp-NMT',data={x:time,y:adat.hkp[12]}
d = fix(adat.hkp[12])
dd = d - shift(d,1)
dd = dd + 256 * (dd lt 0)
store_data,'r-NMT',data={x:time,y:dd}
store_data,'hkp-sctr',data={x:time,y:adat.hkp[13]}

endelse


if 1 then begin
  w = where(memad ne 8,nw)
  if nw gt 0 then begin
    dapmem = treat_as_bytes(adat[w].n)
    printdat,dapmem
    store_data,'mem',data={x:time[w],y:transpose(dapmem),v:findgen(240)} ,dlim={no_interp:1,spec:1,panel_size:3,zlim:[0,130]}
;  set_dap_memory,dapmem,memad
  endif
endif


;sys_steady = (shift(plsr,-1) eq shift(plsr,1))
;sys_steady = sys_steady and (shift(map,-1) eq shift(map,1))
;sys_change = fix(sys_steady) - shift(sys_steady,1)
;store_data,'steady',data={x:time,y:sys_steady}
;store_data,'dsteady',data={x:time,y:sys_change}

;stop

end

