pro plot_spectra,dat,over=over,col=col,fit=p,lim=lim
if not keyword_set(dat) then begin
   s1 = tsample('C',t,times=ts)

   dat=s1
endif else begin
   s1=dat
endelse
if not keyword_set(lim) then begin
   xlim,lim,0,130,0
   ylim,lim,.0001,5000,1
   options,lim,psym=10
endif

if not keyword_set(over) then box,lim
dim= size(/dimen,s1)
n1 = dim[0]

t1 = total(s1,1)
r1 = t1/n1
d1 = sqrt(t1+.2)/n1

bins = indgen(128)

oplot,bins,r1,psym=4,col=col
oplot_err,bins,r1-d1,r1+d1,col=col

if arg_present(p) then begin
   if size(/type,p) ne 8 then p = {thresh:threshold_response(), p:igauss() }
   pfit = p.p
   pfit.x0 = pfit.x0 > 35
   pfit.s  = abs(pfit.s) > 1
   pfit.a  = pfit.a >.01
   printdat,pfit
   w=where(bins gt 30)
   fit,bins[w],r1[w],dy=d1[w],param=pfit
   oplot,bins,igauss(bins,binw,param=pfit),col=col,psym=10
   p.p = pfit
   res=pfit.s * 2.35 * 59.5 / pfit.x0
   print,'res=',res,' keV'

   w=where(bins lt 10)
   tfit = p.thresh
   fit,bins[w],r1[w],dy=d1[w],param=tfit
   oplot,bins,threshold_response(bins,binw,param=tfit),col=col,psym=10
   p.thresh = tfit
   printdat,p,'par'

;stop
endif


end