
pro plot_extpulse_stat,data,pks,param=p

if not keyword_set(pks) then pks = sstgse_extpulse_cal(data)

p=dap_response2()

d = data[0]
struct_assign,d,p,/nozero
p.time = minmax(data.time)

p.map = d.valsm.hkp_map


x = data.valsm.aout0_
xmm = minmax(x)
xmm = [0,8]


y = pks.x0
dy = pks.s
a = pks.a

psize = [800,800]

wi,2,wsize=psize

ns = n_elements(y)
ymm = minmax(y)
ymm = [-20,120]

dat=data[0]
title =time_string(dat.time[0])
dstring = det_string(dat.ch_code)
title = title + string(form='(" DAP:",i02,"  S1:",i02, "  S2:",i02,"  ",a)',dat.dap,dat.sensor1,dat.sensor2,dstring)
title =title + '  Ext Pulser  '

plot,xmm,ymm,/ystyle,/xstyle,/nodata,xtitle='Aout (V)',ytitle='X0 center (ADC units)',title=title

oplot,x,y,psym = 1,col = 4
oplot,x,dy * 10 ,col = 2,psym=-1
oplot,x,a, col = 6,psym=-1

w = where(x lt 5.25 and y lt 110 and a gt .9*average(a[where(x gt 2)]))

fit,x[w],y[w],param=p,chi=chi
p.chi=sqrt(chi)
pf,p,col=1
oplot,x[w],y[w],col=1,psym=4
pt = p
pt.a_1 = 0
pf,pt

oplot,xmm,[0,0],linestyle=1,col=4
oplot,x[w],10*(y[w]-func(x[w],param=p)),/ps  ;,col=1


xyouts,x[w],y[w],string(y[w],format='(f7.1)'),charsi=.7

printdat,p,'Fit Results',/value,outstri=str
n=n_elements(str)
charsize=.8
pos = (convert_coord(!x.crange[0],!y.crange[1],/data,/to_device))[0:1]
px = pos[0] + replicate(2,n) * charsize * !d.x_ch_size
py = pos[1] - (indgen(n)+2)  * charsize * !d.y_ch_size * 1.5
xyouts,px,py,/device,str,align=0,charsize=charsize
print,str



fname = time_string(format=2,p.time[0],prec=-1)
fname=  fname+string(form='("sst_D",i02,"_S",i02, "_S",i02)',p.dap,p.sensor1,dat.sensor2)
fname = fname+'_'+dstring+'_EPcal'

print,'filename: ',fname
makepng,fname
save,pks,data,p,file=fname+'.sav'




end





