
pro plot_spec_stat2,data,pks,param=p,all=all

d=data[0]
fname = time_string(format=2,d.time[0],prec=-1)
fname=  fname+string(form='("sst_D",i02,"_S",i02, "_S",i02)',d.dap,d.sensor1,d.sensor2)
;fname = fname+'_'+dstring+'_EPcal'


if keyword_set(all) then begin
   p = 0
   for i=0,11 do begin
      w = where(data.det eq i,nw)
      if nw ne 0 then begin
         plot_extpulse_stat2,data[w],param=pt
         append_array,p,pt
      endif
   endfor
   wi,3  ,wsize = [800,600]
   plot,[-1,12],[-6,4],/nodata,/xstyle,/ystyle,title=fname
   gain_avr=average(p.dr.gain)
   oplot,[-1,12],[0,0],linestyle=1
   oplot,p.det,(p.dr.gain-gain_avr)/gain_avr*100,psym=-1,col=2
   oplot,p.det,p.dr.b0,psym=-1,col=4
   oplot,p.det,p.pknse.x0-.5,psym=-1
   oplot,p.det,p.dr.a_1,psym=-1,col=6
   xyouts,0,3,string(form='("average gain=",f0.3)',gain_avr),col=2

   makepng,fname
   save,data,p,file=fname+'.sav'
   print,fname

   return
endif

if n_elements(pks) ne n_elements(data) then pks = sstgse_spec_cal(data)

if not keyword_set(p) then begin
  p = { time:lonarr(2)  $
         ,sensor:-1  $
         ,dap:-1,sensor1:-1,sensor2:-1,det:-1,ch_code:-1,map:-1 $
         ,resp:sst_response()  $
;         ,tpr: tailpulser_response(),  $
;         ,elr: electron_pulse_response()  $
;         ,dr: dap_response2() $
         ,pknse: igauss() $
         ,chi:0.}

endif

p=p[0]

struct_assign,d,p,/nozero
p.time = minmax(data.time)

p.map = d.valsm.hkp_map

;ao = data.valsm.aout0_
;tp = func(ao,param=p.tpr)
;sp = - func(tp,param=p.spr)
;adc =  func(sp,param=p.dr)

;x=sp   &   xtitle = 'Shaped Pulse Height (mV)'

x = data.valsm.b50k_v

sp = x / 1.6

xmm = minmax(x) > 0  & xstyle=0
xmm = [0,60]  & xstyle=1

y = pks.x0
dy = pks.s
a = pks.a

wi,2,wsize=[900,900]

ns = n_elements(y)
ymm = minmax(y)
ymm = [-10,40]

dat=data[0]
title = time_string(dat.time[0])
dstring = sstdet_string(dat.ch_code)
fname=fname+'_'+dstring
;title = title + string(form='(" DAP:",i02,"  S1:",i02, "  S2:",i02,"  ",a)',dat.dap,dat.sensor1,dat.sensor2,dstring)
;title =title + '  Ext Pulser  '

plot,xmm,ymm,/ystyle,xstyle=xstyle,/nodata,xtitle=xtitle,ytitle='ADC value',title=fname

oplot,x,y,psym = 1,col = 4
;oplot,x,dy * 10 ,col = 2,psym=-1
;oplot,x,a, col = 6,psym=-1

;w = where(ao lt 5.25 and y lt 110 and a gt .9*average(a[where(ao gt 2)]))
w = where(finite(x) and x ge 28)

resp = p.resp
fit,x[w],y[w],param=resp,name='elr',chi=chi
p.chi=sqrt(chi)
p.resp=resp
xv = dgen()

pf,resp,col=1
oplot,x[w],y[w],col=1,psym=4
;dr.a_1 = 0
;pf,dr

do_noise=1
if do_noise then begin
  b = indgen(120)
  n = average(data.n,2)
  pknoise = noise_response()
  pknoise.nse = data[0].valsm.hkp_nse
  fit,b,n,param=pknoise  ,/silent
  pk = pknoise.pg[p.det]
  pknse = p.pknse
  struct_assign,pk,pknse,/nozer
  p.pknse=pknse
endif


oplot,xmm,[0,0],linestyle=1   ;,col=4
;oplot,x[w],10*(y[w]-func(x[w],param=p.dr)),/ps  ;,col=1
pf,p.resp

xyouts,x[w],y[w],string(y[w],format='(f7.1)'),charsi=.7

printdat,p,'Fit Results',/value,outstri=str
n=n_elements(str)
charsize=.8
pos = (convert_coord(!x.crange[0],!y.crange[1],/data,/to_device))[0:1]
px = pos[0] + replicate(2,n) * charsize * !d.x_ch_size
py = pos[1] - (indgen(n)+2)  * charsize * !d.y_ch_size * 1.5
xyouts,px,py,/device,str,align=0,charsize=charsize
;print,str



;fname = time_string(format=2,p.time[0],prec=-1)
;fname=  fname+string(form='("sst_D",i02,"_S",i02, "_S",i02)',p.dap,p.sensor1,dat.sensor2)
;fname = fname+'_'+dstring+'_EPcal'

print,'filename: ',fname
makepng,fname+'_resp2'
save,pks,data,p,file=fname+'.sav'


end





