function smoothstep,x,parameter=p,x0=x0,x1=x1,sig=sig
if not keyword_set(p) then begin
   if  n_elements(x0) eq 0 then x0=-1d
   if  n_elements(x1) eq 0 then x1= 1d
   if  n_elements(sig) eq 0 then sig = .1d
   p = {x0:x0, x1:x1, s:sig}
endif
f = (erf((x-p.x0)/p.s)  - erf((x-p.x1)/p.s)  ) /2
return,f
end



function presssim,t,p,parameter=par


common dpressure_dt_com, par0, b,c

if keyword_set(par) then par0 = par

if size(/type,par0) ne 8 then begin
  iv = [0d,0d,1/1d6,1/50d,1/10d,1/1d]
  n = n_elements(iv)
  r2 = [2d-5,1000000d,0,1d,1d-1,2.1d-3]
  print,'1/iv*r2=',1/(iv*r2)
  r= dblarr(n,n)
  if 1 then r[2,*] = r2 else begin
    r[2,0:3] = r2[0:3]
    r[3,4] = r2[4]
    r[4,5] = r2[5]
  endelse
  r = r + transpose(r)
  print,r
  print
  print,1/(r * (iv # replicate(1,n)))
  print
  par0 = {n:n, iv:iv,  r:r }

endif
if size(/type,par) ne 8 then par=par0

n = par0.n

if not keyword_set(p) then begin
   p = replicate(760d,n)
   p[1] = 2e-7
endif

r= par0.r

r21 = r[2,1]
open = smoothstep(t,x0=60,x1=6*3600,sig=10) - smoothstep(t,x0=2000d,x1=2600d,sig=10)
r[2,1] = r21 *open
r[1,2] = r21 * open

one = replicate(1,n)
rpp = r * ( p # one - one # p)

dpdt = par0.iv * total(rpp,1)

return,dpdt
end


par = 1
t = dindgen(40000)
t = dindgen(3600*1)
p=0
print,presssim(t[0],p,param=par)
n=n_elements(p)
dat = rk4_rep(p,t,deriv='presssim')
plot,t/3600,dat[*,2],/ylog,/ystyle,yrange=[1e-10,1000]
for i=1,n-1 do oplot,t/3600,dat[*,i],color=i-1

for i=2,2 do oplot,t/3600,60*(deriv(t,dat[*,i])),color=6
end

