

function read_sstgsedatafile,basenames,format=fm $
  ,gaptime=gaptime $
  ,verbose=verbose,tags=filetags,time=time $
  ,append=append $
  ,extension=extension  $
  ,nheader=nheader , headers=headers $
  ,filter=filter

if not keyword_set(fm) then fm = {data:fltarr(18)}
date_struct= {month:0, date:0, year:0, hour:0, min:0, sec:0}
;f1 = create_struct(date_struct,fm)
f2 = create_struct({time:0d},fm)
f1 = {date:date_struct,data:fm}

if not keyword_set(filter) then filter='*'
if not keyword_set(extension) then extension=''


if keyword_set(basenames) then filenames = basenames + extension $
else begin
  filenames=dialog_pickfile(filter=filter+extension,/multi,/read)
  filenames = filenames[sort(filenames)]
endelse


if not keyword_set(filenames) then return,0
if not keyword_set(fm) then return,0

badlines = 0
ctype = bytarr(256)
ctype([32,9]) = 1                 ; white space
ctype(byte('.-0123456789')) =2    ; numbers
s = ''
rec = 0l
if keyword_set(append) then data=append
rec = n_elements(data)
max = rec


for fn=0,n_elements(filenames)-1 do begin
filename = filenames[fn]

on_ioerror,badfile

openr,lun,filename,/get_lun

print,filename

for i=0,(keyword_set(nheader) ? nheader : 0)-1 do begin
   readf,lun,s
   if i eq 0 then headers = s    else    headers = [headers,s]
   if keyword_set(verbose) then print,s
endfor

while not eof(lun) do begin
  readf,lun,s
  strput,s,' ',2
  strput,s,' ',5
  strput,s,' ',13
  strput,s,' ',16
if keyword_set(verbose) then print,s
  bt = byte(s)
  nbt = n_elements(bt)
  j = 0
  while (j lt nbt-1) and (ctype(bt(j)) eq 1) do j=j+1   ; skip white space
  if ctype(bt(j)) eq 2 then begin    ; numbers encountered
    f0 = f1
    if rec ge max then begin        ;Enlarge data array (if neccesary)
       add = floor(max * .5 + 100)
       if max ne 0 then data=[data,replicate(f0,add)]  $
       else data = replicate(f0,add)
       max = max+add
    endif
    valid = 0
    on_ioerror,baddata
    reads,s,f0
    valid = 1
    data[rec]=f0
    rec = rec+1
baddata:
    if valid eq 0 then begin
       if badlines lt 5 then print,'Bad input line: ',s
       badlines = badlines+1
    endif
  endif else begin
    if strlen(s) gt 1 then ls = s
;    if keyword_set(verbose) then print,s
  endelse
endwhile

if keyword_set(lun) then free_lun,lun

endfor

if rec ne 0 then data=data[0:rec-1]



if keyword_set(data) then begin
  stime = data.date
  str_element,/add,stime,'fsec',0d
  ;str_element,/add,data,'sod',0d
  t = time_double(stime)
  d = replicate(f2,n_elements(t))
  struct_assign,data.data,d
  d.time=t
endif

; insert_gaps
if keyword_set(gaptime) then begin
  dt = d.time - shift(d.time,1)
  w = where(dt gt gaptime,nw)

  for i = 0,nw-1 do $
     print,time_string(d[w[i]-1].time),'  -   ',time_string(d[w[i]].time),'  ',dt[w[i]]
  if nw gt 0 then begin
     gapdat = replicate(fill_nan(d[0]),nw)
     gapdat.time = (d[w-1].time + d[w].time)/2
     d = [d,gapdat]
     s = sort(d.time)
     d=d[s]
  endif

endif





return,d


badfile:
;print,!err_string
message,/info,'Invalid file: '+filename
if keyword_set(lun) then free_lun,lun
return,0


end

