function sst_response,x,parameter=p,input=in,output=out

if not keyword_set(p) then begin
   p = { func:'sst_response' $
   ,input:'elec_e', output:'ADC' $
   ,fgr: functgen_response()  $
   ,tpr: tailpulser_response() $
   ,spr: shaped_pulse_response() $
   ,elr: electron_pulse_response() $
   ,xrr: 0 $
   ,dpr: dap_response2()    }
endif

if n_params() eq 0 then return,p

if not keyword_set(in)  then in  = strlowcase( p.input )
if not keyword_set(out) then out = strupcase( p.output )

case in of
'offs':    offs  = x
'vref':    vref  = x
'tpulse':  tpulse= x
'spulse':  spulse= x
'xray_e':  xray_e= x
'elec_e':  elec_e= x
'ion_e' :  ion_e = x
endcase

if keyword_set(offs)    then vref = func(offs,param=p.fgr)
if keyword_set(vref)   then tpulse = func(vref,param=p.tpr)
if out eq 'tpulse' then return,tpulse

if keyword_set(tpulse) then spulse = func(tpulse,param=p.spr)
if keyword_set(elec_e) then spulse = func(elec_e,param=p.elr)
if keyword_set(xray_e) then spulse = func(xray_e,param=p.xrr)
if out eq 'spulse' then return,spulse

adc = func(spulse,param=p.dpr)
if out eq 'ADC' then return,adc

return,0
end

