function sstgse_am241_cal,data,nplots=nplots

if size(/type,data) ne 8 then data=sstgse_am241_dat()

cols = ([2,4,6])[[0,1,2,0,1,2,0,1,2,0,1,2]]

wi,1,wsize = [1000,1000]

if not keyword_set(nplots) then nplots=4
charsize = .8

nspec  = 12/nplots
if nplots eq 4 then  !p.multi = [0,2,2]
if nplots eq 12 then !p.multi = [0,3,4]

ns = n_elements(data)

pk = igauss()
pk.a=5
pk.x0=38
pk.s=3
pks = replicate(pk,ns)
b=indgen(128)
pknoise = noise_response()
pkns = replicate(pknoise,ns)

mmtime = minmax(data.time)
titlestring ='  Base sBase  Area    X0   Sig  Gain   FWHM   T   Thr  '
print,titlestring
for i=0,ns-1 do begin
   dat = data[i]
   tri = dat.time
   val = dat.valsm
   thresholds = [val.thr01_,val.thr02_,val.thr03_,val.thr04_,val.thr05_,val.thr06_,val.thr07_,val.thr08_,val.thr09_,val.thr10_,val.thr11_,val.thr12_]
   s = dat.c
   d = i mod 12
   spc = i mod nspec
   if spc eq 0 then plot,[0,60],[0,1],/nodata   ,title='Am 241  '+time_string(tri[0])
   oplot,b,s,color=cols[d],ps=-1
   w= where (b gt 25 and b lt 45)
   fit,b[w],s[w],param=pk,/silen
   sfit = func(b,param=pk)
   oplot,b,sfit,color=cols[i],ps=10
   pks[i]=pk

   pknoise.nse = val.hkp_nse
   fit,indgen(120),dat.n,param=pknoise,/silent
   pkns[i] = pknoise
   pg=pknoise.pg[d]

   gain = 59.5/pk.x0
   width = 59.5/pk.x0 * pk.s *2.35
   temp = ([val.tint1,val.tint2])[d / 6]
   thresh = thresholds[d]

   str = string(pg.x0,pg.s,pk.a,pk.x0,pk.s,gain,width,temp,thresh,format='(f6.2,f6.2,f6.2,f7.2,f6.2,f6.3,f6.2,f6.1,i4)')

   pos = convert_coord(!x.crange[1],!y.crange[1],/data,/to_device)
   pos = pos - charsize * [!d.x_ch_size,!d.y_ch_size] * [2,2+spc*1.5]
   xyouts,pos[0],pos[1],/device,str,color=cols[d],align=1,charsize=charsize
   print,str
endfor

!p.multi=0

name = time_string(format=2,mmtime[0],prec=-1)+'_Am241'
;print,'filename: ',name
;makepng,name+string(nplots,format='("_",i02)')
;save,pks,pkns,file=name+'.sav'
return,pks
end
