


function sstgse_extpulse_cal,data,nplots=nplots

if size(/type,data) ne 8 then data=sstgse_extpulse_dat()

cols = [2,4,6]
ncols = n_elements(cols)
mmy = minmax(data.c)
;mmy = [0,6]

psize = [1000,800]
wi,1,wsize=psize

if not keyword_set(nplots) then nplots=1;24
charsize = .8

ns = n_elements(data)

nspec  =  41  ;(ns+1) / nplots   ;3  ;43/nplots
if nplots eq 4 then  !p.multi = [0,2,2]
if nplots eq 12 then !p.multi = [0,3,4]
if nplots eq 24 then !p.multi = [0,4,6]


pk = igauss()
pk.a=5
pk.x0=38
pk.s=3
pks = replicate(pk,ns)
b=indgen(128)
;pknoise = noise_response()
;pkns = replicate(pknoise,ns)

mmtime = minmax(data.time)
titlestring ='  Base sBase  Area    X0   Sig  Gain   FWHM   T   Thr  '
print,titlestring


;data.ch_code = data.valsm.hkp_map and 31
;xx=[99,0,1,12, 2,99,13,14]
;data.det = (data.ch_code / 8) * 3 + xx[data.ch_code mod 8]

for i=0,ns-1 do begin

   dat = data[i]
   dstring = det_string(dat.ch_code)

   tri = dat.time
   val = dat.valsm
   thresholds = [val.thr01_,val.thr02_,val.thr03_,val.thr04_,val.thr05_,val.thr06_,val.thr07_,val.thr08_,val.thr09_,val.thr10_,val.thr11_,val.thr12_]
   s = dat.c
   d = dat.det
   cls = cols[i mod ncols]
   spc = i mod nspec

   title =time_string(tri[0])
   title = title + string(form='("  DAP:",i02,"   S1:",i02, "   S2:",i02)',dat.dap,dat.sensor1,dat.sensor2)
   title =title + '  Ext Pulser  '
   if spc eq 0 then plot,[0,120],mmy,/nodata   ,title=title
   oplot,b,s,color=cls,ps=1

   s[0]=0
   mx = max(s,nbmax)
   pk.a=total(s[1:*])
   pk.x0 = b[nbmax]
   pk.s = .6
;   sfit = func(b,param=pk)
;   oplot,b,sfit,color=1,ps=10

   w= where (b gt 2 and b lt 128)
   fit,b[w],s[w],param=pk    ,/silen
   sfit = func(b,param=pk)
   oplot,b,sfit,color=cls,ps=10
   pks[i]=pk

   ;pknoise.nse = val.hkp_nse
   ;fit,indgen(120),dat.n,param=pknoise,/silent
   ;pkns[i] = pknoise
   ;pg=pknoise.pg[d]

  ; gain = 59.5/pk.x0
   ;width = 59.5/pk.x0 * pk.s *2.35
   temp = ([val.tint1,val.tint2])[d / 6]
   thresh = thresholds[d]

  ; str = string(pg.x0,pg.s,pk.a,pk.x0,pk.s,gain,width,temp,thresh,format='(f6.2,f6.2,f6.2,f7.2,f6.2,f6.3,f6.2,f6.1,i4)')
   str = string(dstring,val.aout0_,pk.a,pk.x0,pk.s,temp,thresh,format='(a,f4.1,f6.2,f7.2,f6.2,f6.1,i4)')

   pos = convert_coord(!x.crange[1],!y.crange[1],/data,/to_device)
   pos = pos - charsize * [!d.x_ch_size,!d.y_ch_size] * [2,2+spc*1.5]
   xyouts,pos[0],pos[1],/device,str,color=cls,align=1,charsize=charsize
   print,str
endfor

!p.multi=0



name = time_string(format=2,mmtime[0],prec=-1)
name=name+string(form='("sst_D",i02,"_S",i02, "_S",i02)',dat.dap,dat.sensor1,dat.sensor2)
name = name+'_'+dstring+'_EPcal_sp'

print,'filename: ',name
makepng,name
;save,pks,data,file=name+'.sav'
return,pks
end
