function sstgse_spec_cal,data,bkgdata=bkgdata,nplots=nplots,brk=brk

if size(/type,data) ne 8 then data=sstgse_sample()

cols = ([2,4,6])[[0,1,2,0,1,2,0,1,2,0,1,2]]
cols = [1,2,3,4,5,6,1,2,3,4,5,6,1,2,3,4,5,6,1,2,3,4,5,6]


if not keyword_set(nplots) then nplots=n_elements(data)
charsize = .8

nspec  = 1; 12/nplots
if nplots le 200 then !p.multi = [0,6,5]
if nplots le 25 then !p.multi = [0,5,5]
if nplots le 20 then !p.multi = [0,4,5]
if nplots le 16 then !p.multi = [0,4,4]
if nplots le 12 then !p.multi = [0,4,3]
if nplots le 9 then  !p.multi = [0,3,3]
if nplots le 6 then  !p.multi = [0,3,2]
if nplots le 4 then  !p.multi = [0,2,2]
if nplots eq 1 then !p.multi = 0


wi,1,wsize = [1200,1000] ;= ([2,2] > !p.multi[1:2] < [5,4]) * [350,250]

mmy=minmax(data.c[1:*])
mmx=[0,40]
ns = n_elements(data)

pk = igauss()

pks = replicate(pk,ns)
b=indgen(128)
pknoise = noise_response()
pkns = replicate(pknoise,ns)

mmtime = minmax(data.time)
titlestring ='  Base sBase  Area    X0   Sig  Gain   FWHM   T   Thr  '
print,titlestring
spec='Electron Response'
xtitle='ADC bin'
for i=0,ns-1 do begin
   dat = data[i]
   tri = dat.time
   val = dat.valsm
   thresholds = [val.thr01_,val.thr02_,val.thr03_,val.thr04_,val.thr05_,val.thr06_,val.thr07_,val.thr08_,val.thr09_,val.thr10_,val.thr11_,val.thr12_]

   bkg = keyword_set(bkgdata) ? bkgdata.c : dat.c*0
   s = dat.c - bkg
   ds = sqrt(dat.c * dat.ns +.5)/dat.ns
   if keyword_set(bkgdata) then ds  = sqrt( ds^2 +  bkgdata.c/bkgdata.ns)
   det = dat.det     ; i mod 12
   spc = i mod nspec
   title =spec+'   '+time_string(tri[0])
   if spc eq 0 then plot,mmx,mmy,ystyle=2,/nodata,xtitle=xtitle,ytitle='Cts/frame/bin'  ,title=title
   oplot,b,s,ps=-1,color= 2; cols[i]
   errplot,b,s-ds,s+ds,color=2
   if keyword_set(bkgdata) then oplot,b,bkg,ps=-1,color=3

   w= where (b ge 10 and b lt 35)
 ;  oplot,b[w],s[w],ps=4 ,color=6;cols[det]
   struct_assign,find_peak(s),pk,/nozero
   ;printdat,pk,'pk'
   fit,b[w],s[w],param=pk  ,/silen
   sfit = func(b,param=pk)
   oplot,b,sfit,ps=10,color= 4;cols[i mod n_elements(cols)]
   pks[i]=pk
   oplot,b[w],s[w],ps=4 ,color=6;cols[det]

   pknoise.nse = val.hkp_nse
   fit,indgen(120),dat.n,param=pknoise,/silent
   pkns[i] = pknoise
   pg=pknoise.pg[det]

   temp = ([val.tint1,val.tint2])[det / 6]
   thresh = thresholds[det]

   str = ''
   if keyword_set(am241) then begin
     gain = 59.5/pk.x0
     width = 59.5/pk.x0 * pk.s * 2.35
     str = string(pg.x0,pg.s,pk.a,pk.x0,pk.s,gain,width,temp,thresh,format='(f6.2,f6.2,f7.2,f7.2,f6.2,f6.3,f6.2,f6.1,i4)')
   endif
   if keyword_set(1) then begin
     energy = dat.valsm.b50k_v
     str = string(pg.x0,pg.s,pk.a,pk.x0,pk.s,energy,0.,temp,thresh, format='(f6.2,f6.2,f7.2,f7.2,f6.2,f6.1,f6.2,f6.1,i4)')
   endif

   pos = convert_coord(!x.crange[1],!y.crange[1],/data,/to_device)
   pos = pos - charsize * [!d.x_ch_size,!d.y_ch_size] * [2,2+spc*1.5]
   xyouts,pos[0],pos[1],/device,str,align=1,charsize=charsize;,color=cols[i]
   print,str
   if keyword_set(brk) and !p.multi[0] eq 0 then begin
       Print,'type any key to continue.  p to pause.'
       key = get_kbrd(1)
       print,key
       if key eq 'p' then stop


   endif
endfor

!p.multi=0

name = time_string(format=2,mmtime[0],prec=-1)+'_Am241'
;print,'filename: ',name
;makepng,name+string(nplots,format='("_",i02)')
;save,pks,pkns,file=name+'.sav'
return,pks
end
