function thm_sst_cal_all_channels,dat,prefix=prefix,pngprefix=pngprefix,arange=arange,brange=brange

if not keyword_set(prefix) then prefix=''
if not keyword_set(arange) then arange = [.65,11.]
if not keyword_set(brange) then brange = [0,110]
maps = dat.map
maps = maps(uniq(maps,sort(maps)))
nm = n_elements(maps)
print,'Total maps = ',nm
p = dapcal()
;p.x0=3
params = replicate(p,nm)
ylim,lim,0,250
for i=0,nm-1 do begin
   map = maps[i]
   title = thm_sst_map_string(map,chann=ch)
   w = where(dat.map eq map)
   d = dat[w]
   d = d(sort(d.ep))
   p.map = map
   p.time = minmax(d.t)
   p.channel=ch
   x = d.ep
   y = d.pk2.x0
   plot,x,y,psym=4,title=prefix+'   '+title,_extra=lim
   oplot,x,d.pk2.c,ps=-1,col=6
   oplot,x,d.pk2.w*10,ps=-1,col=4
   wg = where(x gt arange[0] and x lt arange[1] and finite(y) and y ge brange[0] and y lt brange[1])
   oplot,x[wg],y[wg],psym=1,/col
   print,x[wg],y[wg]
   fit,x[wg],y[wg],param=p,/over
   params[i] = p
   printdat,p,'Param',/value,outs=str
   string_out,str,.15,.85
   p.a2=0 & p.a3=0 & p.a4=0 & p.a5=0 & pf,p,/col
   if keyword_set(pngprefix) then makepng,pngprefix+'-'+strtrim(fix(map),2)
   stop

endfor

plot,params.channel,params.B0,ps=-4,xstyle=2,title=prefix,xtitle='Channel',ytitle='B0'
wi,2
plot,params.channel,params.gain,ps=-2,xstyle=2,title=prefix,xtitle='Channel',ytitle='External Pulser Gain'
if keyword_set(pngprefix) then makepng,pngprefix+'-'+'gains'


return,params
end
