

function thm_sst_steps,param=table,dac_cal=dac_cal,instrument=inst

Message,'Obsolete'
if inst le 0  then begin    ; electrons
  name = 'foil'
  nnrg = 16
  nphi = 32
  nthe = 4
  mode = 1
  mass = 511000.d/299792.d^2
  mom_shift=1
  q = -1
endif
if inst gt 0 then begin  ;ions
  name = 'open'
  nnrg = 16
  nphi = 32
  nthe = 4
  mode = 1
  mass = 511000.d/299792.d^2*1836d
  mom_shift = 1
  q = 1
endif

theta = (dindgen(nthe)+.5-nthe/2)*180d/nthe
dtheta = 180d/nthe + dblarr(nthe)

if not keyword_set(dac_cal) then begin
   dac_cal={gain:30000./2l^14,  offset:0.}
endif

if 1 then begin
e = dgen(/log,nnrg+1,range=[30000.,1e6])
nrg = (e + shift(e,+1))/2
dnrg = abs(e -shift(e,+1)) * 1.01
nrg=nrg[1:*]
dnrg=dnrg[1:*]
endif

btable = 1
e_cal = 1.5*100

;bin_edge=[16,24,32,40,48,56,64,72,80,88,96,104,112,120,128,136,4096]
bin_edge=fix(dgen(/log,nnrg+1,range=[16,4096.]))

btable = transpose([[bin_edge[0:15]],[bin_edge[1:16]]])
nrg = average(btable * e_cal,1)
dnrg = reform(btable[1,*]-btable[0,*])*e_cal
dnrg[12:*] = 0

print,btable
print,nrg
print,dnrg



;phi = (dindgen(nphi)+.5)*360d/nphi
phi = reform(dindgen(mode,nphi)+.5)*360d/nphi/mode
dphi = 360d/nphi + phi*0
tgeom = dtheta / 360.
egeom = nrg *0 +1
gf = 0.001176d*2   ; geometric factor for a 360 degree analyzer.
s={inst:'SST', name:name,q:q, mass:mass, nrg:nrg, dnrg:dnrg, $
   phi:phi,  dphi:dphi, theta:theta, dtheta:dtheta, $
   tgeom:tgeom, egeom:egeom, gf:gf, dt:3./nnrg/nphi, $
   mom_shift:mom_shift, $
   mode:mode,  btable:btable, e_cal:e_cal}

return,s
end


